SystemOrganization addCategory: #'BehaviorMockup-Actions'!
SystemOrganization addCategory: #'BehaviorMockup-Actions Tests'!
SystemOrganization addCategory: #'BehaviorMockup-Constraints'!
SystemOrganization addCategory: #'BehaviorMockup-Constraints Tests'!
SystemOrganization addCategory: #'BehaviorMockup-ContextSpecs'!
SystemOrganization addCategory: #'BehaviorMockup-ContextSpecs Tests'!
SystemOrganization addCategory: #'BehaviorMockup-Core'!
SystemOrganization addCategory: #'BehaviorMockup-Core Tests'!
SystemOrganization addCategory: #'BehaviorMockup-MyAddition'!
SystemOrganization addCategory: #'BehaviorMockup-Proxy'!
SystemOrganization addCategory: #'BehaviorMockup-Proxy Tests'!
SystemOrganization addCategory: #'BehaviorMockup-SSpecDSL'!
SystemOrganization addCategory: #'BehaviorMockup-SSpecDSL Tests'!
SystemOrganization addCategory: #'BehaviorMockup-StateSpecs'!
SystemOrganization addCategory: #'BehaviorMockup-StateSpecs Tests'!
SystemOrganization addCategory: #'BehaviorMockup-UsageSpecs'!
SystemOrganization addCategory: #'BehaviorMockup-UsageSpecs Tests'!

!Point methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfFloatingComparisonWith: value delta: delta 
	^PointFloatingComparisonSpec requiredValue: value delta: delta! !

ProtoObject subclass: #Proxy
	instanceVariableNames: 'devServices helper name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy'!

!Proxy commentStamp: '<historical>' prior: 0!
This is minimal behavior for any proxy object.
It prevent inspecting and support usual printing for debuging.
It defines class  in #xxxclass method.

Concrete proxy class must specify behavior in #doesNotUnderstand: message.
And it can implement special printing capabilities in method #xxxprintProxyName.
And it can implement special inspecting (Now inspecting is prevented by empty #inspect method)!

Proxy subclass: #MockObject
	instanceVariableNames: 'behaviorSpecHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy'!

!MockObject methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	^behaviorSpecHandler evaluateMessageSend: (MessageSend 
				receiver: self
				selector: aMessage selector
				arguments: aMessage arguments)! !

!MockObject methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxbehaviorSpecHandler
	^behaviorSpecHandler! !

!MockObject methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxbehaviorSpecHandler: aBehaviorSpecHandler 
	behaviorSpecHandler := aBehaviorSpecHandler! !

!Proxy class methodsFor: 'test' stamp: 'dik 9/3/2007 17:13'!
customTest
	"
	self customTest
	"

	| p |
	self halt.
	p := Proxy named: 'This is proxy'.
	^p! !

!Proxy class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
helperObject
	^ProxyHelper! !

!Proxy class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
helperObjectFor: aProxy 
	^self helperObject for: aProxy! !

!Proxy class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
named: aString 
	^self new xxxname: aString! !

!Proxy class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
new
	^super new xxxinitialize! !

!Proxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
= anObject 
	"Answer whether the receiver and the argument represent the same object.
	If = is redefined in any subclass, consider also redefining the message hash."

	^self == anObject! !

!Proxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
== anObject
	"Answer true if the receiver and the argument are the same object (have the 
	same object pointer) and false otherwise."

	<primitive: 110>
	nil primitiveFailed! !

!Proxy methodsFor: 'specs' stamp: 'dk 16.8.07 17:18'!
asConstraint
	^Equal for: self! !

!Proxy methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
doesNotUnderstand: aMessage 
	"This message for dispatch mechanism framework"

	(devServices isActiveIn: thisContext) 
		ifTrue: [^helper evaluateMessage: aMessage].
	^self evaluateMessage: aMessage! !

!Proxy methodsFor: 'dispatching' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	nil subclassResponsibility! !

!Proxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
hash
	^self identityHash! !

!Proxy methodsFor: 'comparing' stamp: 'dk 16.8.07 17:16'!
identityHash
	"See the method comment in class Object."

	<primitive: 75>
	nil primitiveFailed! !

!Proxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNil: aBlock
	"Return the receiver if it is not nil, or evaluate the block
	and return the result if the receiver is nil."

	^self! !

!Proxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNil: nilBlock ifNotNil: notNilBlock
	"If the receiver is not nil, answer the evaluation of aBlock (with the receiver as
	 its argument if it takes one), otherwise answer nil.
	 UndefinedObject redefines this to answer the evaluation of nilBlock, and hence
	 since here the receiver is not nil answer the evaluation of notNilBlock."

	^0 == notNilBlock numArgs
		ifTrue: [notNilBlock value]
		ifFalse: [notNilBlock value: self]! !

!Proxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNotNil: aBlock
	"If the receiver is not nil, answer the evaluation of aBlock (with the receiver as
	 its argument if it takes one), otherwise answer nil.  Since the receiver is not nil,
	 answer aBlock's evaluation.  Passing the receiver to aBlock is handy for idioms
	 such as
		self toolBarSpec ifNotNil: [:spec | ...].
	UndefinedObject reimplements this to not evaluate aBlock."

	^0 == aBlock numArgs
		ifTrue: [aBlock value]
		ifFalse: [aBlock value: self]! !

!Proxy methodsFor: 'controlling' stamp: 'dk 16.8.07 17:16'!
ifNotNil: notNilBlock ifNil: nilBlock
	"If the receiver is not nil, answer the evaluation of notNilBlock (with the
	 receiver as its argument if it takes one), otherwise answer the evaluation
	 of nilBlock.  UndefinedObject redefines this to answer the evaluation of nilBlock,
	 and hence since here the receiver is not nil answer the evaluation of notNilBlock."

	^0 == notNilBlock numArgs
		ifTrue: [notNilBlock value]
		ifFalse: [notNilBlock value: self]! !

!Proxy methodsFor: 'local variables' stamp: 'dik 9/3/2007 17:09'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>

	^nil primitiveFailed ! !

!Proxy methodsFor: 'local variables' stamp: 'dik 9/3/2007 17:09'!
instVarAt: index put: anObject
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 74>

	^nil primitiveFailed! !

!Proxy methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isNil
	^false! !

!Proxy methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
notNil
	^true! !

!Proxy methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dik 9/3/2007 17:35'!
should
	^StateValidator for: self! !

!Proxy methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dik 9/3/2007 17:35'!
shouldnt
	^self should not! !

!Proxy methodsFor: 'specs' stamp: 'dk 16.8.07 17:18'!
specOfEqualityFor: anObject 
	^EqualitySpec pattern: anObject! !

!Proxy methodsFor: 'class membership' stamp: 'dk 16.8.07 17:16'!
xxxclass
	"Answer the object which is the receiver's class."

	<primitive: 111>
	nil primitiveFailed! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxdevServices
	^devServices! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxdevServices: aDevelopmentServices 
	devServices := aDevelopmentServices.
	aDevelopmentServices proxy: self! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxhelper
	^helper! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxhelper: aProxyHelper 
	helper := aProxyHelper! !

!Proxy methodsFor: 'initialize-realize' stamp: 'dk 16.8.07 17:16'!
xxxinitialize
	devServices := DevelopmentServices currentFor: self.
	helper := self xxxclass helperObjectFor: self! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxname
	^name! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
xxxname: aString 
	name := aString! !

!Proxy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
yourself! !

!BlockContext methodsFor: '*BehaviorMockup-Core-source code accessing' stamp: 'dik 9/3/2007 17:27'!
argumentNames
	^self decompile arguments collect: [:eachArgNode | eachArgNode name]! !

!BlockContext methodsFor: '*BehaviorMockup-Actions-converting' stamp: 'dk 16.8.07 17:19'!
asMockAction
	^PluggableMockAction basedOn: self! !

!BlockContext methodsFor: '*BehaviorMockup-StateSpecs-converting' stamp: 'dk 16.8.07 17:18'!
asStateSpec
	^ArbitraryStateSpec from: self! !

!BlockContext methodsFor: '*BehaviorMockup-Core-building wrappers' stamp: 'dik 9/3/2007 18:17'!
behaviorWrapperOf: aWorld 
	| requiredArgs |
	requiredArgs := OrderedCollection new.
	self argumentNames 
		do: [:eachName | requiredArgs add: (aWorld objectNamed: eachName)].
	^[self valueWithArguments: requiredArgs asArray] fixTemps! !

!BlockContext methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dk 16.8.07 17:19'!
should
	^BehaviorValidator for: self! !

!BlockContext methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dk 16.8.07 17:19'!
shouldRaise: anExeptionClass andSatisfy: aBehaviorSpec 
	self should raise: anExeptionClass andSatisfy: aBehaviorSpec! !

!BlockContext methodsFor: '*BehaviorMockup-StateSpecs-printing' stamp: 'dk 8/17/2007 17:29'!
stringForSpecValidation
	^self decompileString ! !

!Collection methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfElementContainment: anObject 
	^ElementContainmentSpec requiredElement: anObject! !

!Collection methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfElementsCount: anInteger 
	^ElementsCountSpec requiredValue: anInteger! !

TestCase subclass: #AllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!AllTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationByBinaryMessage
	| constraint constraint1 constraint2 |
	constraint1 := Object new.
	constraint2 := Object new.
	constraint := constraint1 andMatches: constraint2.
	self assert: constraint class = All.
	self assert: constraint patterns first pattern == constraint1.
	self assert: constraint patterns last pattern == constraint2! !

!AllTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed
	| firstPattern secondPattern actual constraint result state denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: (state := StateValidationFailing new).
	constraint := All new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result == state.
	firstPattern verify.
	secondPattern verify! !

!AllTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed2
	| firstPattern secondPattern actual constraint result state denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: (state := StateValidationFailing new).
	constraint := All new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result == state.
	firstPattern verify.
	secondPattern verify! !

!AllTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessful
	| firstPattern secondPattern actual constraint result denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	constraint := All new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result isSuccess.
	firstPattern verify.
	secondPattern verify! !

TestCase subclass: #AnyClassTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!AnyClassTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAsConstraint
	self assert: Any asConstraint = Any! !

!AnyClassTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testMatch
	| actual |
	actual := Mock new.
	self assert: (Any matches: actual proxy)! !

!AnyClassTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidate
	| validationState |
	validationState := Any validate: nil.
	self assert: validationState isSuccess! !

TestCase subclass: #AnyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!AnyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationByBinaryMessage
	| constraint1 constraint2 constraint |
	constraint1 := Object basicNew.
	constraint2 := Object basicNew.
	constraint := constraint1 orMatches: constraint2.
	self assert: constraint class = Any.
	self assert: constraint patterns first pattern == constraint1.
	self assert: constraint patterns last pattern == constraint2! !

!AnyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed
	| firstPattern secondPattern actual constraint result state denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	denial := Object new.
	actual := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: (state := StateValidationFailing new).
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: StateValidationFailing new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: state.
	constraint := Any new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result == state.
	firstPattern verify.
	secondPattern verify! !

!AnyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessful
	| firstPattern secondPattern actual constraint result denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	constraint := Any new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result isSuccess.
	firstPattern verify.
	secondPattern verify! !

!AnyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessful2
	| firstPattern secondPattern actual constraint result denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationFailing new.
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	constraint := Any new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result isSuccess.
	firstPattern verify.
	secondPattern verify! !

TestCase subclass: #ArbitraryStateSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ArbitraryStateSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := ArbitraryStateSpec from: [:arg | arg > 0].
	self assert: (spec basicMatches: 10).
	self deny: (spec basicMatches: -10)! !

!ArbitraryStateSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:29'!
testDescription
	| spec result |
	spec := ArbitraryStateSpec from: [:arg | arg > 0].
	result := spec description.
	self assert: result = 'should satisfy: [:arg | arg > 0]'! !

TestCase subclass: #ArithmeticValueStateSpecsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ArithmeticValueStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFloatingComparisonSpec
	| spec |
	spec := 0 specOfFloatingComparisonWith: 3 delta: 4.
	self assert: spec class = NumberFloatingComparisonSpec.
	self assert: spec requiredValue = 3.
	self assert: spec delta = 4! !

TestCase subclass: #AsynchronousCallSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs Tests'!

!AsynchronousCallSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| spec result expected |
	spec := AsynchronousCallSpec forCurrentProcess.
	result := spec initialProcess.
	expected := Processor activeProcess.
	self assert: result == expected! !

!AsynchronousCallSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateIfMessageProcessDifferFromInitial
	| spec messageSend result |
	messageSend := Object new.
	spec := AsynchronousCallSpec forCurrentProcess.
	[result := spec validate: messageSend] fork.
	Processor yield.
	self assert: result isSuccess.
	self assert: result subject == messageSend! !

!AsynchronousCallSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateIfMessageProcessIsInitial
	| spec messageSend result |
	messageSend := Object new.
	spec := AsynchronousCallSpec forCurrentProcess.
	result := spec validate: messageSend.
	self assert: result isFailing.
	self assert: result subject == messageSend.
	self assert: result class = WrongProcess! !

TestCase subclass: #BMWorldTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddMock
	| mock result world |
	world := BMWorld new.
	mock := MockObject named: 'mock'.
	world addMock: mock.
	result := world mocks asArray.
	self assert: result = (Array with: mock)! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBuildSpecification
	| mock world spec specBuilder |
	world := BMWorld new.
	mock := world createObjectNamed: 'mock1'.
	spec := Object new.
	world buildSpecification: spec
		while: [specBuilder := mock xxxbehaviorSpecHandler].
	self assert: specBuilder class = BehaviorSpecBuilder.
	self assert: specBuilder spec == spec! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreateNamedObject
	| mock result world |
	world := BMWorld new.
	mock := world createObjectNamed: 'mock1'.
	result := world mocks asArray.
	self assert: result = (Array with: mock).
	self assert: mock xxxname = 'mock1'! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreateObject
	| mock result world |
	world := BMWorld new.
	mock := world createObject.
	result := world mocks asArray.
	self assert: result = (Array with: mock).
	self assert: mock xxxname = '1'! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEvaluateBehavior
	| mock world oldHandler newHandler result |
	world := BMWorld new.
	mock := world createObject.
	oldHandler := Object new.
	newHandler := Object new.
	mock xxxbehaviorSpecHandler: oldHandler.
	world evaluateBehaviorBy: newHandler
		while: [result := mock xxxbehaviorSpecHandler].
	self assert: result == newHandler.
	self assert: mock xxxbehaviorSpecHandler == oldHandler! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEvaluateBehavior2
	| mock world oldHandler newHandler result mock2 oldHandler2 result2 |
	world := BMWorld new.
	mock := world createObject.
	oldHandler := Object new.
	newHandler := Object new.
	mock2 := world createObject.
	oldHandler2 := Object new.
	mock xxxbehaviorSpecHandler: oldHandler.
	mock2 xxxbehaviorSpecHandler: oldHandler2.
	world evaluateBehaviorBy: newHandler
		while: 
			[result := mock xxxbehaviorSpecHandler.
			result2 := mock2 xxxbehaviorSpecHandler].
	self assert: result == newHandler.
	self assert: result2 == newHandler.
	self assert: mock xxxbehaviorSpecHandler == oldHandler.
	self assert: mock2 xxxbehaviorSpecHandler == oldHandler2! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testGetNamedObject
	| mock result world |
	world := BMWorld new.
	mock := world createObjectNamed: 'mock1'.
	result := world objectNamed: 'mock1'.
	self assert: result == mock! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 8/17/2007 15:50'!
testMocksIsDictionary
	| result world mock1 mock2 |
	world := BMWorld new.
	mock1 := MockObject named: 'mock1'.
	mock2 := MockObject named: 'mock2'.
	world
		addMock: mock1;
		addMock: mock2.
	result := world mocks keys asArray.
	self assert: result = #('mock1' 'mock2').
	result := world mocks asArray.
	self assert: result = (Array with: mock1 with: mock2)! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNextObjectId
	| result world |
	world := BMWorld new.
	result := world nextObjectId.
	self assert: result = '1'.
	world addMock: (MockObject named: 'mock').
	result := world nextObjectId.
	self assert: result = '2'! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testObjects
	| result world mock1 mock2 |
	world := BMWorld new.
	mock1 := world createObject.
	mock2 := world createObject.
	result := world objects.
	self assert: result = (Array with: mock1 with: mock2)! !

!BMWorldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSpecification
	| mock world spec specValidator |
	world := BMWorld new.
	mock := world createObjectNamed: 'mock1'.
	spec := Object new.
	world validateSpecification: spec
		while: [specValidator := mock xxxbehaviorSpecHandler].
	self assert: specValidator class = MessageSendValidator.
	self assert: specValidator spec == spec! !

TestCase subclass: #BehaviorSpecAcceptanceTestCase
	instanceVariableNames: 'world mock1 mock2 spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BehaviorSpecAcceptanceTestCase class methodsFor: 'testing' stamp: 'dk 17.8.07 15:1'!
isAbstract
	^self = BehaviorSpecAcceptanceTestCase! !

!BehaviorSpecAcceptanceTestCase methodsFor: 'private' stamp: 'dk 17.8.07 15:1'!
behaviorSpecClass
	self subclassResponsibility! !

!BehaviorSpecAcceptanceTestCase methodsFor: 'running' stamp: 'dk 17.8.07 15:1'!
setUp
	world := BMWorld new.
	mock1 := world createObject.
	mock2 := world createObject.
	spec := self behaviorSpecClass of: world! !

!BehaviorSpecAcceptanceTestCase methodsFor: 'accessing' stamp: 'dk 17.8.07 15:1'!
shouldFailSpec: aBlock 
	self should: [aBlock shouldSatisfy: spec] raise: SpecFailed! !

!BehaviorSpecAcceptanceTestCase methodsFor: 'accessing' stamp: 'dk 8/17/2007 16:51'!
shouldFailSpec: aBlock with: aSpecValidationFailingClass 
	| result |
	[aBlock shouldSatisfy: spec] on: SpecFailed
		do: [:err | result := err reason].
	self assert: result class = aSpecValidationFailingClass! !

!BehaviorSpecAcceptanceTestCase methodsFor: 'accessing' stamp: 'dk 17.8.07 15:1'!
shouldntFailSpec: aBlock 
	self shouldnt: [aBlock shouldSatisfy: spec] raise: SpecFailed! !

BehaviorSpecAcceptanceTestCase subclass: #ConstraintAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!ConstraintAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:1'!
behaviorSpecClass
	^StrictBehaviorSpec! !

!ConstraintAcceptanceTests methodsFor: 'accessing' stamp: 'dk 17.8.07 15:1'!
shouldFailSpec: aBlock 
	self shouldFailSpec: aBlock with: WrongMessageArgument! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAll
	spec define: 
			[mock1 someMessage: (All of: (Satisfy for: [:arg | arg > 1])
						and: (Satisfy for: [:arg | arg < 5]))].
	self shouldntFailSpec: [mock1 someMessage: 2].
	self shouldFailSpec: [mock1 someMessage: 6]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAnd
	spec define: 
			[mock1 someMessage: ((Satisfy for: [:arg | arg > 1]) 
						andMatches: (Satisfy for: [:arg | arg < 5]))].
	self shouldntFailSpec: [mock1 someMessage: 2].
	self shouldFailSpec: [mock1 someMessage: 6]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAny
	spec define: [mock1 someMessage: (Any of: #(1 2 3))].
	self shouldntFailSpec: [mock1 someMessage: 2].
	self shouldFailSpec: [mock1 someMessage: 4]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAnyClass
	spec define: [mock1 someMessage: Any].
	self shouldntFailSpec: [mock1 someMessage: 2].
	self shouldntFailSpec: [mock1 someMessage: 'asdas']! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testKind
	spec define: [mock1 someMessage: (Kind of: Integer)].
	self shouldntFailSpec: [mock1 someMessage: 1].
	self shouldFailSpec: [mock1 someMessage: 2.0]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNot
	spec define: [mock1 someMessage: 2 notMatches].
	self shouldntFailSpec: [mock1 someMessage: 3].
	self shouldFailSpec: [mock1 someMessage: 2]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNothing
	spec define: [mock1 someMessage: (Nothing of: #(1 2 3))].
	self shouldntFailSpec: [mock1 someMessage: 4].
	self shouldFailSpec: [mock1 someMessage: 2]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testOr
	spec define: [mock1 someMessage: (2 orMatches: 3)].
	self shouldntFailSpec: [mock1 someMessage: 2].
	self shouldntFailSpec: [mock1 someMessage: 3].
	self shouldFailSpec: [mock1 someMessage: 6]! !

!ConstraintAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testSatisfy
	spec define: [mock1 someMessage: (Satisfy for: [:arg | arg = 1])].
	self shouldntFailSpec: [mock1 someMessage: 1].
	self shouldFailSpec: [mock1 someMessage: 2]! !

BehaviorSpecAcceptanceTestCase subclass: #LenientBehaviorSpecAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!LenientBehaviorSpecAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:1'!
behaviorSpecClass
	^LenientBehaviorSpec! !

!LenientBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddStrictSpec
	spec
		define: [mock1 someMessage];
		define: StrictBehaviorSpec
			by: 
				[mock1 someMessage2.
				mock2 someMessage3];
		define: [mock1 someMessage4].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage2.
			mock2 someMessage3.
			mock1 someMessage4].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage4.
			mock1 someMessage2.
			mock2 someMessage3].
	self shouldntFailSpec: 
			[mock1 someMessage4.
			mock1 someMessage2.
			mock2 someMessage3.
			mock1 someMessage].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock1 someMessage2.
			mock1 someMessage4.
			mock2 someMessage3]! !

!LenientBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAnyMessageOrder
	spec define: 
			[mock1 someMessage.
			mock2 someMessage2].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2].
	self shouldntFailSpec: 
			[mock2 someMessage2.
			mock1 someMessage]! !

BehaviorSpecAcceptanceTestCase subclass: #MessageContextSpecAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs Tests'!

!MessageContextSpecAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
behaviorSpecClass
	^StrictBehaviorSpec! !

!MessageContextSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldBeAsynchronousIfMessageInInitialProcess
	spec define: [mock1 someMessage shouldBeAsynchronous].
	self shouldFailSpec: [mock1 someMessage] with: WrongProcess! !

!MessageContextSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldBeAsynchronousIfMessageInOtherProcess
	spec define: [mock1 someMessage shouldBeAsynchronous].
	[self shouldntFailSpec: [mock1 someMessage]] fork.
	Processor yield! !

!MessageContextSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfy
	spec define: [mock1 someMessage shouldSatisfy: [true]].
	self shouldntFailSpec: [mock1 someMessage]! !

!MessageContextSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfyFailSpec
	spec define: [mock1 someMessage shouldSatisfy: [false]].
	self shouldFailSpec: [mock1 someMessage] with: WrongCondition! !

BehaviorSpecAcceptanceTestCase subclass: #MessageUsageSpecAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs Tests'!

!MessageUsageSpecAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
behaviorSpecClass
	^StrictBehaviorSpec! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseArbitrarily
	spec define: 
			[mock1 someMessage useArbitrarily.
			mock2 someMessage2].
	self shouldntFailSpec: [mock2 someMessage2].
	self shouldntFailSpec: 
			[mock2 someMessage2.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock2 someMessage2.
			mock1 someMessage.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock1 someMessage]
		with: MessageSendNotHappen! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseArbitrarilyButTwice
	spec define: 
			[(mock1 someMessage)
				useArbitrarily;
				useTwice.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: MessageSendNotHappen.
	self shouldFailSpec: 
			[mock2 someMessage2.
			mock1 someMessage]
		with: MessageSendNotHappen.
	self shouldntFailSpec: 
			[mock2 someMessage2.
			mock1 someMessage.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage.
			mock2 someMessage2]! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseAtLeast
	spec define: 
			[mock1 someMessage useAtLeast: 2.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: WrongMessageReceiver.
	self shouldFailSpec: [mock1 someMessage2] with: WrongMessageSelector.
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2]
		with: MessageSendNotHappen.
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage.
			mock1 someMessage]! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseAtLeastAndAtMost
	spec define: 
			[mock1 someMessage useAtLeast: 2 atMost: 3.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: WrongMessageReceiver.
	self shouldFailSpec: [mock1 someMessage2] with: WrongMessageSelector.
	self shouldFailSpec: [mock1 someMessage] with: MessageSendNotHappen.
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2]
		with: MessageSendNotHappen.
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage.
			mock2 someMessage2].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock1 someMessage.
			mock2 someMessage2.
			mock1
				someMessage;
				someMessage]
		with: UsageLimitExceeded! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseAtMost
	spec define: 
			[mock1 someMessage useAtMost: 2.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: WrongMessageReceiver.
	self shouldFailSpec: [mock1 someMessage2] with: WrongMessageSelector.
	self shouldFailSpec: [mock1 someMessage] with: MessageSendNotHappen.
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1
				someMessage;
				someMessage]
		with: UsageLimitExceeded.
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1
				someMessage;
				someMessage2]
		with: WrongMessageSelector! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseOnce
	spec define: 
			[mock1 someMessage useOnce.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: WrongMessageReceiver.
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage]
		with: UsageLimitExceeded! !

!MessageUsageSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUseTwice
	spec define: 
			[mock1 someMessage useTwice.
			mock2 someMessage2].
	self shouldFailSpec: [mock2 someMessage2] with: WrongMessageReceiver.
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2]
		with: MessageSendNotHappen.
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage].
	self shouldntFailSpec: 
			[mock1
				someMessage;
				someMessage.
			mock2 someMessage2].
	self shouldFailSpec: 
			[mock1
				someMessage;
				someMessage.
			mock2 someMessage2.
			mock1 someMessage]
		with: UsageLimitExceeded.
	self shouldFailSpec: 
			[mock1
				someMessage;
				someMessage;
				someMessage.
			mock2 someMessage2]
		with: WrongMessageReceiver! !

BehaviorSpecAcceptanceTestCase subclass: #MockActionAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!MockActionAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
behaviorSpecClass
	^StrictBehaviorSpec! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillBlockWithArgs
	| result |
	spec define: [(mock1 someMessage: 2 and: 3) will: [:a1 :a2 | a1 + a2]].
	self shouldntFailSpec: [result := mock1 someMessage: 2 and: 3].
	self assert: result = 5! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillBlockWithoutArgs
	| result |
	spec define: [mock1 someMessage will: [true]].
	self shouldntFailSpec: [result := mock1 someMessage].
	self assert: result! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillProcessBlocking
	| result blocking |
	result := false.
	blocking := ProcessBlocking singleLock.
	spec define: 
			[(mock1 someMessage)
				will: blocking;
				willReturn: true].
	[self shouldntFailSpec: 
			[result := mock1 someMessage.
			true]] fork.
	self deny: result.
	blocking unlock.
	self assert: result! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillProcessBlocking2
	| result blocking |
	result := false.
	blocking := ProcessBlocking singleLock.
	spec define: 
			[mock1 someMessage will: blocking.
			mock1 someMessage2 willReturn: true].
	self shouldntFailSpec: 
			[
			[mock1 someMessage.
			result := mock1 someMessage2.
			true] fork.
			blocking unlock].
	self assert: result! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillRaise
	spec define: [mock1 someMessage willRaise: ZeroDivide].
	self shouldntFailSpec: [self should: [mock1 someMessage] raise: ZeroDivide]! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillReturn
	| result |
	spec define: [mock1 someMessage willReturn: 'answer'].
	self shouldntFailSpec: [result := mock1 someMessage].
	self assert: result = 'answer'! !

!MockActionAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testWillReturnYourself
	| result |
	spec define: [mock1 someMessage willReturnYourself].
	self shouldntFailSpec: [result := mock1 someMessage].
	self assert: result == mock1! !

BehaviorSpecAcceptanceTestCase subclass: #StrictBehaviorSpecAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!StrictBehaviorSpecAcceptanceTests methodsFor: 'private' stamp: 'dk 17.8.07 15:1'!
behaviorSpecClass
	^StrictBehaviorSpec! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddLenientSpec
	spec
		define: [mock1 someMessage];
		define: LenientBehaviorSpec
			by: 
				[mock2 someMessage2.
				mock1 someMessage3];
		define: [mock2 someMessage4].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2.
			mock1 someMessage3.
			mock2 someMessage4].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock1 someMessage3.
			mock2 someMessage2.
			mock2 someMessage4]! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArgumentConstraintIsMockObject
	spec define: [mock1 someMessage: mock2].
	self shouldntFailSpec: [mock1 someMessage: mock2]! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArgumentsMatches
	spec define: [mock1 someMessage: 'arg'].
	self shouldntFailSpec: [mock1 someMessage: 'arg']! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCorrectMessageOrder
	spec define: 
			[mock1 someMessage.
			mock2 someMessage2].
	self shouldntFailSpec: 
			[mock1 someMessage.
			mock2 someMessage2]! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testMessageReturnNilIfNoActions
	| result |
	spec define: [mock1 someMessage].
	self shouldntFailSpec: [result := mock1 someMessage].
	self assert: result isNil! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testMessageSendNotHappen
	spec define: [mock1 someMessage].
	self shouldFailSpec: [] with: MessageSendNotHappen! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotCorrectMessageOrder
	spec define: 
			[mock1 someMessage.
			mock2 someMessage2].
	self 
		should: [
			[mock2 someMessage2.
			mock1 someMessage] shouldSatisfy: spec]
		raise: SpecFailed! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testTooManyMessageSends
	spec define: [mock1 someMessage].
	self shouldFailSpec: 
			[mock1 someMessage.
			mock2 someMessage]
		with: TooManyMessageSends! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testWrongMessageArgument
	spec define: [mock1 someMessage: 'arg'].
	self shouldFailSpec: [mock1 someMessage: 'wrong arg']
		with: WrongMessageArgument! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testWrongMessageReceiver
	spec define: [mock1 someMessage].
	self shouldFailSpec: [mock2 someMessage] with: WrongMessageReceiver! !

!StrictBehaviorSpecAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testWrongMessageSelector
	spec define: [mock1 someMessage].
	self shouldFailSpec: [mock1 someMessage2] with: WrongMessageSelector! !

TestCase subclass: #BehaviorSpecBuilderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BehaviorSpecBuilderTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| spec builder result |
	spec := Object new.
	builder := BehaviorSpecBuilder on: spec.
	result := builder spec.
	self assert: result == spec! !

!BehaviorSpecBuilderTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEvaluateMessageSend
	| spec builder messageSend result contextSpec receiver constraint arg semanticsSpec |
	spec := Mock new.
	receiver := Object new.
	constraint := Object new.
	arg := Mock new.
	messageSend := MessageSend 
				receiver: receiver
				selector: #selector
				argument: arg proxy.
	(spec expect: #add:) with: 
			[:arg2 | 
			contextSpec := arg2.
			true].
	(arg expect: #asConstraint) returns: constraint.
	builder := BehaviorSpecBuilder on: spec proxy.
	result := builder evaluateMessageSend: messageSend.
	self assert: contextSpec class = MessageSendSpec.
	semanticsSpec := contextSpec contents first.
	self assert: semanticsSpec class == MessageSemanticsSpec.
	self assert: semanticsSpec receiver == receiver.
	self assert: semanticsSpec selector == #selector.
	self assert: semanticsSpec argumentConstraints first == constraint.
	self assert: result class = MessageSendSpecBuilder.
	self assert: result spec == contextSpec.
	spec verify.
	arg verify! !

TestCase subclass: #BehaviorSpecBuilderTests2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-MyAddition'!

!BehaviorSpecBuilderTests2 methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 14:16'!
testEvaluateIgnoreMessagesSend
	| spec builder messageSend result contextSpec receiver semanticsSpec |
	spec := Mock new.
	receiver := Object new.
	messageSend := MessageSend 
				receiver: receiver
				selector: #ignoreMessages.
	(spec expect: #add:) with: 
			[:arg | 
			contextSpec := arg.
			true].
	builder := BehaviorSpecBuilder on: spec proxy.
	result := builder evaluateMessageSend: messageSend.
	self assert: contextSpec class = MessageSendSpec.
	semanticsSpec := contextSpec contents first.
	self assert: semanticsSpec class == IgnoreMessageSemanticsSpec.
	self assert: semanticsSpec receiver == receiver.
	"self assert: semanticsSpec selector == #selector.
	self assert: semanticsSpec argumentConstraints first == constraint."
	self assert: result class = MessageSendSpecBuilder.
	self assert: result spec == contextSpec.
	spec verify.! !

TestCase subclass: #BehaviorSpecBuildingAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BehaviorSpecBuildingAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testOneMessageSend
	| world mock spec messageSend |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	spec define: [mock someMessage].
	self assert: spec contents size = 1.
	messageSend := spec contents first contents first.
	self assert: messageSend selector = #someMessage.
	self assert: messageSend receiver == mock! !

!BehaviorSpecBuildingAcceptanceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testTwoMessageSends
	| world mock spec messageSend mock2 |
	world := BMWorld new.
	mock := world createObject.
	mock2 := world createObject.
	spec := BehaviorSpec of: world.
	spec define: 
			[mock someMessage.
			mock2 someMessage2].
	self assert: spec contents size = 2.
	messageSend := spec contents first contents first.
	self assert: messageSend selector = #someMessage.
	self assert: messageSend receiver == mock.
	messageSend := spec contents last contents first.
	self assert: messageSend selector = #someMessage2.
	self assert: messageSend receiver == mock2! !

TestCase subclass: #BehaviorSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateExpectedMessageIfSingleInnerSpec
	| spec innerSpec validation messageSend result |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	validation := Mock new.
	messageSend := Object new.
	(validation expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: true.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	spec add: innerSpec proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result == validation proxy.
	innerSpec verify.
	validation verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateExpectedMessageIfTwoInnerSpec
	| spec innerSpec validation messageSend result innerSpec2 validation2 |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	innerSpec2 := Mock new.
	validation := Mock new.
	validation2 := Mock new.
	messageSend := Object new.
	(validation expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: true.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	(validation2 expect: #isSuccess) returns: true.
	(innerSpec2 expect: #isArbitraryUsage) returns: true.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validation2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result == validation2 proxy.
	innerSpec verify.
	innerSpec2 verify.
	validation verify.
	validation2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateExpectedMessageIfTwoInnerSpec2
	| spec innerSpec validation messageSend result innerSpec2 validation2 |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	innerSpec2 := Mock new.
	validation := Mock new.
	validation2 := Mock new.
	messageSend := Object new.
	(validation expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: true.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: true.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result == validation proxy.
	innerSpec verify.
	innerSpec2 verify.
	validation verify.
	validation2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateIfNoSpecs
	| spec innerSpec messageSend result |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	spec add: innerSpec proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result class = TooManyMessageSends.
	self assert: result subject == messageSend.
	innerSpec verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateNotExpectedMessageIfSingleInnerSpec
	| spec innerSpec validation messageSend result |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	validation := Mock new.
	messageSend := Object new.
	(validation expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: true.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	spec add: innerSpec proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result == validation proxy.
	innerSpec verify.
	validation verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testArbitrarilyValidateNotExpectedMessageIfTwoInnerSpec
	| spec innerSpec validation messageSend result innerSpec2 validation2 |
	spec := BehaviorSpec new.
	innerSpec := Mock new.
	innerSpec2 := Mock new.
	validation := Mock new.
	validation2 := Mock new.
	messageSend := Object new.
	(validation expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: true.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	(validation2 expect: #isSuccess) returns: false.
	(innerSpec2 expect: #isArbitraryUsage) returns: true.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validation2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByArbitrarilyUsedSpecs: messageSend.
	self assert: result == validation2 proxy.
	innerSpec verify.
	innerSpec2 verify.
	validation verify.
	validation2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationForWorld
	| spec result world |
	world := BMWorld new.
	spec := BehaviorSpec of: world.
	result := spec world.
	self assert: result == world! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDefine
	| spec result world mock |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	spec define: [result := mock xxxbehaviorSpecHandler].
	self assert: result class = BehaviorSpecBuilder.
	self assert: result spec == spec! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDefineSpecByBlock
	| spec result world innerSpec innerSpecClass block |
	world := BMWorld new.
	spec := BehaviorSpec of: world.
	innerSpec := Mock new.
	innerSpecClass := Mock new.
	block := [].
	(innerSpec expect: #define:) with: [:arg | arg == block].
	(innerSpecClass expect: #of:)
		with: world;
		returns: innerSpec proxy.
	spec define: innerSpecClass proxy by: block.
	self assert: spec contents size = 1.
	result := spec contents first.
	self assert: result == innerSpec proxy.
	innerSpec verify.
	innerSpecClass verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDefinedByBlock
	| spec semantics |
	spec := BehaviorSpec definedBy: [:mock | mock someMessage].
	self assert: spec contents size = 1.
	semantics := spec contents first contents first.
	self assert: semantics receiver == spec world objects first.
	self assert: semantics selector = #someMessage! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:52'!
testDefinedByBlockSetCorrectMockObjectsForBlockArgs
	BehaviorSpec definedBy: 
			[:mock1 :mock2 | 
			self assert: mock1 xxxname = 'mock1'.
			self assert: mock2 xxxname = 'mock2']! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryUsage
	| spec |
	spec := BehaviorSpec new.
	self deny: spec isArbitraryUsage! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidIfOneInnerSpec
	| spec innerSpec |
	innerSpec := Mock new.
	(innerSpec expect: #isValid) returns: true.
	spec := BehaviorSpec new.
	spec add: innerSpec proxy.
	self assert: spec isValid.
	innerSpec verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidIfSpecEmpty
	| spec |
	spec := BehaviorSpec new.
	self assert: spec isValid! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidIfTwoInnerSpec
	| spec innerSpec innerSpec2 |
	innerSpec := Mock new.
	(innerSpec expect: #isValid) returns: true.
	innerSpec2 := Mock new.
	(innerSpec2 expect: #isValid) returns: true.
	spec := BehaviorSpec new.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	self assert: spec isValid.
	innerSpec verify.
	innerSpec2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfTwoInnerSpec
	| spec innerSpec innerSpec2 |
	innerSpec := Mock new.
	(innerSpec expect: #isValid) returns: true.
	innerSpec2 := Mock new.
	(innerSpec2 expect: #isValid) returns: false.
	spec := BehaviorSpec new.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	self deny: spec isValid.
	innerSpec verify.
	innerSpec2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfTwoInnerSpec2
	| spec innerSpec innerSpec2 |
	innerSpec := Mock new.
	(innerSpec expect: #isValid) returns: false.
	innerSpec2 := Mock new.
	spec := BehaviorSpec new.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	self deny: spec isValid.
	innerSpec verify.
	innerSpec2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testReset
	| spec innerSpec innerSpec2 |
	innerSpec := Mock new.
	innerSpec expect: #reset.
	innerSpec2 := Mock new.
	innerSpec2 expect: #reset.
	spec := BehaviorSpec new.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	spec reset.
	innerSpec verify.
	innerSpec2 verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateBehavior
	| spec result world mock |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	spec validateBehavior: [result := mock xxxbehaviorSpecHandler].
	self assert: result class = MessageSendValidator.
	self assert: result spec == spec! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:30'!
testValidateBehaviorFailSpecIfSomeMessageDoesntSend
	| spec world innerSpec result |
	world := BMWorld new.
	spec := BehaviorSpec of: world.
	innerSpec := Mock new.
	innerSpec expect: #reset.
	(innerSpec expect: #isValid) returns: false.
	spec add: innerSpec proxy.
	[spec validateBehavior: []] on: SpecFailed
		do: [:err | result := err reason].
	self assert: result class = MessageSendNotHappen.
	innerSpec verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:30'!
testValidateBehaviorThatRaisesExeption
	| spec result world mock |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	spec validateBehavior: 
			[result := mock xxxbehaviorSpecHandler.
			ZeroDivide new signal]
		thatShouldRaise: ZeroDivide.
	self assert: result class = MessageSendValidator.
	self assert: result spec == spec! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:33'!
testValidateBehaviorThatRaisesExeption2
	| spec world mock |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	self should: 
			[spec validateBehavior: 
					[mock xxxbehaviorSpecHandler.
					FloatingPointException signal]
				thatShouldRaise: ZeroDivide]
		raise: FloatingPointException! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateBehaviorThatRaisesExeptionFailSpecIfExeptionNotRaised
	| spec result world mock |
	world := BMWorld new.
	mock := world createObject.
	spec := BehaviorSpec of: world.
	self should: 
			[spec validateBehavior: [result := mock xxxbehaviorSpecHandler]
				thatShouldRaise: ZeroDivide]
		raise: SpecFailed! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:33'!
testValidateBehaviorThatRaisesExeptionFailSpecIfSomeMessageDoesntSend
	| spec world innerSpec result |
	world := BMWorld new.
	spec := BehaviorSpec of: world.
	innerSpec := Mock new.
	innerSpec expect: #reset.
	(innerSpec expect: #isValid) returns: false.
	spec add: innerSpec proxy.
	[spec validateBehavior: [ZeroDivide signal] thatShouldRaise: ZeroDivide] 
		on: SpecFailed
		do: [:err | result := err reason].
	self assert: result class = MessageSendNotHappen.
	innerSpec verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:55'!
testValidateWorldBehavior
	| spec world block wrapperBlock |
	world := BMWorld new.
	world createObject.
	world createObject.
	block := Mock new.
	wrapperBlock := Mock new.
	spec := BehaviorSpec of: world.
	wrapperBlock expect: #value.
	(block expect: #behaviorWrapperOf:)
		with: world;
		returns: wrapperBlock proxy.
	spec validateWorldBehavior: block proxy.
	block verify.
	wrapperBlock verify! !

!BehaviorSpecTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:59'!
testValidateWorldBehaviorThatRaisesExeption
	| spec world m1 m2 |
	world := BMWorld new.
	world createObjectNamed: 'mock1'.
	world createObjectNamed: 'mock2'.
	spec := BehaviorSpec of: world.
	spec validateWorldBehavior: 
			[:mock2 :mock1 | 
			m1 := mock1.
			m2 := mock2.
			ZeroDivide signal]
		thatShouldRaise: ZeroDivide.
	self assert: m1 xxxname = 'mock1'.
	self assert: m2 xxxname = 'mock2'! !

TestCase subclass: #BehaviorSpecValidatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BehaviorSpecValidatorTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEvaluateMessageSend
	| spec builder messageSend result validation |
	spec := Mock new.
	validation := Mock new.
	messageSend := Object new.
	(validation expect: #raise) returns: 'answer'.
	(spec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	builder := MessageSendValidator on: spec proxy.
	result := builder evaluateMessageSend: messageSend.
	self assert: result = 'answer'.
	spec verify.
	validation verify! !

TestCase subclass: #BehaviorValidatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!BehaviorValidatorTests methodsFor: 'tests fot should clauses' stamp: 'dk 17.8.07 15:2'!
testLenient
	| validator result |
	validator := BehaviorValidator new.
	result := validator lenient.
	self assert: result class = ShouldLenientClause.
	self assert: result validator == validator! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'test 9/26/2007 13:34'!
testLenientSatisfy
	| validator result |
	"self halt."
	validator := BehaviorValidator for: [:mock | result := mock someMessage].
	validator lenientSatisfy: [:mock | mock someMessage willReturn: 'answer'].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testLenientSatisfyMain
	| validator result1 result2 |
	validator := BehaviorValidator for: 
					[:mock1 :mock2 | 
					result2 := mock2 someMessage.
					result1 := mock1 someMessage].
	validator lenientSatisfy: 
			[:mock1 :mock2 | 
			mock1 someMessage willReturn: 'answer1'.
			mock2 someMessage willReturn: 'answer2'].
	self assert: result1 = 'answer1'.
	self assert: result2 = 'answer2'! !

!BehaviorValidatorTests methodsFor: 'tests fot should clauses' stamp: 'dk 17.8.07 15:2'!
testRaise
	| validator result |
	validator := BehaviorValidator new.
	result := validator raise.
	self assert: result class = ShouldRaiseClause.
	self assert: result validator == validator! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseAndLenientSatisfy
	| validator result |
	validator := BehaviorValidator for: 
					[:mock | 
					result := mock
								someMessage2;
								someMessage.
					Error new raise].
	validator raiseAndLenientSatisfy: 
			[:mock | 
			mock someMessage willReturn: 'answer'.
			mock someMessage2].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseAndSatisfyBehaviorSpec
	| block spec validator |
	block := [].
	validator := BehaviorValidator for: block.
	spec := Mock new.
	(spec expect: #validateBehavior:thatShouldRaise:)
		with: [:arg | arg == block];
		with: Error.
	validator raiseAndSatisfy: spec proxy.
	spec verify! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseAndStrictlySatisfy
	| validator result |
	validator := BehaviorValidator for: 
					[:mock | 
					result := mock
								someMessage;
								someMessage2.
					Error new raise].
	validator raiseAndStrictlySatisfy: 
			[:mock | 
			mock someMessage.
			mock someMessage2 willReturn: 'answer'].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseErrorFailed
	| validator |
	validator := BehaviorValidator for: [1 + 2].
	self should: [validator raiseError] raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseErrorSuccessful
	| validator |
	validator := BehaviorValidator for: [1 / 0].
	self shouldnt: [validator raiseError] raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 8/17/2007 17:44'!
testRaiseExeptionAndLenientSatisfy
	| validator result |
	validator := BehaviorValidator for: 
					[:mock | 
					result := mock
								someMessage2;
								someMessage.
					ZeroDivide signal].
	validator raise: ZeroDivide
		andLenientSatisfy: 
			[:mock | 
			mock someMessage willReturn: 'answer'.
			mock someMessage2].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionAndLenientSatisfyRaiseSpecFailedIfExeptionDoesntHappen
	| validator |
	validator := BehaviorValidator for: 
					[:mock | 
					mock
						someMessage2;
						someMessage].
	self should: 
			[validator raise: ZeroDivide
				andLenientSatisfy: 
					[:mock | 
					mock
						someMessage;
						someMessage2]]
		raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionAndSatisfyBehaviorSpec
	| block spec validator exp |
	block := [].
	validator := BehaviorValidator for: block.
	exp := Object new.
	spec := Mock new.
	(spec expect: #validateBehavior:thatShouldRaise:)
		with: [:arg | arg == block];
		with: exp.
	validator raise: exp andSatisfy: spec proxy.
	spec verify! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 8/17/2007 17:44'!
testRaiseExeptionAndStrictlySatisfy
	| validator result |
	validator := BehaviorValidator for: 
					[:mock | 
					result := mock
								someMessage;
								someMessage2.
					ZeroDivide signal].
	validator raise: ZeroDivide
		andStrictlySatisfy: 
			[:mock | 
			mock someMessage.
			mock someMessage2 willReturn: 'answer'].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionAndStrictlySatisfy2
	| validator |
	validator := BehaviorValidator for: 
					[:mock | 
					mock
						someMessage2;
						someMessage.
					ZeroDivide new raise].
	self should: 
			[validator raise: ZeroDivide
				andStrictlySatisfy: 
					[:mock | 
					mock someMessage.
					mock someMessage2 willReturn: 'answer']]
		raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionAndStrictlySatisfyRaiseSpecFailedIfExeptionDoesntHappen
	| validator |
	validator := BehaviorValidator for: 
					[:mock | 
					mock
						someMessage;
						someMessage2].
	self should: 
			[validator raise: ZeroDivide
				andStrictlySatisfy: 
					[:mock | 
					mock someMessage.
					mock someMessage2 willReturn: 'answer']]
		raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionFailed
	| validator |
	validator := BehaviorValidator for: [1 + 2].
	self should: [validator raise: ZeroDivide] raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRaiseExeptionSuccessful
	| validator |
	validator := BehaviorValidator for: [1 / 0].
	self shouldnt: [validator raise: ZeroDivide] raise: SpecFailed! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testSatisfy
	| block spec validator |
	block := [].
	validator := BehaviorValidator for: block.
	spec := Mock new.
	(spec expect: #validateBehavior:) with: [:arg | arg == block].
	validator satisfy: spec proxy.
	spec verify! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testSatisfyMustBeWithoutNegation
	| block spec validator |
	block := [].
	validator := BehaviorValidator for: block.
	spec := Object new.
	validator not.
	self should: [validator satisfy: spec] raise: Error! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testSatisfySpecDefinedByBlock
	| validator block specDefinitionBlock spec specClass |
	block := Object new.
	specDefinitionBlock := Object new.
	spec := Mock new.
	specClass := Mock new.
	(spec expect: #validateWorldBehavior:) with: block.
	(specClass expect: #definedBy:)
		with: specDefinitionBlock;
		returns: spec proxy.
	validator := BehaviorValidator for: block.
	validator satisfySpec: specClass proxy definedBy: specDefinitionBlock.
	specClass verify.
	spec verify! !

!BehaviorValidatorTests methodsFor: 'tests fot should clauses' stamp: 'dk 17.8.07 15:2'!
testStrictly
	| validator result |
	validator := BehaviorValidator new.
	result := validator strictly.
	self assert: result class = ShouldStrictlyClause.
	self assert: result validator == validator! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testStrictlySatisfy
	| validator result |
	validator := BehaviorValidator for: [:mock | result := mock someMessage].
	validator strictlySatisfy: [:mock | mock someMessage willReturn: 'answer'].
	self assert: result = 'answer'! !

!BehaviorValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testStrictlySatisfyMain
	| validator result1 result2 |
	validator := BehaviorValidator for: 
					[:mock1 :mock2 | 
					result1 := mock1 someMessage.
					result2 := mock2 someMessage].
	validator strictlySatisfy: 
			[:mock1 :mock2 | 
			mock1 someMessage willReturn: 'answer1'.
			mock2 someMessage willReturn: 'answer2'].
	self assert: result1 = 'answer1'.
	self assert: result2 = 'answer2'! !

TestCase subclass: #BlockContextShouldTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!BlockContextShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShould
	| subject behaviorValidator |
	subject := ['block'].
	behaviorValidator := subject should.
	self assert: behaviorValidator class = BehaviorValidator.
	self assert: behaviorValidator subject == subject! !

!BlockContextShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldRaiseExeptionAndSatisfySpec
	| block spec exp |
	block := [].
	spec := Mock new.
	exp := Object new.
	(spec expect: #validateBehavior:thatShouldRaise:)
		with: [:arg | arg == block];
		with: exp.
	block shouldRaise: exp andSatisfy: spec proxy.
	spec verify! !

!BlockContextShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfy
	| block spec |
	block := [].
	spec := Mock new.
	(spec expect: #validateBehavior:) with: [:arg | arg == block].
	block shouldSatisfy: spec proxy.
	spec verify! !

TestCase subclass: #BlockContextSourceCodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BlockContextSourceCodeTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:20'!
testArgumentNames
	| result |
	result := [:nameA :nameB | ] argumentNames.
	self assert: result = #('nameA' 'nameB')! !

!BlockContextSourceCodeTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:20'!
testArgumentNamesIfTwoBlocksWithEqualCode
	| result |
	result := [:nameA :nameB | ] argumentNames.
	self assert: result = #('nameA' 'nameB').
	result := [:nameC :nameD | ] argumentNames.
	self assert: result = #('nameC' 'nameD')! !

TestCase subclass: #BlockContextWrapperTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!BlockContextWrapperTests methodsFor: 'tests' stamp: 'dik 3.9.07 17:38'!
testPassRequiredArgsCount
	| world wrapperBlock evaluated |
	world := BMWorld new.
	world createObjectNamed: 'mockA'.
	world createObjectNamed: 'mockB'.
	wrapperBlock := 
			[:mockB | 
			evaluated := true.
			self assert: mockB xxxname = 'mockB'] 
					behaviorWrapperOf: world.
	wrapperBlock value.
	self assert: evaluated! !

!BlockContextWrapperTests methodsFor: 'tests' stamp: 'dik 3.9.07 17:38'!
testPassRequiredArgsCount2
	| world wrapperBlock evaluated |
	world := BMWorld new.
	world createObjectNamed: 'mockA'.
	world createObjectNamed: 'mockB'.
	wrapperBlock := 
			[:mockA | 
			evaluated := true.
			self assert: mockA xxxname = 'mockA'] 
					behaviorWrapperOf: world.
	wrapperBlock value.
	self assert: evaluated! !

!BlockContextWrapperTests methodsFor: 'tests' stamp: 'dik 3.9.07 17:38'!
testPassRightOrderedArgs
	| world wrapperBlock evaluated |
	world := BMWorld new.
	world createObjectNamed: 'mockA'.
	world createObjectNamed: 'mockB'.
	wrapperBlock := 
			[:mockA :mockB | 
			evaluated := true.
			self assert: mockA xxxname = 'mockA'.
			self assert: mockB xxxname = 'mockB'] 
					behaviorWrapperOf: world.
	wrapperBlock value.
	self assert: evaluated! !

!BlockContextWrapperTests methodsFor: 'tests' stamp: 'dik 3.9.07 17:38'!
testPassRightOrderedArgs2
	| world wrapperBlock evaluated |
	world := BMWorld new.
	world createObjectNamed: 'mockA'.
	world createObjectNamed: 'mockB'.
	wrapperBlock := 
			[:mockB :mockA | 
			evaluated := true.
			self assert: mockA xxxname = 'mockA'.
			self assert: mockB xxxname = 'mockB'] 
					behaviorWrapperOf: world.
	wrapperBlock value.
	self assert: evaluated! !

!BlockContextWrapperTests methodsFor: 'tests' stamp: 'dik 3.9.07 17:38'!
testRaiseErrorIfNoMocksForArgs
	| world |
	world := BMWorld new.
	world createObjectNamed: 'mockA'.
	world createObjectNamed: 'mockB'.
	self should: [[:mockC | ] behaviorWrapperOf: world] raise: Error! !

TestCase subclass: #ClassSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ClassSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := ClassSpec for: SmallInteger.
	self assert: (spec basicMatches: 10).
	self deny: (spec basicMatches: 10.0)! !

!ClassSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := ClassSpec for: SmallInteger.
	result := spec description.
	self assert: result = 'should be an instance of SmallInteger'! !

TestCase subclass: #CollectionStateSpecsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!CollectionStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testElementContainmentSpec
	| subject spec element |
	subject := Collection new.
	element := Object new.
	spec := subject specOfElementContainment: element.
	self assert: spec class = ElementContainmentSpec.
	self assert: spec requiredElement == element! !

!CollectionStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testElementsCountSpec
	| subject spec |
	subject := Collection new.
	spec := subject specOfElementsCount: 10.
	self assert: spec class = ElementsCountSpec.
	self assert: spec requiredValue = 10! !

TestCase subclass: #ComplexConstraintTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!ComplexConstraintTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| pattern1 pattern2 constraint1 constraint2 constraint |
	pattern1 := Mock new.
	pattern2 := Mock new.
	constraint1 := Object new.
	constraint2 := Object new.
	(pattern1 expect: #asConstraint) returns: constraint1.
	(pattern2 expect: #asConstraint) returns: constraint2.
	constraint := ComplexConstraint of: pattern1 proxy and: pattern2 proxy.
	self 
		assert: constraint patterns = (Array with: constraint1 with: constraint2).
	pattern1 verify.
	pattern2 verify! !

TestCase subclass: #ComplexMessageUsageSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBeArbitrary
	| messageUsageSpec |
	messageUsageSpec := ComplexMessageUsageSpec new.
	self deny: messageUsageSpec isArbitrary.
	messageUsageSpec beArbitrary.
	self assert: messageUsageSpec isArbitrary! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryIfSpecArbitraryYourself
	| simpleUsageSpec messageUsageSpec |
	simpleUsageSpec := Mock new.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	messageUsageSpec beArbitrary.
	self assert: messageUsageSpec isArbitrary.
	simpleUsageSpec verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryIfSpecNotEmpty
	| simpleUsageSpec messageUsageSpec |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isArbitrary) returns: true.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	self assert: messageUsageSpec isArbitrary.
	simpleUsageSpec verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidAfterValidationIfSpecEmpty
	| messageSend messageUsageSpec |
	messageSend := Object new.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec validate: messageSend.
	self assert: messageUsageSpec isValid! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidIfOneInnerSpec
	| simpleUsageSpec messageUsageSpec |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isValid) returns: true.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	self assert: messageUsageSpec isValid.
	simpleUsageSpec verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidIfTwoInnerSpec
	| simpleUsageSpec messageUsageSpec simpleUsageSpec2 |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isValid) returns: true.
	simpleUsageSpec2 := Mock new.
	(simpleUsageSpec2 expect: #isValid) returns: true.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec
		add: simpleUsageSpec proxy;
		add: simpleUsageSpec2 proxy.
	self assert: messageUsageSpec isValid.
	simpleUsageSpec verify.
	simpleUsageSpec2 verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidWhenEmptySpecIfSpecArbitrary
	| messageUsageSpec |
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec beArbitrary.
	self assert: messageUsageSpec isValid! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotArbitraryIfSpecEmpty
	| messageUsageSpec |
	messageUsageSpec := ComplexMessageUsageSpec new.
	self deny: messageUsageSpec isArbitrary! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotArbitraryIfSpecNotEmpty
	| simpleUsageSpec messageUsageSpec |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isArbitrary) returns: false.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	self deny: messageUsageSpec isArbitrary.
	simpleUsageSpec verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfEmptySpec
	| messageUsageSpec |
	messageUsageSpec := ComplexMessageUsageSpec new.
	self deny: messageUsageSpec isValid! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfOneInnerSpec
	| simpleUsageSpec messageUsageSpec |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isValid) returns: false.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	self deny: messageUsageSpec isValid.
	simpleUsageSpec verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfTwoInnerSpec
	| simpleUsageSpec messageUsageSpec simpleUsageSpec2 |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isValid) returns: true.
	simpleUsageSpec2 := Mock new.
	(simpleUsageSpec2 expect: #isValid) returns: false.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec
		add: simpleUsageSpec proxy;
		add: simpleUsageSpec2 proxy.
	self deny: messageUsageSpec isValid.
	simpleUsageSpec verify.
	simpleUsageSpec2 verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotValidIfTwoInnerSpec2
	| simpleUsageSpec messageUsageSpec simpleUsageSpec2 |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #isValid) returns: false.
	simpleUsageSpec2 := Mock new.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec
		add: simpleUsageSpec proxy;
		add: simpleUsageSpec2 proxy.
	self deny: messageUsageSpec isValid.
	simpleUsageSpec verify.
	simpleUsageSpec2 verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testResetIfSpecEmpty
	| messageUsageSpec |
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec validate: Object new.
	self assert: messageUsageSpec isValid.
	messageUsageSpec reset.
	self deny: messageUsageSpec isValid! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testResetIfTwoInnerSpec
	| simpleUsageSpec messageUsageSpec simpleUsageSpec2 |
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #reset) returns: true.
	simpleUsageSpec2 := Mock new.
	(simpleUsageSpec2 expect: #reset) returns: true.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec
		add: simpleUsageSpec proxy;
		add: simpleUsageSpec2 proxy.
	messageUsageSpec reset.
	simpleUsageSpec verify.
	simpleUsageSpec2 verify! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateIfEmptySpec
	| messageSend messageUsageSpec result |
	messageSend := Object new.
	messageUsageSpec := ComplexMessageUsageSpec new.
	result := messageUsageSpec validate: messageSend.
	self assert: result isSuccess.
	self assert: result subject == messageSend! !

!ComplexMessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessfully
	| messageSend simpleUsageSpec messageUsageSpec result |
	messageSend := Object new.
	simpleUsageSpec := Mock new.
	(simpleUsageSpec expect: #validate:)
		with: messageSend;
		returns: BehaviorSpecValidationSuccess new.
	simpleUsageSpec expect: #incrementUsageCount.
	messageUsageSpec := ComplexMessageUsageSpec new.
	messageUsageSpec add: simpleUsageSpec proxy.
	result := messageUsageSpec validate: messageSend.
	self assert: result isSuccess.
	self assert: result subject == messageSend.
	simpleUsageSpec verify! !

TestCase subclass: #ComplexSpecificationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!ComplexSpecificationTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddSpec
	| spec otherSpec result |
	spec := ComplexSpecification new.
	otherSpec := Object new.
	spec add: otherSpec.
	result := spec contents asArray.
	self assert: result = (Array with: otherSpec)! !

!ComplexSpecificationTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsEmpty
	| spec |
	spec := ComplexSpecification new.
	self assert: spec isEmpty! !

!ComplexSpecificationTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotEmpty
	| spec otherSpec |
	spec := ComplexSpecification new.
	otherSpec := Object new.
	spec add: otherSpec.
	self deny: spec isEmpty! !

TestCase subclass: #ConditionSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs Tests'!

!ConditionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| condition spec result |
	condition := [true].
	spec := ConditionSpec from: condition.
	result := spec condition.
	self assert: result == condition! !

!ConditionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateIfConditionFalse
	| spec messageSend condition result |
	messageSend := Object new.
	condition := [false].
	spec := ConditionSpec from: condition.
	result := spec validate: messageSend.
	self assert: result isFailing.
	self assert: result subject == messageSend.
	self assert: result class = WrongCondition.
	self assert: result expectedCondition == condition! !

!ConditionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateIfConditionTrue
	| spec messageSend result |
	messageSend := Object new.
	spec := ConditionSpec from: [true].
	result := spec validate: messageSend.
	self assert: result isSuccess.
	self assert: result subject == messageSend! !

TestCase subclass: #ConstraintTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!ConstraintTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAsConstraint
	| constraint |
	constraint := Constraint new.
	self assert: constraint asConstraint == constraint! !

!ConstraintTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDenialDefault
	| constraint |
	constraint := Constraint new.
	self deny: constraint denial! !

TestCase subclass: #DevelopmentServicesTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy Tests'!

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationWithClasses
	| services result |
	services := DevelopmentServices onClasses: #('class1' 'class2').
	result := services classes.
	self assert: result = #('class1' 'class2')! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationWithProxy
	| proxy services result |
	proxy := Proxy new.
	services := DevelopmentServices for: proxy.
	result := services proxy.
	self assert: result == proxy! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCurrent
	| services result expected |
	services := DevelopmentServices current.
	self assert: services class = DevelopmentServices.
	result := services classes asArray.
	expected := DevelopmentServices currentSystemClasses asArray.
	self assert: result = expected! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCurrentForConcreteProxy
	| services proxy result |
	proxy := Proxy new.
	services := DevelopmentServices currentFor: proxy.
	result := services proxy.
	self assert: result == proxy! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFindProxyClientContext
	| services result proxy currentContext proxyClientContext |
	proxy := Object new.
	services := DevelopmentServices for: proxy.
	currentContext := Mock new.
	proxyClientContext := Mock new.
	(proxyClientContext expect: #receiver) returns: false.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: proxyClientContext proxy.
	result := services findProxyClientContextIn: currentContext proxy.
	self assert: result == proxyClientContext proxy.
	currentContext verify.
	proxyClientContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFindProxyClientContextIfSomeSendersNotProxy
	| services result proxy currentContext proxyClientContext senderContext |
	proxy := Object new.
	services := DevelopmentServices for: proxy.
	currentContext := Mock new.
	senderContext := Mock new.
	proxyClientContext := Mock new.
	(proxyClientContext expect: #receiver) returns: false.
	(senderContext expect: #receiver) returns: proxy.
	(senderContext expect: #sender) returns: proxyClientContext proxy.
	(currentContext expect: #receiver) returns: false.
	(currentContext expect: #sender) returns: senderContext proxy.
	result := services findProxyClientContextIn: currentContext proxy.
	self assert: result == proxyClientContext proxy.
	currentContext verify.
	senderContext verify.
	proxyClientContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFindProxyClientContextIfTwoSendersIsProxy
	| services result proxy currentContext proxyClientContext senderContext |
	proxy := Object new.
	services := DevelopmentServices for: proxy.
	currentContext := Mock new.
	senderContext := Mock new.
	proxyClientContext := Mock new.
	(proxyClientContext expect: #receiver) returns: false.
	(senderContext expect: #receiver) returns: proxy.
	(senderContext expect: #sender) returns: proxyClientContext proxy.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: senderContext proxy.
	result := services findProxyClientContextIn: currentContext proxy.
	self assert: result == proxyClientContext proxy.
	currentContext verify.
	senderContext verify.
	proxyClientContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsActiveInContextIfItMoreDeeper
	| services result proxy currentContext proxyClientContext proxyClient serviceContext service |
	proxy := Object new.
	currentContext := Mock new.
	proxyClientContext := Mock new.
	proxyClient := Object new.
	serviceContext := Mock new.
	service := ByteString new.
	(serviceContext expect: #receiver) returns: service.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(proxyClientContext expect: #sender) returns: serviceContext proxy.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: proxyClientContext proxy.
	services := DevelopmentServices for: proxy.
	services add: ByteString.
	result := services isActiveIn: currentContext proxy.
	self assert: result.
	currentContext verify.
	proxyClientContext verify.
	serviceContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsActiveInContextIfReceiverClass
	| services result proxy currentContext proxyClientContext |
	proxy := Object new.
	currentContext := Mock new.
	proxyClientContext := Mock new.
	(proxyClientContext expect: #receiver) returns: Object.
	(proxyClientContext expect: #receiver) returns: Object.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: proxyClientContext proxy.
	services := DevelopmentServices for: proxy.
	services add: Object.
	result := services isActiveIn: currentContext proxy.
	self assert: result.
	currentContext verify.
	proxyClientContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsActiveInContextIfReceiverObject
	| services result proxy currentContext proxyClientContext proxyClient |
	proxy := Object new.
	currentContext := Mock new.
	proxyClientContext := Mock new.
	proxyClient := Object new.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: proxyClientContext proxy.
	services := DevelopmentServices for: proxy.
	services add: Object.
	result := services isActiveIn: currentContext proxy.
	self assert: result.
	currentContext verify.
	proxyClientContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotActiveIfNoServices
	| services currentContext |
	currentContext := Mock new.
	services := DevelopmentServices new.
	self deny: (services isActiveIn: currentContext proxy).
	currentContext verify! !

!DevelopmentServicesTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotActiveInContext
	| services result proxy currentContext proxyClientContext proxyClient |
	proxy := Object new.
	currentContext := Mock new.
	proxyClientContext := Mock new.
	proxyClient := Object new.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(proxyClientContext expect: #receiver) returns: proxyClient.
	(proxyClientContext expect: #sender) returns: nil.
	(currentContext expect: #receiver) returns: proxy.
	(currentContext expect: #sender) returns: proxyClientContext proxy.
	services := DevelopmentServices for: proxy.
	services add: String.
	result := services isActiveIn: currentContext proxy.
	self deny: result.
	currentContext verify.
	proxyClientContext verify! !

TestCase subclass: #DictionaryStateSpecsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!DictionaryStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testKeyContainmentSpec
	| subject spec key |
	subject := Dictionary new.
	key := Object new.
	spec := subject specOfKeyContainment: key.
	self assert: spec class = KeyContainmentSpec.
	self assert: spec requiredKey == key! !

TestCase subclass: #ElementContainmentSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ElementContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := ElementContainmentSpec requiredElement: 10.
	self assert: (spec basicMatches: #(10 20)).
	self deny: (spec basicMatches: #(20 40))! !

!ElementContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := ElementContainmentSpec requiredElement: '10'.
	result := spec description.
	self assert: result = 'should include ''10'''! !

TestCase subclass: #ElementsCountSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ElementsCountSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := ElementsCountSpec requiredValue: 2.
	self assert: (spec basicMatches: #(10 20)).
	self deny: (spec basicMatches: #(20 40 30))! !

!ElementsCountSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := ElementsCountSpec requiredValue: 2.
	result := spec description.
	self assert: result = 'should have 2 elements'! !

TestCase subclass: #EqualTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!EqualTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| constraint result |
	constraint := Equal for: true.
	result := constraint pattern.
	self assert: result! !

!EqualTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStateSpecForSubject
	| constraint result subject spec object |
	subject := Mock new.
	spec := Object new.
	object := Object new.
	(subject expect: #specOfEqualityFor:)
		with: object;
		returns: spec.
	constraint := Equal for: object.
	result := constraint stateSpecFor: subject proxy.
	self assert: result == spec.
	subject verify! !

!EqualTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidate
	| constraint result subject spec validationState denial object |
	subject := Mock new.
	spec := Mock new.
	validationState := Object new.
	object := Object new.
	denial := Object new.
	(spec expect: #denial:) with: denial.
	(spec expect: #validate:)
		with: [:arg | arg == subject proxy];
		returns: validationState.
	(subject expect: #specOfEqualityFor:)
		with: object;
		returns: spec proxy.
	constraint := Equal for: object.
	constraint denial: denial.
	result := constraint validate: subject proxy.
	self assert: result == validationState.
	subject verify.
	spec verify! !

TestCase subclass: #EqualitySpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!EqualitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:36'!
testDescription
	| spec result |
	spec := EqualitySpec pattern: 'some object'.
	result := spec description.
	self assert: result = 'should equal ''some object'''! !

!EqualitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:34'!
testValidateFailed
	| pattern subject spec result |
	pattern := 'Object'.
	subject := 'Other object'.
	spec := EqualitySpec pattern: pattern.
	result := spec validate: subject.
	self assert: result class = StateValidationFailing.
	self assert: result subject == subject.
	self assert: result spec == spec.
	! !

!EqualitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:39'!
testValidateFailedIfDenialSpec
	| pattern subject spec result |
	pattern := 'Object'.
	subject := pattern.
	
	spec := EqualitySpec pattern: pattern.
	spec denial: true.
	result := spec validate: subject.
	self assert: result class = StateValidationFailing.
	self assert: result subject == subject.
	self assert: result spec == spec! !

!EqualitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:38'!
testValidateSuccessful
	| pattern subject spec result |
	pattern := 'Object'.
	subject := pattern.
	
	spec := EqualitySpec pattern: pattern.
	result := spec validate: subject.
	self assert: result class = StateValidationSuccess! !

!EqualitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:35'!
testValidateSuccessfulIfDenialSpec
	| pattern subject spec result |
	pattern := 'Object'.
	subject := 'Other object'.
	spec := EqualitySpec pattern: pattern.
	spec denial: true.
	result := spec validate: subject.
	self assert: result class = StateValidationSuccess! !

TestCase subclass: #HierarchySpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!HierarchySpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := HierarchySpec for: Integer.
	self assert: (spec basicMatches: 10).
	self deny: (spec basicMatches: 10.0)! !

!HierarchySpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := HierarchySpec for: Integer.
	result := spec description.
	self assert: result = 'should be a kind of Integer'! !

TestCase subclass: #IdenticalTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!IdenticalTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| constraint result |
	constraint := Identical for: true.
	result := constraint pattern.
	self assert: result! !

!IdenticalTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStateSpecForSubject
	| constraint result subject spec object |
	subject := Mock new.
	spec := Object new.
	object := Object new.
	(subject expect: #specOfIdentityFor:)
		with: object;
		returns: spec.
	constraint := Identical for: object.
	result := constraint stateSpecFor: subject proxy.
	self assert: result == spec.
	subject verify! !

TestCase subclass: #IdentitySpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!IdentitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:36'!
testBasicMatches
	| pattern spec |
	pattern := 'some object'.
	spec := IdentitySpec pattern: pattern.
	self assert: (spec basicMatches: pattern).
	self deny: (spec basicMatches: 'other object')! !

!IdentitySpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:35'!
testDescription
	| spec result |
	spec := IdentitySpec pattern: 'some object'.
	result := spec description.
	self assert: result = 'should be ''some object'''! !

TestCase subclass: #IgnoreMessageSemanticsSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-MyAddition'!

!IgnoreMessageSemanticsSpecTests methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 03:04'!
testFailsWithWrongReceiver
	| messageSend result actualMessageSend arg receiver1 receiver2 |
	receiver1 := 'receiver1'.
	receiver2 := 'receiver2'.
	arg := Object new.
	messageSend := IgnoreMessageSemanticsSpec receiver: receiver1.
	actualMessageSend := MessageSend 
				receiver: receiver2
				selector: #someMessage
				argument: arg.
	result := messageSend validate: actualMessageSend.
	self assert: result isFailing.
	self assert: result subject == actualMessageSend.
	self assert: result class = WrongMessageReceiver.
	self assert: result expectedReceiver = receiver1! !

!IgnoreMessageSemanticsSpecTests methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 03:03'!
testSucceedWithoutSelectorAndAnyArgs
	| receiver messageSend result actualMessageSend arg |
	receiver := 'receiver'.
	arg := Object new.
	messageSend := IgnoreMessageSemanticsSpec receiver: receiver.
	actualMessageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				argument: arg.
	result := messageSend validate: actualMessageSend.
	self assert: result isSuccess.
	self assert: result subject == actualMessageSend.! !

TestCase subclass: #IndexContainmentSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!IndexContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := IndexContainmentSpec requiredIndex: 2.
	self assert: (spec basicMatches: #(1 3)).
	self deny: (spec basicMatches: #(2))! !

!IndexContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := IndexContainmentSpec requiredIndex: 1.
	result := spec description.
	self assert: result = 'should include index 1'! !

TestCase subclass: #KeyContainmentSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!KeyContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec subject1 subject2 |
	subject1 := (Dictionary new)
				add: 1 -> 2;
				add: 3 -> 4;
				yourself.
	subject2 := (Dictionary new)
				add: 10 -> 1;
				add: 3 -> 4;
				yourself.
	spec := KeyContainmentSpec requiredKey: 1.
	self assert: (spec basicMatches: subject1).
	self deny: (spec basicMatches: subject2)! !

!KeyContainmentSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := KeyContainmentSpec requiredKey: '10'.
	result := spec description.
	self assert: result = 'should include key ''10'''! !

TestCase subclass: #KindTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!KindTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| constraint result |
	constraint := Kind of: Object.
	result := constraint requiredClass.
	self assert: result == Object! !

!KindTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStateSpecForSubject
	| constraint result subject spec |
	subject := Mock new.
	spec := Object new.
	(subject expect: #specOfHierarchy:)
		with: Object;
		returns: spec.
	constraint := Kind of: Object.
	result := constraint stateSpecFor: subject proxy.
	self assert: result == spec.
	subject verify! !

TestCase subclass: #LenientBehaviorSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testReset
	| spec innerSpec |
	innerSpec := Object new.
	spec := LenientBehaviorSpec new.
	spec activeSpec: innerSpec.
	self assert: spec activeSpec notNil.
	spec reset.
	self assert: spec activeSpec isNil! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageChooseConcreteInnerSpecForFurtherMessageValidation
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(validationState2 expect: #isSuccess) returns: true.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec
				validateByStronglyUsedSpecs: messageSend;
				validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState2 proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageChooseConcreteInnerSpecForFurtherMessageValidation2
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: false.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(validationState2 expect: #isSuccess) returns: true.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: true.
	(innerSpec2 expect: #isValid) returns: true.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec
				validateByStronglyUsedSpecs: messageSend;
				validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfOneInnerSpecIsValid
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: true.
	(validationState2 expect: #isSuccess) returns: true.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState2 proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfSingleInnerSpec
	| spec innerSpec validationState messageSend result |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	spec add: innerSpec proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfTwoInnerSpec
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(validationState2 expect: #isSuccess) returns: true.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState2 proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfTwoInnerSpec2
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateNotExpectedMessageIfAllInnerSpecsValid
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: true.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: true.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result isFailing.
	self assert: result class = TooManyMessageSends.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateNotExpectedMessageIfInnerSpecsNotValid
	| spec innerSpec validationState messageSend result innerSpec2 validationState2 |
	spec := LenientBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	innerSpec2 := Mock new.
	validationState2 := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(validationState2 expect: #isSuccess) returns: false.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState2 proxy.
	spec
		add: innerSpec proxy;
		add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify.
	innerSpec2 verify.
	validationState2 verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec failingValidation |
	spec := LenientBehaviorSpec new.
	messageSend := Object new.
	failingValidation := SpecValidationFailing new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failingValidation.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failingValidation.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == failingValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailedByTooManyMessageSends
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec failedValidation |
	spec := LenientBehaviorSpec new.
	messageSend := Object new.
	failedValidation := SpecValidationFailing new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failedValidation.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: TooManyMessageSends new.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: TooManyMessageSends new.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == failedValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateNotExpectedMessageIfSpecIsEmpty
	| spec messageSend validation |
	spec := LenientBehaviorSpec new.
	messageSend := Object new.
	validation := spec validate: messageSend.
	self assert: validation isFailing.
	self assert: validation subject == messageSend.
	self assert: validation class = TooManyMessageSends! !

!LenientBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessfully
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec successValidation |
	spec := LenientBehaviorSpec new.
	messageSend := Object new.
	successValidation := BehaviorSpecValidationSuccess new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: successValidation.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == successValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

TestCase subclass: #LimitedUsageSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs Tests'!

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| usageSpec result |
	usageSpec := LimitedUsageSpec withUsageCountBetween: 5 and: 10.
	result := usageSpec validatedUsageLimit.
	self assert: result = 5.
	result := usageSpec usageLimit.
	self assert: result = 10! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreationForSingleUsage
	| usageSpec result |
	usageSpec := LimitedUsageSpec singleUsage.
	result := usageSpec usageLimit.
	self assert: result = 1! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreationWithExactUsageLimit
	| usageSpec result |
	usageSpec := LimitedUsageSpec withExactUsageCount: 5.
	result := usageSpec validatedUsageLimit.
	self assert: result = 5.
	result := usageSpec usageLimit.
	self assert: result = 5! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsValid
	| usageSpec |
	usageSpec := LimitedUsageSpec withUsageCountBetween: 3 and: 5.
	usageSpec usageCount: 3.
	self assert: usageSpec isValid! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsValid2
	| usageSpec |
	usageSpec := LimitedUsageSpec withUsageCountBetween: 3 and: 5.
	usageSpec usageCount: 5.
	self assert: usageSpec isValid! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsValid3
	| usageSpec |
	usageSpec := LimitedUsageSpec withUsageCountBetween: 3 and: 5.
	usageSpec usageCount: 6.
	self assert: usageSpec isValid! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testNotValid
	| usageSpec |
	usageSpec := LimitedUsageSpec withUsageCountBetween: 3 and: 5.
	usageSpec usageCount: 2.
	self deny: usageSpec isValid! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateFailed
	| usageSpec result messageSend validationState |
	messageSend := Object new.
	usageSpec := LimitedUsageSpec withExactUsageCount: 5.
	usageSpec usageCount: 5.
	validationState := usageSpec validate: messageSend.
	self assert: validationState isFailing.
	self assert: validationState subject == messageSend.
	self assert: validationState class = UsageLimitExceeded.
	self assert: validationState usageLimit = 5.
	result := usageSpec usageCount.
	self assert: result = 5! !

!LimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateSuccessfully
	| usageSpec messageSend validationState |
	messageSend := Object new.
	usageSpec := LimitedUsageSpec withExactUsageCount: 5.
	usageSpec usageCount: 3.
	validationState := usageSpec validate: messageSend.
	self assert: validationState isSuccess.
	self assert: validationState subject == messageSend! !

TestCase subclass: #MessageContextSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!MessageContextSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsUsageSpec
	| spec |
	spec := MessageContextSpec new.
	self deny: spec isUsageSpec! !

TestCase subclass: #MessageSemanticsSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationFromMessageSendWithOneArg
	| messageSend spec arg constraint receiver |
	arg := Mock new.
	receiver := Object new.
	constraint := Object new.
	(arg expect: #asConstraint) returns: constraint.
	messageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				argument: arg proxy.
	spec := MessageSemanticsSpec from: messageSend.
	self assert: spec receiver == receiver.
	self assert: spec selector == #someMessage.
	self assert: spec argumentConstraints first == constraint.
	arg verify! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationFromMessageSendWithTwoArg
	| messageSend spec arg constraint receiver arg2 constraint2 |
	arg := Mock new.
	arg2 := Mock new.
	receiver := Object new.
	constraint := Object new.
	constraint2 := Object new.
	(arg expect: #asConstraint) returns: constraint.
	(arg2 expect: #asConstraint) returns: constraint2.
	messageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				arguments: (Array with: arg proxy with: arg2 proxy).
	spec := MessageSemanticsSpec from: messageSend.
	self assert: spec receiver == receiver.
	self assert: spec selector == #someMessage.
	self assert: spec argumentConstraints first == constraint.
	self assert: spec argumentConstraints last == constraint2.
	arg verify.
	arg2 verify! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDifferentArgument
	| receiver messageSendSpec result actualMessageSend argPattern arg stateValidation |
	receiver := 'receiver'.
	argPattern := Mock new.
	arg := Object new.
	(argPattern expect: #validate:)
		with: arg;
		returns: (stateValidation := StateValidationFailing new).
	messageSendSpec := MessageSemanticsSpec 
				receiver: receiver
				selector: #someMessage
				argumentConstraint: argPattern proxy.
	actualMessageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				argument: arg.
	result := messageSendSpec validate: actualMessageSend.
	self assert: result isFailing.
	self assert: result subject == actualMessageSend.
	self assert: result class = WrongMessageArgument.
	self assert: result argumentIndex = 1.
	self assert: result stateFailing == stateValidation.
	argPattern verify! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:20'!
testDifferentReceivers
	| receiver messageSend result actualMessageSend wrongReceiver |
	receiver := 'receiver'.
	wrongReceiver := receiver copy.
	messageSend := MessageSemanticsSpec  receiver: receiver selector: #someMessage.
	actualMessageSend := MessageSend receiver: wrongReceiver
				selector: #someMessage.
	result := messageSend validate: actualMessageSend.
	self assert: result isFailing.
	self assert: result subject == actualMessageSend.
	self assert: result class = WrongMessageReceiver.
	self assert: result expectedReceiver = receiver! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDifferentSelectors
	| receiver messageSend result actualMessageSend |
	receiver := 'receiver'.
	messageSend := MessageSemanticsSpec  receiver: receiver selector: #someMessage.
	actualMessageSend := MessageSend receiver: receiver selector: #wrongMessage.
	result := messageSend validate: actualMessageSend.
	self assert: result isFailing.
	self assert: result subject == actualMessageSend.
	self assert: result class = WrongMessageSelector.
	self assert: result expectedSelector = #someMessage! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEqualArguments
	| receiver messageSend result actualMessageSend argPattern arg |
	receiver := 'receiver'.
	argPattern := Mock new.
	arg := Object new.
	(argPattern expect: #validate:)
		with: arg;
		returns: StateValidationSuccess new.
	messageSend := MessageSemanticsSpec  
				receiver: receiver
				selector: #someMessage
				argumentConstraint: argPattern proxy.
	actualMessageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				argument: arg.
	result := messageSend validate: actualMessageSend.
	self assert: result isSuccess.
	self assert: result subject == actualMessageSend.
	argPattern verify! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEqualReceiverAndSelectorButWithoutArgs
	| receiver messageSend result actualMessageSend |
	receiver := 'receiver'.
	messageSend := MessageSemanticsSpec  receiver: receiver selector: #someMessage.
	actualMessageSend := MessageSend receiver: receiver selector: #someMessage.
	result := messageSend validate: actualMessageSend.
	self assert: result isSuccess.
	self assert: result subject == actualMessageSend! !

!MessageSemanticsSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testTwoDifferentArguments
	| receiver messageSend result actualMessageSend argPattern arg arg2 argPattern2 stateValidation |
	receiver := 'receiver'.
	arg := Object new.
	arg2 := Object new.
	argPattern := Mock new.
	(argPattern expect: #validate:)
		with: arg;
		returns: StateValidationSuccess new.
	argPattern2 := Mock new.
	(argPattern2 expect: #validate:)
		with: arg2;
		returns: (stateValidation := StateValidationFailing new).
	messageSend := MessageSemanticsSpec  
				receiver: receiver
				selector: #someMessage:and:
				argumentConstraints: (Array with: argPattern proxy with: argPattern2 proxy).
	actualMessageSend := MessageSend 
				receiver: receiver
				selector: #someMessage:and:
				arguments: (Array with: arg with: arg2).
	result := messageSend validate: actualMessageSend.
	self assert: result isFailing.
	self assert: result subject == actualMessageSend.
	self assert: result class = WrongMessageArgument.
	self assert: result argumentIndex = 2.
	self assert: result stateFailing == stateValidation.
	argPattern verify.
	argPattern2 verify! !

TestCase subclass: #MessageSendSpecBuilderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!MessageSendSpecBuilderTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkActionDefinedBy: buildingBlock with: checkBlock 
	self 
		checkSpecBuiltBy: #addAction:
		and: buildingBlock
		with: checkBlock! !

!MessageSendSpecBuilderTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkContextSpecBuiltBy: buildingBlock with: checkBlock 
	self 
		checkSpecBuiltBy: #add:
		and: buildingBlock
		with: checkBlock! !

!MessageSendSpecBuilderTests methodsFor: 'private' stamp: 'dk 17.8.07 15:1'!
checkSpecBuiltBy: buildingSelector and: buildingBlock with: checkBlock 
	| messageSendSpec builder |
	messageSendSpec := Mock new.
	(messageSendSpec expect: buildingSelector) with: 
			[:contextSpec | 
			checkBlock value: contextSpec.
			true].
	builder := MessageSendSpecBuilder on: messageSendSpec proxy.
	buildingBlock value: builder.
	messageSendSpec verify! !

!MessageSendSpecBuilderTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkUsageSpecBuiltBy: buildingBlock with: checkBlock 
	self 
		checkSpecBuiltBy: #addUsageSpec:
		and: buildingBlock
		with: checkBlock! !

!MessageSendSpecBuilderTests methodsFor: 'tests context specs definition' stamp: 'dk 17.8.07 15:2'!
testShouldBeAsynchronous
	self 
		checkContextSpecBuiltBy: [:definition | definition shouldBeAsynchronous]
		with: 
			[:contextSpec | 
			self assert: contextSpec class = AsynchronousCallSpec.
			self assert: contextSpec initialProcess == Processor activeProcess]! !

!MessageSendSpecBuilderTests methodsFor: 'tests context specs definition' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfy
	| condition |
	condition := [true].
	self 
		checkContextSpecBuiltBy: [:definition | definition shouldSatisfy: condition]
		with: 
			[:contextSpec | 
			self assert: contextSpec class = ConditionSpec.
			self assert: contextSpec condition == condition]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseArbitrarily
	| usageSpec messageSendSpec builder |
	usageSpec := Mock new.
	messageSendSpec := Mock new.
	usageSpec expect: #beArbitrary.
	(messageSendSpec expect: #usageSpec) returns: usageSpec proxy.
	builder := MessageSendSpecBuilder on: messageSendSpec proxy.
	builder useArbitrarily.
	messageSendSpec verify.
	usageSpec verify! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseAtLeast
	self checkUsageSpecBuiltBy: [:definition | definition useAtLeast: 10]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = UnlimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 10]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseAtLeastAndAtMost
	self 
		checkUsageSpecBuiltBy: [:definition | definition useAtLeast: 3 atMost: 10]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = LimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 3.
			self assert: usageSpec usageLimit = 10]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseAtMost
	self checkUsageSpecBuiltBy: [:definition | definition useAtMost: 10]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = LimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 1.
			self assert: usageSpec usageLimit = 10]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseExactly
	self checkUsageSpecBuiltBy: [:definition | definition useExactly: 10]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = LimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 10.
			self assert: usageSpec usageLimit = 10]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseOnce
	self checkUsageSpecBuiltBy: [:definition | definition useOnce]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = LimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 1.
			self assert: usageSpec usageLimit = 1]! !

!MessageSendSpecBuilderTests methodsFor: 'tests usage spec definition' stamp: 'dk 17.8.07 15:2'!
testUseTwice
	self checkUsageSpecBuiltBy: [:definition | definition useTwice]
		with: 
			[:usageSpec | 
			self assert: usageSpec class = LimitedUsageSpec.
			self assert: usageSpec validatedUsageLimit = 2.
			self assert: usageSpec usageLimit = 2]! !

!MessageSendSpecBuilderTests methodsFor: 'tests actions definition' stamp: 'dk 17.8.07 15:2'!
testWill
	| object |
	object := Mock new.
	(object expect: #asMockAction) returns: 'some'.
	self checkActionDefinedBy: [:definition | definition will: object proxy]
		with: [:action | self assert: action = 'some']! !

!MessageSendSpecBuilderTests methodsFor: 'tests actions definition' stamp: 'dk 17.8.07 15:2'!
testWillRaise
	self checkActionDefinedBy: [:definition | definition willRaise: Error]
		with: 
			[:action | 
			self assert: action class = RaisingExeption.
			self assert: action exeptionClass == Error]! !

!MessageSendSpecBuilderTests methodsFor: 'tests actions definition' stamp: 'dk 17.8.07 15:2'!
testWillReturn
	| answer |
	answer := Object new.
	self checkActionDefinedBy: [:definition | definition willReturn: answer]
		with: 
			[:action | 
			self assert: action class = ReturnValue.
			self assert: action value == answer]! !

!MessageSendSpecBuilderTests methodsFor: 'tests actions definition' stamp: 'dk 17.8.07 15:2'!
testWillReturnYourself
	self checkActionDefinedBy: [:definition | definition willReturnYourself]
		with: [:action | self assert: action class = ReturnReceiver]! !

TestCase subclass: #MessageSendSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddAction
	| spec action expected |
	action := Object new.
	spec := MessageSendSpec new.
	spec addAction: action.
	expected := spec actions contents asArray.
	self assert: expected = (Array with: action)! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAddUsageSpec
	| spec action expected |
	action := Object new.
	spec := MessageSendSpec new.
	spec addUsageSpec: action.
	expected := spec usageSpec contents asArray.
	self assert: expected = (Array with: action)! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreateWithEmptyActions
	| spec |
	spec := MessageSendSpec new.
	self assert: spec actions class = MockActionSequence.
	self assert: spec actions contents isEmpty! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| spec result messageSend arg receiver constraint |
	arg := Mock new.
	receiver := Object new.
	constraint := Object new.
	(arg expect: #asConstraint) returns: constraint.
	messageSend := MessageSend 
				receiver: receiver
				selector: #someMessage
				argument: arg proxy.
	spec := MessageSendSpec withMessageSemanticsLike: messageSend.
	self assert: spec contents size = 1.
	result := spec contents first.
	self assert: result class = MessageSemanticsSpec.
	self assert: result receiver == receiver.
	self assert: result selector == #someMessage.
	self assert: result argumentConstraints first == constraint! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryUsage
	| spec messageUsageSpec |
	messageUsageSpec := Mock new.
	(messageUsageSpec expect: #isArbitrary) returns: true.
	spec := MessageSendSpec new.
	spec addUsageSpec: messageUsageSpec proxy.
	self assert: spec isArbitraryUsage.
	messageUsageSpec verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryUsageDelegateMessageToUsageSpec
	| spec usageSpec |
	usageSpec := Mock new.
	(usageSpec expect: #isArbitrary) returns: true.
	spec := MessageSendSpec new.
	spec usageSpec: usageSpec proxy.
	self assert: spec isArbitraryUsage.
	usageSpec verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsArbitraryUsageIfOneSpecNotAboutUsage
	| spec messageUsageSpec messageContextSpec |
	messageContextSpec := Mock new.
	messageUsageSpec := Mock new.
	(messageUsageSpec expect: #isArbitrary) returns: true.
	spec := MessageSendSpec new.
	spec
		addUsageSpec: messageUsageSpec proxy;
		addUsageSpec: messageContextSpec proxy.
	self assert: spec isArbitraryUsage.
	messageUsageSpec verify.
	messageContextSpec verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsNotValidBeforeValidation
	| spec |
	spec := MessageSendSpec new.
	self deny: spec isValid! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsValidDelegateMessageToUsageSpec
	| spec usageSpec |
	usageSpec := Mock new.
	(usageSpec expect: #isValid) returns: true.
	spec := MessageSendSpec new.
	spec usageSpec: usageSpec proxy.
	self assert: spec isValid.
	usageSpec verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotArbitraryUsage
	| spec messageUsageSpec |
	messageUsageSpec := Mock new.
	(messageUsageSpec expect: #isArbitrary) returns: false.
	spec := MessageSendSpec new.
	spec addUsageSpec: messageUsageSpec proxy.
	self deny: spec isArbitraryUsage.
	messageUsageSpec verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testNotArbitraryUsageIfSpecEmpty
	| spec |
	spec := MessageSendSpec new.
	self deny: spec isArbitraryUsage! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testReset
	| spec usageSpec actions |
	usageSpec := Mock new.
	usageSpec expect: #reset.
	actions := Mock new.
	actions expect: #reset.
	spec := MessageSendSpec new.
	spec
		usageSpec: usageSpec proxy;
		actions: actions proxy.
	spec reset.
	usageSpec verify.
	actions verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateIfAllContextSpecValidateSuccessfully
	| spec result messageSpec messageSend validation mockActions |
	messageSpec := Mock new.
	messageSend := Object new.
	validation := Mock new.
	mockActions := Object new.
	(validation expect: #isFailing) returns: false.
	(messageSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	spec := MessageSendSpec new.
	spec add: messageSpec proxy.
	spec actions: mockActions.
	result := spec validate: messageSend.
	self assert: result isSuccess.
	self assert: result subject == messageSend.
	self assert: result actions == mockActions.
	messageSpec verify.
	validation verify! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateIfSomeContextSpecValidateFailed
	| spec result messageSpec messageSend validation |
	messageSpec := Mock new.
	messageSend := Object new.
	validation := Mock new.
	(validation expect: #isFailing) returns: true.
	(messageSpec expect: #validate:)
		with: messageSend;
		returns: validation proxy.
	spec := MessageSendSpec new.
	spec add: messageSpec proxy.
	result := spec validate: messageSend.
	self assert: result == validation proxy! !

!MessageSendSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateIfSpecEmpty
	| spec result messageSend mockActions usageSpec |
	messageSend := Object new.
	mockActions := Object new.
	usageSpec := Mock new.
	(usageSpec expect: #validate:)
		with: messageSend;
		returns: BehaviorSpecValidationSuccess new.
	spec := MessageSendSpec new.
	spec
		usageSpec: usageSpec proxy;
		actions: mockActions.
	result := spec validate: messageSend.
	self assert: result isSuccess.
	self assert: result subject == messageSend.
	self assert: result actions == mockActions.
	usageSpec verify! !

TestCase subclass: #MessageUsageSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs Tests'!

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| usageSpec result |
	usageSpec := MessageUsageSpec new.
	result := usageSpec usageCount.
	self assert: result = 0! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIncrementUsageCount
	| usageSpec result |
	usageSpec := MessageUsageSpec new.
	usageSpec usageCount: 3.
	usageSpec incrementUsageCount.
	result := usageSpec usageCount.
	self assert: result = 4! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsArbitrary
	| usageSpec |
	Object new.
	usageSpec := MessageUsageSpec new.
	usageSpec usageCount: 1.
	self assert: usageSpec isArbitrary! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsNotValid
	| usageSpec |
	usageSpec := MessageUsageSpec withValidatedUsageLimit: 5.
	usageSpec usageCount: 4.
	self deny: usageSpec isValid! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsUsageSpec
	| usageSpec |
	usageSpec := MessageUsageSpec new.
	self assert: usageSpec isUsageSpec! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsValid
	| usageSpec |
	usageSpec := MessageUsageSpec  withValidatedUsageLimit: 5.
	usageSpec usageCount: 5.
	self assert: usageSpec isValid! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIsValid2
	| usageSpec |
	usageSpec := MessageUsageSpec  withValidatedUsageLimit: 5.
	usageSpec usageCount: 6.
	self assert: usageSpec isValid! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testNotArbitrary
	| usageSpec |
	Object new.
	usageSpec := MessageUsageSpec new.
	usageSpec usageCount: 0.
	self deny: usageSpec isArbitrary! !

!MessageUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testReset
	| usageSpec result |
	usageSpec := MessageUsageSpec new.
	usageSpec usageCount: 3.
	self assert: usageSpec usageCount = 3.
	usageSpec reset.
	result := usageSpec usageCount.
	self assert: result = 0! !

TestCase subclass: #MockActionSequenceTests
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!MockActionSequenceTests methodsFor: 'running' stamp: 'dk 17.8.07 15:1'!
setUp
	actions := MockActionSequence new! !

!MockActionSequenceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testAdd
	| action1 action2 result |
	action1 := MockAction new.
	action2 := MockAction new.
	actions
		add: action1;
		add: action2.
	result := actions contents asArray.
	self assert: result = (Array with: action1 with: action2)! !

!MockActionSequenceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testExecute
	| part1 part2 act result |
	part1 := Mock new.
	part2 := Mock new.
	act := Object new.
	(part1 expect: #executeFor:) with: act.
	(part2 expect: #executeFor:)
		with: act;
		returns: true.
	actions
		add: part1 proxy;
		add: part2 proxy.
	result := actions executeFor: act.
	self assert: result.
	part1 verify.
	part2 verify! !

!MockActionSequenceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testExecuteWhenEmptyParts
	| act result |
	act := Object new.
	self shouldnt: [result := actions executeFor: act] raise: Error.
	self assert: result isNil! !

!MockActionSequenceTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testReset
	| part1 part2 |
	part1 := Mock new.
	part2 := Mock new.
	part1 expect: #reset.
	part2 expect: #reset.
	actions
		add: part1 proxy;
		add: part2 proxy.
	actions reset.
	part1 verify.
	part2 verify! !

TestCase subclass: #MockObjectTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy Tests'!

!MockObjectTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDispatchMessage
	| mock behaviorSpecHandler result |
	behaviorSpecHandler := Mock new.
	mock := MockObject new.
	(behaviorSpecHandler expect: #evaluateMessageSend:)
		with: 
				[:arg | 
				self assert: arg selector = #someMessage:.
				self assert: arg arguments = #(2).
				self assert: arg receiver == mock.
				true];
		returns: 'answer'.
	mock xxxbehaviorSpecHandler: behaviorSpecHandler proxy.
	result := mock someMessage: 2.
	self assert: result = 'answer'.
	behaviorSpecHandler verify! !

!MockObjectTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testPrintStringIfMockWithName
	| mock result services |
	mock := MockObject named: 'mock1'.
	services := DevelopmentServices new.
	mock xxxdevServices: services.
	services add: self class.
	result := mock printString.
	self assert: result = 'a MockObject(mock1)'! !

!MockObjectTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testPrintStringIfMockWithoutName
	| mock result services |
	mock := MockObject new.
	services := DevelopmentServices new.
	mock xxxdevServices: services.
	services add: self class.
	result := mock printString.
	self assert: result = 'a MockObject'! !

TestCase subclass: #NotMessageSendAcceptanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-MyAddition'!

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 16:19'!
testDoNotIgnoreMessageSendsExceeded
	self should: [
		[:mock | mock someMessage; someMessage] should lenient satisfy: 
			[:mock | 
				mock someMessage useOnce.
				mock ignoreMessages useArbitrarily.]] raise: Error.
	self should: [
		[:mock | mock someMessage; someMessage] should lenient satisfy: 
			[:mock | 
				mock ignoreMessages useArbitrarily.
				mock someMessage useOnce.]] raise: Error.! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 17:48'!
testIgnoreTooManyMessageSends
	[:mock | mock someMessage; someMessage] should lenient satisfy: 
			[:mock | 
			mock someMessage.
			mock ignoreMessages useArbitrarily.].! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 16:21'!
testIgnoresAndExpectMessageSends
	[:mock | mock someMessage] should lenient satisfy: 
		[:mock | 
			mock someMessage.
			mock ignoreMessages useArbitrarily.].
		
	[:mock | mock someMessage] should lenient satisfy: 
		[:mock | 
			mock ignoreMessages useArbitrarily.
			mock someMessage.].! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 14:22'!
testIgnoresMessageSend

	[:mock | mock someMessage] should lenient satisfy: [:mock | mock ignoreMessages].
	[:mock | mock someMessage] should strictly satisfy: [:mock | mock ignoreMessages].! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'test 9/26/2007 15:30'!
testIgnoresNoMessageSend

	[] should lenient satisfy: [:mock | "self halt." mock ignoreMessages useArbitrarily].
	"[:mock | mock someMessage] should strictly satisfy: [:mock | mock ignoreMessages. mock someMessage]."! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 18:38'!
testPositionMattersWhenStrictBehavior

	[:mock | mock message1; message2] should strictly satisfy:
		[:mock | mock message2 useArbitrarily.mock message1]
	
	"	self should: [
		[:mock | mock someMessage; someMessage] should lenient satisfy: 
			[:mock | 
				mock ignoreMessages useArbitrarily.
				mock someMessage useOnce.]] raise: Error."! !

!NotMessageSendAcceptanceTest methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 14:51'!
xtestIgnoresAndExpectMessageSends
	[:mock | mock someMessage] should lenient satisfy: 
			[:mock | 
			mock someMessage.
			mock ignoreMessages]! !

TestCase subclass: #NothingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!NothingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationByUnaryMessage
	| object1 constraint |
	object1 := Object new.
	constraint := object1 notMatches.
	self assert: constraint class = Nothing.
	self assert: constraint patterns first pattern == object1! !

!NothingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDenialDefault
	| constraint |
	constraint := Nothing new.
	self assert: constraint denial! !

!NothingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed
	| firstPattern secondPattern actual constraint result state denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: (state := StateValidationFailing new).
	constraint := Nothing new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result == state.
	firstPattern verify.
	secondPattern verify! !

!NothingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed2
	| firstPattern secondPattern actual constraint result state denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: (state := StateValidationFailing new).
	constraint := Nothing new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result == state.
	firstPattern verify.
	secondPattern verify! !

!NothingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessful
	| firstPattern secondPattern actual constraint result denial |
	firstPattern := Mock new.
	secondPattern := Mock new.
	actual := Object new.
	denial := Object new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(firstPattern expect: #denial:) with: denial.
	(firstPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	(secondPattern expect: #denial:) with: denial.
	(secondPattern expect: #validate:)
		with: actual;
		returns: StateValidationSuccess new.
	constraint := Nothing new 
				patterns: (Array with: firstPattern proxy with: secondPattern proxy).
	constraint denial: denial.
	result := constraint validate: actual.
	self assert: result isSuccess.
	firstPattern verify.
	secondPattern verify! !

TestCase subclass: #NumberFloatingComparisonSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!NumberFloatingComparisonSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := NumberFloatingComparisonSpec requiredValue: 10 delta: 2.
	self assert: (spec basicMatches: 11).
	self deny: (spec basicMatches: 12)! !

!NumberFloatingComparisonSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := NumberFloatingComparisonSpec requiredValue: 10 delta: 2.
	result := spec description.
	self assert: result = 'should be within 2 of 10'! !

TestCase subclass: #ObjectAsConstraintTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!ObjectAsConstraintTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testShouldBeConstraintEquality
	| subject result |
	subject := Object new.
	result := subject asConstraint.
	self assert: result class = Equal.
	self assert: result pattern == subject! !

TestCase subclass: #ObjectShouldTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ObjectShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShould
	| subject stateValidator |
	subject := Object new.
	stateValidator := subject should.
	self assert: stateValidator class = StateValidator.
	self assert: stateValidator subject == subject! !

!ObjectShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfyFailed
	| subject stateSpec |
	subject := Object new.
	stateSpec := Mock new.
	(stateSpec expect: #validate:)
		with: subject;
		returns: StateValidationFailing new.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	self should: [subject shouldSatisfy: stateSpec proxy] raise: SpecFailed.
	stateSpec verify! !

!ObjectShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldSatisfySuccessful
	| subject stateSpec |
	subject := Object new.
	stateSpec := Mock new.
	(stateSpec expect: #validate:)
		with: subject;
		returns: StateValidationSuccess new.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	subject shouldSatisfy: stateSpec proxy.
	stateSpec verify! !

!ObjectShouldTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testShouldnt
	| subject validator |
	subject := Object new.
	validator := subject shouldnt.
	self assert: validator subject == subject.
	self assert: validator neededNegate! !

TestCase subclass: #ObjectStateSpecsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ObjectStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testClassSpec
	| subject spec |
	subject := Object new.
	spec := subject specOfClass: Object.
	self assert: spec class = ClassSpec.
	self assert: spec requiredClass = Object! !

!ObjectStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEqualitySpec
	| subject object spec |
	subject := Object new.
	object := Object new.
	spec := subject specOfEqualityFor: object.
	self assert: spec class = EqualitySpec.
	self assert: spec pattern == object! !

!ObjectStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testHierarchySpec
	| subject spec |
	subject := Object new.
	spec := subject specOfHierarchy: Object.
	self assert: spec class = HierarchySpec.
	self assert: spec requiredClass = Object! !

!ObjectStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIdentitySpec
	| subject object spec |
	subject := Object new.
	object := Object new.
	spec := subject specOfIdentityFor: object.
	self assert: spec class = IdentitySpec.
	self assert: spec pattern == object! !

!ObjectStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testResponsibilitySpec
	| subject spec |
	subject := Object new.
	spec := subject specOfResponsibilityFor: #selector.
	self assert: spec class = ResponsibilitySpec.
	self assert: spec messageSelector == #selector! !

TestCase subclass: #PluggableMockActionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!PluggableMockActionTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| block action result |
	block := [true].
	action := PluggableMockAction basedOn: block.
	result := action block.
	self assert: result == block! !

!PluggableMockActionTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreationByBlock
	| block action result |
	block := [true].
	action := block asMockAction.
	self assert: action class = PluggableMockAction.
	result := action block.
	self assert: result == block! !

!PluggableMockActionTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecuteIfBlockWithArgs
	| block action result messageSend |
	messageSend := Mock new.
	(messageSend expect: #arguments) returns: #(1 2).
	block := Mock new.
	(block expect: #numArgs) returns: 1.
	(block expect: #valueWithArguments:)
		with: #(1 2);
		returns: true.
	action := PluggableMockAction basedOn: block proxy.
	result := action executeFor: messageSend proxy.
	self assert: result.
	messageSend verify.
	block verify! !

!PluggableMockActionTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecuteIfBlockWithoutArgs
	| block action result messageSend |
	block := [true].
	messageSend := Mock new.
	action := PluggableMockAction basedOn: block.
	result := action executeFor: messageSend proxy.
	self assert: result.
	messageSend verify! !

TestCase subclass: #PointFloatingComparisonSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!PointFloatingComparisonSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := PointFloatingComparisonSpec requiredValue: 0 @ 0 delta: 1.
	self assert: (spec basicMatches: 0.7 @ 0.7).
	self deny: (spec basicMatches: 0.8 @ 0.8)! !

!PointFloatingComparisonSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := PointFloatingComparisonSpec requiredValue: 10 @ 10 delta: 2.
	result := spec description.
	self assert: result = 'should be within 2 of 10@10'! !

TestCase subclass: #PointStateSpecs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!PointStateSpecs methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFloatingComparisonSpec
	| spec |
	spec := 0 @ 0 specOfFloatingComparisonWith: 3 @ 3 delta: 4.
	self assert: spec class = PointFloatingComparisonSpec.
	self assert: spec requiredValue = (3 @ 3).
	self assert: spec delta = 4! !

TestCase subclass: #ProcessBlockingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| blocking result |
	blocking := ProcessBlocking lockCount: 4.
	result := blocking lockCount.
	self assert: result = 4! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation2
	| blocking result |
	blocking := ProcessBlocking singleLock.
	result := blocking lockCount.
	self assert: result = 1! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecute
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 1.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	self deny: isFinished.
	blocking unlock.
	self assert: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecuteAndReset
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 1.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	Processor yield.
	blocking reset.
	self deny: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecuteAndReset2
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 1.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	Processor yield.
	blocking reset.
	self deny: isFinished.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	Processor yield.
	blocking unlock.
	self assert: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecuteIfManyLocking
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 2.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	self deny: isFinished.
	blocking unlock.
	self deny: isFinished.
	blocking unlock.
	self assert: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testFinish
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 2.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	Processor yield.
	self deny: isFinished.
	blocking finish.
	self assert: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testFinishIfUnlocksWasPerformed
	| blocking isFinished |
	isFinished := false.
	blocking := ProcessBlocking lockCount: 3.
	
	[blocking executeFor: nil.
	isFinished := true] fork.
	Processor yield.
	self deny: isFinished.
	blocking unlock.
	blocking finish.
	self assert: isFinished! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testLock
	| blocking semaphore result |
	semaphore := Mock new.
	semaphore expect: #wait.
	blocking := ProcessBlocking singleLock.
	blocking semaphore: semaphore proxy.
	blocking lock.
	result := blocking currentLockNumber.
	self assert: result = 1.
	semaphore verify! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testReset
	| blocking semaphore result |
	semaphore := Mock new.
	semaphore expect: #terminateProcess.
	blocking := ProcessBlocking singleLock.
	blocking semaphore: semaphore proxy.
	blocking
		currentUnlockNumber: 4;
		currentLockNumber: 5.
	blocking reset.
	result := blocking currentUnlockNumber.
	self assert: result = 0.
	result := blocking currentLockNumber.
	self assert: result = 0.
	self deny: blocking semaphore == semaphore proxy! !

!ProcessBlockingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testUnlock
	| blocking semaphore result |
	semaphore := Mock new.
	semaphore expect: #wait.
	semaphore expect: #signal.
	blocking := ProcessBlocking singleLock.
	blocking semaphore: semaphore proxy.
	blocking lock.
	blocking unlock.
	result := blocking currentUnlockNumber.
	self assert: result = 1.
	semaphore verify! !

TestCase subclass: #ProxyHelperTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy Tests'!

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testEvaluateMessage
	| helper selector arguments |
	helper := ProxyHelper new.
	[helper evaluateMessage: (Message selector: #someMessage: argument: 2)] 
		on: MessageNotUnderstood
		do: 
			[:err | 
			selector := err message selector.
			arguments := err message arguments].
	self assert: selector = #someMessage:.
	self assert: arguments = #(2)! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testInspect
	| helper |
	helper := ProxyHelper for: Proxy new.
	self should: [helper inspect] raise: Error! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsBlockContext
	| helper |
	helper := ProxyHelper for: Proxy new.
	self deny: helper isBlockContext! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsKindOfClass
	| helper |
	helper := ProxyHelper for: Proxy new.
	self assert: (helper isKindOf: Proxy)! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsNotKindOfClass
	| helper |
	helper := ProxyHelper for: Proxy new.
	self deny: (helper isKindOf: Object)! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testMatches
	| helper proxy |
	proxy := Proxy new.
	helper := ProxyHelper for: proxy.
	self assert: (helper matches: proxy).
	self deny: (helper matches: Proxy new)! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testPrintString
	| helper result |
	helper := ProxyHelper for: Proxy new.
	result := helper printString.
	self assert: result = 'a Proxy'! !

!ProxyHelperTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testPrintStringForNamedProxy
	| helper result |
	helper := ProxyHelper for: (Proxy named: 'proxy1').
	result := helper printString.
	self assert: result = 'a Proxy(proxy1)'! !

TestCase subclass: #ProxyShouldTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ProxyShouldTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:33'!
testShould
	| subject stateValidator |
	subject := Proxy new.
	stateValidator := subject should.
	self assert: stateValidator class = StateValidator.
	self assert: stateValidator subject == subject! !

!ProxyShouldTests methodsFor: 'tests' stamp: 'dik 9/3/2007 17:34'!
testShouldnt
	| subject validator |
	subject := Proxy new.
	validator := subject shouldnt.
	self assert: validator subject == subject.
	self assert: validator neededNegate! !

TestCase subclass: #ProxyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy Tests'!

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreationWithName
	| proxy |
	proxy := Proxy named: 'proxy'.
	self assert: proxy xxxname = 'proxy'! !

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDefaultDevServices
	| proxy result |
	proxy := Proxy new.
	result := proxy xxxdevServices.
	self assert: result class = DevelopmentServices.
	self assert: result proxy == proxy! !

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDevServices
	| services proxy result |
	services := DevelopmentServices new.
	proxy := Proxy new.
	proxy xxxdevServices: services.
	result := proxy xxxdevServices.
	self assert: result == services.
	self assert: services proxy == proxy! !

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDoesNotUnderstandDelegateMessageToHelper
	| services proxy result message helper |
	services := Mock new.
	helper := Mock new.
	message := Object new.
	proxy := Proxy new.
	(services expect: #proxy:) with: [:arg | arg == proxy].
	(services expect: #isActiveIn:)
		with: [:arg | arg class = MethodContext];
		returns: true.
	(helper expect: #evaluateMessage:)
		with: message;
		returns: 'answer'.
	proxy
		xxxdevServices: services proxy;
		xxxhelper: helper proxy.
	result := proxy doesNotUnderstand: message.
	self assert: result = 'answer'.
	services verify.
	helper verify! !

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDoesNotUnderstandMessageRaiseErrorIfServicesNotActive
	| services proxy message |
	services := Mock new.
	message := Object new.
	proxy := Proxy new.
	(services expect: #proxy:) with: [:arg | arg == proxy].
	(services expect: #isActiveIn:)
		with: [:arg | arg class = MethodContext];
		returns: false.
	proxy xxxdevServices: services proxy.
	self should: [proxy doesNotUnderstand: message] raise: Error.
	services verify! !

!ProxyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testHelperObject
	| proxy result |
	proxy := Proxy new.
	result := proxy xxxhelper.
	self assert: result class = Proxy helperObject.
	self assert: result proxy == proxy! !

!ProxyTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:1'!
testNamedProxyPrintStringIfServicesActive
	| services proxy result |
	services := DevelopmentServices new.
	proxy := Proxy named: 'p1'.
	proxy xxxdevServices: services.
	services add: self class.
	result := proxy printString.
	self assert: result = 'a Proxy(p1)'! !

!ProxyTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:1'!
testPrintStringIfServicesActive
	| services proxy result |
	services := DevelopmentServices new.
	proxy := Proxy new.
	proxy xxxdevServices: services.
	services add: self class.
	result := proxy printString.
	self assert: result = 'a Proxy'! !

!ProxyTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:1'!
testPrintStringRaiseErrorIfServicesNotActive
	| services proxy |
	services := DevelopmentServices new.
	proxy := Proxy new.
	proxy xxxdevServices: services.
	self should: [proxy printString] raise: Error! !

TestCase subclass: #RaisingExeptionSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!RaisingExeptionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := RaisingExeptionSpec requiredExeption: ZeroDivide.
	self 
		assert: (spec basicMatches: 
					[1 / 0.
					self error: 'continue']).
	self deny: (spec basicMatches: [1 + 2]).
	self should: [spec basicMatches: [#() at: 1]] raise: Error! !

!RaisingExeptionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := RaisingExeptionSpec requiredExeption: ZeroDivide.
	result := spec description.
	self assert: result = 'should raise ZeroDivide'! !

!RaisingExeptionSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:53'!
testErrorSpecFailedIfBehaviorRaiseSpecFailedExeption
	| spec |
	spec := RaisingExeptionSpec requiredExeption: Error.
	self 
		should: [spec basicMatches: [SpecFailed raiseWith: MessageSendNotHappen new]]
		raise: SpecFailed! !

!RaisingExeptionSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testFailingDescription
	| spec result state |
	spec := RaisingExeptionSpec requiredExeption: ZeroDivide.
	spec denial: true.
	state := spec validate: [1 / 0].
	result := state description.
	self assert: result = '[1 / 0] should not raise ZeroDivide'! !

TestCase subclass: #RaisingExeptionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!RaisingExeptionTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testCreation
	| raising result |
	raising := RaisingExeption of: Error.
	result := raising exeptionClass.
	self assert: result == Error! !

!RaisingExeptionTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:43'!
testExecute
	| raising exeption |
	exeption := Mock new.
	exeption expect: #signal.
	raising := RaisingExeption of: exeption proxy.
	raising executeFor: nil.
	exeption verify! !

TestCase subclass: #ResponsibilitySpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!ResponsibilitySpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testBasicMatches
	| spec |
	spec := ResponsibilitySpec for: #+.
	self assert: (spec basicMatches: 10).
	self deny: (spec basicMatches: Object new)! !

!ResponsibilitySpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec result |
	spec := ResponsibilitySpec for: #someMessage.
	result := spec description.
	self assert: result = 'should respond to #someMessage'! !

TestCase subclass: #ReturnReceiverTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!ReturnReceiverTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecute
	| receiver result action messageSend |
	action := ReturnReceiver new.
	receiver := Object new.
	messageSend := MessageSend receiver: receiver selector: #someMessage.
	result := action executeFor: messageSend.
	self assert: result == receiver! !

TestCase subclass: #ReturnValueTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions Tests'!

!ReturnValueTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testExecute
	| answer action result |
	answer := Object new.
	action := ReturnValue of: answer.
	result := action executeFor: nil.
	self assert: result == answer! !

TestCase subclass: #SSpecDSLAcceptanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!SSpecDSLAcceptanceTests commentStamp: '<historical>' prior: 0!
Additional tests in ShouldClause tests!

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dik 9/3/2007 17:17'!
customTestForArbitraryBlock

	"
	5 should satisfy: [:num | num < 0]
	"
	5 should satisfy: [:num | num > 0]! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testAncestorClass
	self shouldnt: [5 should kindOf: Integer] raise: SpecFailed.
	self should: [5.0 should kindOf: Integer] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testArbitraryBlock
	self shouldnt: [5 should satisfy: [:num | num > 0]] raise: SpecFailed.
	self should: [-5 should satisfy: [:num | num > 0]] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testDirectInstance
	self shouldnt: [5 should instanceOf: SmallInteger] raise: SpecFailed.
	self should: [-5 should instanceOf: Integer] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testElementContainment
	self shouldnt: [#(10 20) should include: 10] raise: SpecFailed.
	self should: [#(10 20) should include: 15] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testElementsCount
	self shouldnt: [#(10 20) should haveSize: 2] raise: SpecFailed.
	self should: [#(10 20) should haveSize: 3] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testIndexContainment
	self shouldnt: [#(1 3) should includeKey: 2] raise: SpecFailed.
	self should: [#(2) should includeKey: 2] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testKeyContainment
	| subject |
	subject := (Dictionary new)
				add: 1 -> 2;
				add: 3 -> 4;
				yourself.
	self shouldnt: [subject should includeKey: 1] raise: SpecFailed.
	self should: [subject should includeKey: 2] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'behavior tests' stamp: 'dik 9/3/2007 18:11'!
testMockObjectsSmartSyntaxRaiseErrorIfWrongVariableName
	self should: 
			[[:mock | mock someMessage] should strictly 
				satisfy: [:mockB :mockA | mockA someMessage]]
		raise: Error! !

!SSpecDSLAcceptanceTests methodsFor: 'behavior tests' stamp: 'dik 9/3/2007 18:11'!
testMockObjectsSmartSyntaxTotal
	[:mockA | mockA someMessage] should strictly 
		satisfy: [:mockB :mockA | mockA someMessage].
	[:mockB | mockB someMessage] should lenient 
		satisfy: [:mockB :mockA | mockB someMessage].
	self should: 
			[[:mock | mock someMessage] should strictly 
				satisfy: [:mockB :mockA | mockA someMessage]]
		raise: Error! !

!SSpecDSLAcceptanceTests methodsFor: 'behavior tests' stamp: 'dik 9/3/2007 18:11'!
testMockObjectsSmartSyntaxTotal2
	[:mockA | mockA someMessage] should strictly 
		satisfy: [:mockB :mockA | mockA someMessage].
	[:mockB | mockB someMessage] should lenient 
		satisfy: [:mockB :mockA | mockB someMessage].
	self should: 
			[[:mock | mock someMessage] should strictly 
				satisfy: [:mockB :mockA | mockA someMessage]]
		raise: Error! !

!SSpecDSLAcceptanceTests methodsFor: 'behavior tests' stamp: 'dik 9/3/2007 18:11'!
testMockObjectsSmartSyntaxWithTwoDifferentBlocks
	[:mockA | mockA someMessage] should strictly 
		satisfy: [:mockB :mockA | mockA someMessage].
	[:mockB2 | mockB2 someMessage2] should lenient 
		satisfy: [:mockB2 :mockA2 | mockB2 someMessage2]! !

!SSpecDSLAcceptanceTests methodsFor: 'behavior tests' stamp: 'dik 9/3/2007 18:11'!
testMockObjectsSmartSyntaxWithTwoEqualBlocks
	[:mockA | mockA someMessage] should strictly 
		satisfy: [:mockB :mockA | mockA someMessage].
	[:mockB | mockB someMessage] should lenient 
		satisfy: [:mockB :mockA | mockB someMessage]! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testNumberFloatingComparison
	self shouldnt: [11 should be within: 2 of: 10] raise: SpecFailed.
	self should: [11 should be within: 0.5 of: 10] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testObjectsEquality
	self shouldnt: ['some' should equal: 'some'] raise: SpecFailed.
	self should: ['some' should equal: 'other'] raise: SpecFailed.
	self shouldnt: [5 should not equal: 6] raise: SpecFailed.
	self should: [5 should not equal: 5] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 8/17/2007 17:44'!
testObjectsIdentity
	self shouldnt: [5 should be: 5] raise: SpecFailed.
	self should: ['asd' should be: 'asd' copy] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testPointFloatingComparison
	self shouldnt: [(0.7 @ 0.7) should be within: 1 of: 0 @ 0]
		raise: SpecFailed.
	self should: [(0.8 @ 0.8) should be within: 1 of: 0 @ 0] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testRaisingExeption
	self shouldnt: [[1 / 0] should raise: ZeroDivide] raise: SpecFailed.
	self should: [[1 / 3] should raise: ZeroDivide] raise: SpecFailed.
	self shouldnt: [[1 / 0] should raiseError] raise: SpecFailed.
	self should: [[1 / 3] should raiseError] raise: SpecFailed.
	self shouldnt: [[1 / 1] should not raise: ZeroDivide] raise: SpecFailed.
	self should: [[1 / 0] should not raise: ZeroDivide] raise: SpecFailed! !

!SSpecDSLAcceptanceTests methodsFor: 'state tests' stamp: 'dk 17.8.07 15:2'!
testType
	self shouldnt: [5 should respondTo: #+] raise: SpecFailed.
	self should: [Object new  should respondTo: #+] raise: SpecFailed! !

TestCase subclass: #SatisfyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints Tests'!

!SatisfyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| block constraint |
	block := [:arg | true].
	constraint := Satisfy for: block.
	self assert: constraint condition == block! !

!SatisfyTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStateSpecForSubject
	| constraint spec block |
	block := ['some block'].
	constraint := Satisfy for: block.
	spec := constraint stateSpecFor: nil.
	self assert: spec class = ArbitraryStateSpec.
	self assert: spec condition == block! !

TestCase subclass: #SequenceableCollectionStateSpecsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!SequenceableCollectionStateSpecsTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testKeyContainmentSpec
	| subject spec key |
	subject := SequenceableCollection new.
	key := Object new.
	spec := subject specOfKeyContainment: key.
	self assert: spec class = IndexContainmentSpec.
	self assert: spec requiredIndex == key! !

TestCase subclass: #ShouldHaveClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldHaveClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testLength
	| validator shouldClause |
	validator := Mock new.
	(validator expect: #haveSize:) with: 10.
	shouldClause := ShouldHaveClause of: validator proxy.
	shouldClause length: 10.
	validator verify! !

!ShouldHaveClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	self shouldnt: [#(1 3) should have size: 2] raise: SpecFailed.
	self should: [#(2) should have size: 2] raise: SpecFailed.
	self shouldnt: [#(1 3) should have length: 2] raise: SpecFailed.
	self should: [#(2) should have length: 2] raise: SpecFailed! !

!ShouldHaveClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testSize
	| validator shouldClause |
	validator := Mock new.
	(validator expect: #haveSize:) with: 10.
	shouldClause := ShouldHaveClause of: validator proxy.
	shouldClause size: 10.
	validator verify! !

TestCase subclass: #ShouldIncludeClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldIncludeClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testIndex
	| validator shouldClause key |
	validator := Mock new.
	key := Object new.
	(validator expect: #includeKey:) with: key.
	shouldClause := ShouldIncludeClause of: validator proxy.
	shouldClause index: key.
	validator verify! !

!ShouldIncludeClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testKey
	| validator shouldClause key |
	validator := Mock new.
	key := Object new.
	(validator expect: #includeKey:) with: key.
	shouldClause := ShouldIncludeClause of: validator proxy.
	shouldClause key: key.
	validator verify! !

!ShouldIncludeClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	self shouldnt: [#(1 3) should include key: 2] raise: SpecFailed.
	self should: [#(2) should include key: 2] raise: SpecFailed.
	self shouldnt: [#(1 3) should include index: 2] raise: SpecFailed.
	self should: [#(2) should include index: 2] raise: SpecFailed! !

TestCase subclass: #ShouldInstanceClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldInstanceClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	self shouldnt: [5 should be an instance of: SmallInteger] raise: SpecFailed.
	self should: [5 should be an instance of: Integer] raise: SpecFailed! !

!ShouldInstanceClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testOf
	| validator class shouldClause |
	validator := Mock new.
	class := Object new.
	(validator expect: #instanceOf:) with: class.
	shouldClause := ShouldInstanceClause of: validator proxy.
	shouldClause of: class.
	validator verify! !

TestCase subclass: #ShouldKindClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldKindClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	self shouldnt: [5 should be a kind of: Integer] raise: SpecFailed.
	self should: [5 should be a kind of: Float] raise: SpecFailed! !

!ShouldKindClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testOf
	| validator class shouldClause |
	validator := Mock new.
	class := Object new.
	(validator expect: #kindOf:) with: class.
	shouldClause := ShouldKindClause of: validator proxy.
	shouldClause of: class.
	validator verify! !

TestCase subclass: #ShouldLenientClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldLenientClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	
	[:mock | 
	self assert: mock someMessage2.
	self deny: mock someMessage] should 
		lenient satisfy: 
				[:mock | 
				mock someMessage willReturn: false.
				mock someMessage2 willReturn: true]! !

!ShouldLenientClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testSatisfy
	| validator shouldClause block |
	validator := Mock new.
	block := Object new.
	(validator expect: #lenientSatisfy:) with: block.
	shouldClause := ShouldLenientClause of: validator proxy.
	shouldClause satisfy: block.
	validator verify! !

TestCase subclass: #ShouldRaiseAndLenientClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldRaiseAndLenientClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	
	[:mock | 
	self assert: mock someMessage2.
	self deny: mock someMessage.
	Error new raise] 
			should raise 
		and lenient 
		satisfy: 
			[:mock | 
			mock someMessage willReturn: false.
			mock someMessage2 willReturn: true]! !

!ShouldRaiseAndLenientClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain2
	self should: 
			[
			[:mock | 
			self assert: mock someMessage2.
			self deny: mock someMessage] should 
				raise and 
				lenient satisfy: 
						[:mock | 
						mock someMessage willReturn: false.
						mock someMessage2 willReturn: true]]
		raise: SpecFailed! !

!ShouldRaiseAndLenientClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testSatisfy
	| validator shouldClause block |
	validator := Mock new.
	block := Object new.
	(validator expect: #raiseAndLenientSatisfy:) with: block.
	shouldClause := ShouldRaiseAndLenientClause of: validator proxy.
	shouldClause satisfy: block.
	validator verify! !

TestCase subclass: #ShouldRaiseAndStrictlyClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldRaiseAndStrictlyClauseTests methodsFor: 'acceptance tests' stamp: 'dk 8/17/2007 17:44'!
testBehaviorSpecFailedWithRightState
	
	| result |
	[
	[:mock | 
	mock
		someMessage2;
		someMessage.
	Error new raise] should 
		raise and 
		strictly satisfy: 
				[:mock | 
				mock
					someMessage;
					someMessage2]] 
			on: SpecFailed
			do: [:ex | result := ex reason].
	self assert: result class = WrongMessageSelector! !

!ShouldRaiseAndStrictlyClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	
	[:mock | 
	self deny: mock someMessage.
	self assert: mock someMessage2.
	Error new raise] 
			should raise 
		and strictly 
		satisfy: 
			[:mock | 
			mock someMessage willReturn: false.
			mock someMessage2 willReturn: true]! !

!ShouldRaiseAndStrictlyClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain2
	self should: 
			[
			[:mock | 
			self deny: mock someMessage.
			self assert: mock someMessage2] should 
				raise and 
				strictly satisfy: 
						[:mock | 
						mock someMessage willReturn: false.
						mock someMessage2 willReturn: true]]
		raise: SpecFailed! !

!ShouldRaiseAndStrictlyClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testSatisfy
	| validator shouldClause block |
	validator := Mock new.
	block := Object new.
	(validator expect: #raiseAndStrictlySatisfy:) with: block.
	shouldClause := ShouldRaiseAndStrictlyClause of: validator proxy.
	shouldClause satisfy: block.
	validator verify! !

TestCase subclass: #ShouldRaiseClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldRaiseClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testAnd
	| shouldClause |
	shouldClause := ShouldRaiseClause new.
	self assert: shouldClause and == shouldClause! !

!ShouldRaiseClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testAndSatisfy
	| validator shouldClause spec |
	validator := Mock new.
	spec := Object new.
	(validator expect: #raiseAndSatisfy:) with: spec.
	shouldClause := ShouldRaiseClause of: validator proxy.
	shouldClause and satisfy: spec.
	validator verify! !

!ShouldRaiseClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testError
	| validator shouldClause |
	validator := Mock new.
	validator expect: #raiseError.
	shouldClause := ShouldRaiseClause of: validator proxy.
	shouldClause error.
	validator verify! !

!ShouldRaiseClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testLenient
	| shouldClause validator result |
	validator := Object new.
	shouldClause := ShouldRaiseClause of: validator.
	result := shouldClause lenient.
	self assert: result class = ShouldRaiseAndLenientClause.
	self assert: result validator == validator! !

!ShouldRaiseClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMainAndSatisfy
	self shouldnt: 
			[[self error: 'asdas'] should raise and 
				satisfy: (BehaviorSpec of: BMWorld new)]
		raise: SpecFailed.
	self 
		should: [['asdas'] should raise and satisfy: (BehaviorSpec of: BMWorld new)]
		raise: SpecFailed! !

!ShouldRaiseClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMainError
	self shouldnt: [[self error: 'asdas'] should raise error] raise: SpecFailed.
	self should: [['asdas'] should raise error] raise: SpecFailed! !

!ShouldRaiseClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testStrictly
	| shouldClause validator result |
	validator := Object new.
	shouldClause := ShouldRaiseClause of: validator.
	result := shouldClause strictly.
	self assert: result class = ShouldRaiseAndStrictlyClause.
	self assert: result validator == validator! !

TestCase subclass: #ShouldRespondClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldRespondClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	self shouldnt: [5 should respond to: #+] raise: SpecFailed.
	self should: [Object new should respond to: #+] raise: SpecFailed! !

!ShouldRespondClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testTo
	| validator shouldClause |
	validator := Mock new.
	(validator expect: #respondTo:) with: #someMessage.
	shouldClause := ShouldRespondClause of: validator proxy.
	shouldClause to: #someMessage.
	validator verify! !

TestCase subclass: #ShouldStrictlyClauseTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!ShouldStrictlyClauseTests methodsFor: 'acceptance tests' stamp: 'dk 17.8.07 15:2'!
testMain
	[:mock | self assert: mock someMessage] should strictly 
		satisfy: [:mock | mock someMessage willReturn: true].
	self should: 
			[
			[:mock | 
			mock someMessage2.
			mock someMessage] should strictly 
				satisfy: 
					[:mock | 
					mock
						someMessage;
						someMessage2]]
		raise: SpecFailed! !

!ShouldStrictlyClauseTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testSatisfy
	| validator shouldClause block |
	validator := Mock new.
	block := Object new.
	(validator expect: #strictlySatisfy:) with: block.
	shouldClause := ShouldStrictlyClause of: validator proxy.
	shouldClause satisfy: block.
	validator verify! !

TestCase subclass: #SpecFailedTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!SpecFailedTests methodsFor: 'tests' stamp: 'dk 8/17/2007 18:17'!
testDefaultAction
	| validationFailing specFailed |
	specFailed := SpecFailed new.
	validationFailing := Mock new.
	(validationFailing expect: #debugSpecOver:) with: specFailed.
	specFailed reason: validationFailing proxy.
	specFailed defaultAction.	
	validationFailing verify! !

!SpecFailedTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:23'!
testDescription
	| validationFailing specFailed result expected |
	validationFailing := Mock new.
	(validationFailing expect: #description) returns: 'some'.
	specFailed := SpecFailed new.
	specFailed reason: validationFailing proxy.
	result := specFailed description.
	expected := SpecFailed name , ': some'.
	self assert: result = expected.
	validationFailing verify! !

!SpecFailedTests methodsFor: 'tests' stamp: 'dk 8/17/2007 17:53'!
testRaiseWithValidationFailing
	| validationFailing |
	validationFailing := Object new.
	self should: [SpecFailed raiseWith: validationFailing] raise: SpecFailed.
	[SpecFailed raiseWith: validationFailing] on: SpecFailed
		do: [:err | self assert: err reason == validationFailing]! !

TestCase subclass: #SpecValidationFailingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!SpecValidationFailingTests methodsFor: 'tests' stamp: 'dk 8/17/2007 18:20'!
testDebugSpecOverSpecFailedError
	| validationState specFailed |
	validationState := SpecValidationFailing new.
	specFailed := SpecFailed withReason: validationState.
	self should: [specFailed signal] raise: Error.! !

!SpecValidationFailingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| validationState result |
	validationState := SpecValidationFailing new.
	result := validationState description.
	self assert: result = SpecValidationFailing name! !

!SpecValidationFailingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsFailing
	| validationState |
	validationState := SpecValidationFailing new.
	self assert: validationState isFailing! !

!SpecValidationFailingTests methodsFor: 'tests' stamp: 'dk 8/17/2007 16:30'!
testRaise
	| validationState |
	validationState := SpecValidationFailing new.
	self should: [validationState raise] raise: SpecFailed.
	[validationState raise] on: SpecFailed
		do: [:err | self assert: err reason == validationState]! !

TestCase subclass: #SpecValidationSuccessTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!SpecValidationSuccessTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testCreation
	| messageSend validationState result actions |
	messageSend := Object new.
	actions := Object new.
	validationState := BehaviorSpecValidationSuccess for: messageSend
				withActions: actions.
	result := validationState subject.
	self assert: result == messageSend.
	result := validationState actions.
	self assert: result == actions! !

!SpecValidationSuccessTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testIsNotFailing
	| validationState |
	validationState := BehaviorSpecValidationSuccess new.
	self deny: validationState isFailing! !

!SpecValidationSuccessTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testRaise
	| messageSend validationState result actions |
	messageSend := Object new.
	actions := Mock new.
	(actions expect: #executeFor:)
		with: messageSend;
		returns: 'answer'.
	validationState := BehaviorSpecValidationSuccess for: messageSend
				withActions: actions proxy.
	result := validationState raise.
	self assert: result = 'answer'! !

TestCase subclass: #StateSpecConvertingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!StateSpecConvertingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testConvertBlockContext
	| block result |
	block := [:arg | ].
	result := block asStateSpec.
	self assert: result class = ArbitraryStateSpec.
	self assert: result condition == block! !

!StateSpecConvertingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testConvertStateSpec
	| result spec |
	spec := StateSpec new.
	result := spec asStateSpec.
	self assert: result == spec! !

TestCase subclass: #StateSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs Tests'!

!StateSpecTests methodsFor: 'tests' stamp: 'dk 8/17/2007 18:40'!
testDebugValidationFailingOverSpecFailedError
	| validationState specFailed subject spec |
	subject := Object new.
	spec := StateSpec new.
	validationState := StateValidationFailing spec: spec
				for: subject.
	specFailed := SpecFailed withReason: validationState.
	self should: [specFailed signal] raise: Error.! !

!StateSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDenialDefault
	| stateSpec |
	stateSpec := StateSpec new.
	self deny: stateSpec denial! !

!StateSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testShouldPrefixPhrase
	| stateSpec result |
	stateSpec := StateSpec new.
	result := stateSpec shouldPrefixPhrase.
	self assert: result = 'should'! !

!StateSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testShouldPrefixPhraseForDenial
	| stateSpec result |
	stateSpec := StateSpec new.
	stateSpec denial: true.
	result := stateSpec shouldPrefixPhrase.
	self assert: result = 'should not'! !

TestCase subclass: #StateValidationFailingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!StateValidationFailingTests methodsFor: 'tests' stamp: 'dk 8/17/2007 18:33'!
testDebugSpecOverSpecFailedError
	| spec subject validationState specFailed |
	specFailed := SpecFailed new. 
	spec := Mock new.
	subject := Mock new.
	(spec expect: #debugValidationFailingOver:) with: specFailed.
	validationState := StateValidationFailing spec: spec proxy
				for: subject proxy.

	specFailed reason: validationState.
	validationState debugSpecOver: specFailed.
	
	spec verify.
	subject verify! !

!StateValidationFailingTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| spec subject validationState result |
	spec := Mock new.
	subject := Mock new.
	(subject expect: #stringForSpecValidation) returns: 'some object'.
	(spec expect: #description) returns: 'should be string'.
	validationState := StateValidationFailing spec: spec proxy
				for: subject proxy.
	result := validationState description.
	self assert: result = 'some object should be string'.
	spec verify.
	subject verify! !

TestCase subclass: #StateValidatorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL Tests'!

!StateValidatorTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkDenialSpec: stateSpecKeyword validatedBy: aBlock 
	| subject stateSpec stateValidator validationState args expectation |
	args := (1 to: aBlock numArgs - 1) collect: [:i | Object new].
	subject := Mock new.
	stateSpec := Mock new.
	validationState := Mock new.
	(stateSpec expect: #denial:) with: true.
	expectation := subject expect: stateSpecKeyword.
	args do: [:each | expectation with: each].
	expectation returns: stateSpec proxy.
	validationState expect: #raise.
	(stateSpec expect: #validate:)
		with: subject proxy;
		returns: validationState proxy.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	stateValidator := StateValidator for: subject proxy.
	stateValidator not.
	aBlock valueWithArguments: (Array with: stateValidator) , args.
	subject verify.
	stateSpec verify.
	validationState verify! !

!StateValidatorTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkShouldClauseFrom: aBlock instanceOf: aClass 
	| stateValidator shouldClause |
	stateValidator := StateValidator new.
	shouldClause := aBlock value: stateValidator.
	self assert: shouldClause class = aClass.
	self assert: shouldClause validator == stateValidator! !

!StateValidatorTests methodsFor: 'private' stamp: 'dk 17.8.07 15:2'!
checkSpec: stateSpecKeyword validatedBy: aBlock 
	| subject stateSpec stateValidator validationState args expectation |
	args := (1 to: aBlock numArgs - 1) collect: [:i | Object new].
	subject := Mock new.
	stateSpec := Mock new.
	validationState := Mock new.
	(stateSpec expect: #denial:) with: false.
	expectation := subject expect: stateSpecKeyword.
	args do: [:each | expectation with: each].
	expectation returns: stateSpec proxy.
	validationState expect: #raise.
	(stateSpec expect: #validate:)
		with: subject proxy;
		returns: validationState proxy.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	stateValidator := StateValidator for: subject proxy.
	aBlock valueWithArguments: (Array with: stateValidator) , args.
	subject verify.
	stateSpec verify.
	validationState verify! !

!StateValidatorTests methodsFor: 'tests for should helper words' stamp: 'dk 17.8.07 15:2'!
testA
	| stateValidator |
	stateValidator := StateValidator new.
	self assert: stateValidator a == stateValidator! !

!StateValidatorTests methodsFor: 'tests for should helper words' stamp: 'dk 17.8.07 15:2'!
testAn
	| stateValidator |
	stateValidator := StateValidator new.
	self assert: stateValidator an == stateValidator! !

!StateValidatorTests methodsFor: 'tests for should helper words' stamp: 'dk 17.8.07 15:2'!
testBe
	| stateValidator |
	stateValidator := StateValidator new.
	self assert: stateValidator be == stateValidator! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testBeIdentity
	self checkSpec: #specOfIdentityFor:
		validatedBy: [:stateValidator :object | stateValidator be: object]! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testEqual
	self checkSpec: #specOfEqualityFor:
		validatedBy: [:stateValidator :object | stateValidator equal: object]! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testHave
	self checkShouldClauseFrom: [:validator | validator have]
		instanceOf: ShouldHaveClause! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testHaveSize
	self checkSpec: #specOfElementsCount:
		validatedBy: [:stateValidator :count | stateValidator haveSize: count]! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testInclude
	self checkShouldClauseFrom: [:validator | validator include]
		instanceOf: ShouldIncludeClause! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testIncludeElement
	self checkSpec: #specOfElementContainment:
		validatedBy: [:stateValidator :element | stateValidator include: element]! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testIncludeKey
	self checkSpec: #specOfKeyContainment:
		validatedBy: [:stateValidator :key | stateValidator includeKey: key]! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testInstance
	self checkShouldClauseFrom: [:validator | validator instance]
		instanceOf: ShouldInstanceClause! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testInstanceOfClass
	self checkSpec: #specOfClass:
		validatedBy: [:stateValidator :class | stateValidator instanceOf: class]! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testKind
	self checkShouldClauseFrom: [:validator | validator kind]
		instanceOf: ShouldKindClause! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testKindOfClass
	self checkSpec: #specOfHierarchy:
		validatedBy: [:stateValidator :class | stateValidator kindOf: class]! !

!StateValidatorTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testNeededNegateDefault
	| stateValidator |
	stateValidator := StateValidator new.
	self deny: stateValidator neededNegate! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testNot
	| stateValidator |
	stateValidator := StateValidator new.
	self assert: stateValidator not == stateValidator.
	self assert: stateValidator neededNegate! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testNotEqual
	self checkDenialSpec: #specOfEqualityFor:
		validatedBy: [:stateValidator :object | stateValidator equal: object]! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testNotTwice
	| stateValidator |
	stateValidator := StateValidator new.
	stateValidator not not.
	self deny: stateValidator neededNegate! !

!StateValidatorTests methodsFor: 'tests for should clause' stamp: 'dk 17.8.07 15:2'!
testRespond
	self checkShouldClauseFrom: [:validator | validator respond]
		instanceOf: ShouldRespondClause! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testRespondToMessage
	self checkSpec: #specOfResponsibilityFor:
		validatedBy: [:stateValidator :class | stateValidator respondTo: class]! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testSatisfyFailed
	| subject stateValidator stateSpec |
	subject := Mock new.
	stateSpec := Mock new.
	stateValidator := StateValidator for: subject proxy.
	(stateSpec expect: #validate:)
		with: subject proxy;
		returns: StateValidationFailing new.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	self should: [stateValidator satisfy: stateSpec proxy] raise: SpecFailed.
	subject verify.
	stateSpec verify! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testSatisfySuccessful
	| subject stateValidator stateSpec |
	subject := Mock new.
	stateSpec := Mock new.
	stateValidator := StateValidator for: subject proxy.
	(stateSpec expect: #validate:)
		with: subject proxy;
		returns: StateValidationSuccess new.
	(stateSpec expect: #asStateSpec) returns: stateSpec proxy.
	stateValidator satisfy: stateSpec proxy.
	subject verify.
	stateSpec verify! !

!StateValidatorTests methodsFor: 'tests for specs' stamp: 'dk 17.8.07 15:2'!
testWithinOfValue
	self checkSpec: #specOfFloatingComparisonWith:delta:
		validatedBy: [:stateValidator :value :delta | stateValidator within: delta of: value]! !

TestCase subclass: #StrictBehaviorSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfSingleInnerSpec
	| spec innerSpec validationState messageSend result |
	spec := StrictBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	spec add: innerSpec proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfTwoInnerSpec
	| spec innerSpec validationState messageSend result innerSpec2 |
	spec := StrictBehaviorSpec new.
	innerSpec := Mock new.
	innerSpec2 := Mock new.
	validationState := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: true.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isValid) returns: false.
	(innerSpec2 expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	spec add: innerSpec proxy.
	spec add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	innerSpec2 verify.
	validationState verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateExpectedMessageIfTwoInnerSpec2
	| spec innerSpec validationState messageSend result innerSpec2 |
	spec := StrictBehaviorSpec new.
	innerSpec := Mock new.
	innerSpec2 := Mock new.
	validationState := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec2 expect: #isArbitraryUsage) returns: false.
	(validationState expect: #isSuccess) returns: true.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	spec add: innerSpec proxy.
	spec add: innerSpec2 proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	innerSpec2 verify.
	validationState verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateNotExpectedMessageIfSingleInnerSpec
	| spec innerSpec validationState messageSend result |
	spec := StrictBehaviorSpec new.
	innerSpec := Mock new.
	validationState := Mock new.
	messageSend := Object new.
	(validationState expect: #isSuccess) returns: false.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: false.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	(innerSpec expect: #validate:)
		with: messageSend;
		returns: validationState proxy.
	spec add: innerSpec proxy.
	result := spec validateByStronglyUsedSpecs: messageSend.
	self assert: result == validationState proxy.
	innerSpec verify.
	validationState verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testStronglyValidateTooManyMessagesIfSingleInnerSpec
	| spec innerSpec messageSend validationState |
	spec := StrictBehaviorSpec new.
	innerSpec := Mock new.
	messageSend := Object new.
	(innerSpec expect: #isArbitraryUsage) returns: false.
	(innerSpec expect: #isValid) returns: true.
	spec add: innerSpec proxy.
	validationState := spec validateByStronglyUsedSpecs: messageSend.
	self assert: validationState isFailing.
	self assert: validationState subject == messageSend.
	self assert: validationState class = TooManyMessageSends.
	innerSpec verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailed
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec failingValidation |
	spec := StrictBehaviorSpec new.
	messageSend := Object new.
	failingValidation := SpecValidationFailing new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failingValidation.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failingValidation.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == failingValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateFailedByTooManyMessageSends
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec failedValidation |
	spec := StrictBehaviorSpec new.
	messageSend := Object new.
	failedValidation := SpecValidationFailing new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: failedValidation.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: TooManyMessageSends new.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: TooManyMessageSends new.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == failedValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateNotExpectedMessageIfSpecIsEmpty
	| spec messageSend validation |
	spec := StrictBehaviorSpec new.
	messageSend := Object new.
	validation := spec validate: messageSend.
	self assert: validation isFailing.
	self assert: validation subject == messageSend.
	self assert: validation class = TooManyMessageSends! !

!StrictBehaviorSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testValidateSuccessfully
	| spec messageSend validationState arbitraryUsedMessageSpec stronglyUsedMessageSpec successValidation |
	spec := StrictBehaviorSpec new.
	messageSend := Object new.
	successValidation := BehaviorSpecValidationSuccess new.
	arbitraryUsedMessageSpec := Mock new.
	stronglyUsedMessageSpec := Mock new.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #isArbitraryUsage) returns: true.
	(arbitraryUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: successValidation.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isArbitraryUsage) returns: false.
	(stronglyUsedMessageSpec expect: #isValid) returns: false.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	(stronglyUsedMessageSpec expect: #validate:)
		with: messageSend;
		returns: SpecValidationFailing new.
	spec
		add: arbitraryUsedMessageSpec proxy;
		add: stronglyUsedMessageSpec proxy.
	validationState := spec validate: messageSend.
	self assert: validationState == successValidation.
	arbitraryUsedMessageSpec verify.
	stronglyUsedMessageSpec verify! !

TestCase subclass: #UnlimitedUsageSpecTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs Tests'!

!UnlimitedUsageSpecTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:2'!
testValidateSuccessfulAlways
	| usageSpec messageSend validationState |
	messageSend := Object new.
	usageSpec := UnlimitedUsageSpec withValidatedUsageLimit: 5.
	usageSpec usageCount: 6.
	validationState := usageSpec validate: messageSend.
	self assert: validationState isSuccess.
	self assert: validationState subject == messageSend! !

TestCase subclass: #WrongMessageArgumentTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core Tests'!

!WrongMessageArgumentTests methodsFor: 'tests' stamp: 'dk 17.8.07 15:1'!
testDescription
	| stateFailing wrongArgument result |
	stateFailing := Mock new.
	(stateFailing expect: #description) returns: 'state failed'.
	wrongArgument := WrongMessageArgument new.
	wrongArgument argumentIndex: 3.
	wrongArgument stateFailing: stateFailing proxy.
	result := wrongArgument description.
	self assert: result = 'wrong arg 3: state failed'! !

!SequenceableCollection methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfKeyContainment: anObject 
	^IndexContainmentSpec requiredIndex: anObject! !

Object subclass: #BMWorld
	instanceVariableNames: 'mocks objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!BMWorld class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
new
	^super new initialize! !

!BMWorld methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
addMock: aMockObject 
	mocks at: aMockObject xxxname put: aMockObject.
	objects add: aMockObject! !

!BMWorld methodsFor: 'evaluation behavior' stamp: 'dk 16.8.07 17:17'!
buildSpecification: aSpec while: aBlock 
	| behaviorHandler |
	behaviorHandler := BehaviorSpecBuilder on: aSpec.
	self evaluateBehaviorBy: behaviorHandler while: aBlock! !

!BMWorld methodsFor: 'objects creation' stamp: 'dk 16.8.07 17:17'!
createObject
	^self createObjectNamed: self nextObjectId! !

!BMWorld methodsFor: 'objects creation' stamp: 'dk 16.8.07 17:17'!
createObjectNamed: aString 
	| newMock |
	newMock := MockObject named: aString.
	self addMock: newMock.
	^newMock! !

!BMWorld methodsFor: 'evaluation behavior' stamp: 'dk 16.8.07 17:17'!
evaluateBehaviorBy: behaviorHandler while: aBlock 
	| oldHandlers mockNames |
	mockNames := self objectNames.
	oldHandlers := mockNames 
				collect: [:eachName | (self objectNamed: eachName) xxxbehaviorSpecHandler].
	mockNames 
		do: [:eachName | (self objectNamed: eachName) xxxbehaviorSpecHandler: behaviorHandler].
	aBlock value.
	mockNames with: oldHandlers
		do: [:eachName :eachHandler | (self objectNamed: eachName) xxxbehaviorSpecHandler: eachHandler]! !

!BMWorld methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:17'!
initialize
	mocks := Dictionary new.
	objects := OrderedCollection new! !

!BMWorld methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
mocks
	^mocks! !

!BMWorld methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
nextObjectId
	^(mocks size + 1) printString! !

!BMWorld methodsFor: 'objects accessing' stamp: 'dk 16.8.07 17:17'!
objectNamed: aString 
	^mocks at: aString! !

!BMWorld methodsFor: 'objects accessing' stamp: 'dk 16.8.07 17:17'!
objectNames
	^mocks keys asArray! !

!BMWorld methodsFor: 'objects accessing' stamp: 'dk 16.8.07 17:17'!
objects
	^objects asArray! !

!BMWorld methodsFor: 'evaluation behavior' stamp: 'dk 16.8.07 17:17'!
validateSpecification: aBehaviorSpec while: aBlock 
	| specValidator |
	specValidator := MessageSendValidator on: aBehaviorSpec.
	self evaluateBehaviorBy: specValidator while: aBlock! !

Object subclass: #DevelopmentServices
	instanceVariableNames: 'proxy classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy'!

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
current
	^self new addAll: self currentSystemClasses! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
currentFor: aProxy 
	^(self current)
		proxy: aProxy;
		yourself! !

!DevelopmentServices class methodsFor: 'current system classes' stamp: 'dk 8/17/2007 15:36'!
currentSystemClasses
	^(self currentSystemEnvironment select: [:eachClassSymbol | Smalltalk includesKey: eachClassSymbol]) 
		collect: [:eachClassSymbol | Smalltalk at: eachClassSymbol]

		! !

!DevelopmentServices class methodsFor: 'current system classes' stamp: 'dik 9/3/2007 17:16'!
currentSystemEnvironment
	^#(MessageSendSpec ContextVariablesInspector  MethodStub Inspector)
! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
for: aProxy 
	^self new proxy: aProxy! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
new
	^super new initialize! !

!DevelopmentServices class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
onClasses: anArray 
	^self new classes: anArray! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
add: aClass 
	classes add: aClass! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
addAll: anArray 
	anArray do: [:each | self add: each]! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
classes
	^classes! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
classes: anArray 
	classes := anArray! !

!DevelopmentServices methodsFor: 'context finding' stamp: 'dk 16.8.07 17:16'!
findProxyClientContextIn: aContext 
	| proxyClientContext |
	proxyClientContext := (self findProxyContextIn: aContext) sender.
	[proxyClientContext receiver == proxy] 
		whileTrue: [proxyClientContext := proxyClientContext sender].
	^proxyClientContext! !

!DevelopmentServices methodsFor: 'context finding' stamp: 'dk 16.8.07 17:16'!
findProxyContextIn: aContext 
	^aContext receiver == proxy 
		ifTrue: [aContext]
		ifFalse: [self findProxyContextIn: aContext sender]! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
includeProxyClient: anObject 
	^classes anySatisfy: 
			[:eachServiceClass | 
			anObject = eachServiceClass or: [anObject xxxclass = eachServiceClass]]! !

!DevelopmentServices methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:16'!
initialize
	classes := OrderedCollection new! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isActiveIn: aContext 
	| proxyClientContext |
	self isEmpty ifTrue: [^false].
	proxyClientContext := self findProxyClientContextIn: aContext.
	^self isActiveInProxyClientContext: proxyClientContext! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isActiveInProxyClientContext: aContext 
	| proxyClientContext |
	proxyClientContext := aContext.
	
	[proxyClientContext notNil 
		and: [(self includeProxyClient: proxyClientContext receiver) not]] 
			whileTrue: [proxyClientContext := proxyClientContext sender].
	^proxyClientContext notNil! !

!DevelopmentServices methodsFor: 'testing' stamp: 'dk 16.8.07 17:16'!
isEmpty
	^classes isEmpty! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy
	^proxy! !

!DevelopmentServices methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy: aProxy 
	proxy := aProxy! !

Object subclass: #MockAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!MockAction methodsFor: 'converting' stamp: 'dk 16.8.07 17:17'!
asMockAction! !

!MockAction methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:17'!
executeFor: aBehaviorAct 
	self subclassResponsibility! !

!MockAction methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
reset! !

MockAction subclass: #MockActionSequence
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!MockActionSequence class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
new
	^super new initialize! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
add: aMockAction 
	actions add: aMockAction! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
contents
	^actions! !

!MockActionSequence methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:17'!
executeFor: aBehaviorAct 
	actions allButLastDo: [:eachPart | eachPart executeFor: aBehaviorAct].
	^actions notEmpty ifTrue: [actions last executeFor: aBehaviorAct]! !

!MockActionSequence methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:17'!
initialize
	actions := OrderedCollection new! !

!MockActionSequence methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
reset
	actions do: [:each | each reset]! !

MockAction subclass: #PluggableMockAction
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions'!

!PluggableMockAction class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
basedOn: aBlockContext 
	^self new block: aBlockContext! !

!PluggableMockAction methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
block
	^block! !

!PluggableMockAction methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
block: anObject
	block := anObject! !

!PluggableMockAction methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:19'!
executeFor: aMessageSend 
	^block numArgs = 0 
		ifTrue: [block value]
		ifFalse: [block valueWithArguments: aMessageSend arguments]! !

MockAction subclass: #ProcessBlocking
	instanceVariableNames: 'lockCount semaphore currentLockNumber currentUnlockNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions'!

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
lockCount: aNumber 
	^self new lockCount: aNumber! !

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
new
	^super new initialize! !

!ProcessBlocking class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
singleLock
	^self lockCount: 1! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
allowLockOccur
	[self isLockOccurs] whileFalse: [Processor yield]! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
currentLockNumber
	^currentLockNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
currentLockNumber: aNumber 
	currentLockNumber := aNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
currentUnlockNumber
	^currentUnlockNumber! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
currentUnlockNumber: aNumber 
	currentUnlockNumber := aNumber! !

!ProcessBlocking methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:19'!
executeFor: aMessageSend 
	lockCount timesRepeat: [self lock]! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
finish
	lockCount - currentUnlockNumber timesRepeat: [self unlock]! !

!ProcessBlocking methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:19'!
initialize
	semaphore := Semaphore new.
	currentLockNumber := 0.
	currentUnlockNumber := 0! !

!ProcessBlocking methodsFor: 'testing' stamp: 'dk 16.8.07 17:19'!
isLockOccurs
	^currentLockNumber > currentUnlockNumber! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
lock
	currentLockNumber := currentLockNumber + 1.
	semaphore wait! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
lockCount
	^lockCount! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
lockCount: aNumber 
	lockCount := aNumber! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
reset
	semaphore terminateProcess.
	self initialize! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
semaphore
	^semaphore! !

!ProcessBlocking methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
semaphore: aSemaphore 
	semaphore := aSemaphore! !

!ProcessBlocking methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
unlock
	self allowLockOccur.
	semaphore signal.
	currentUnlockNumber := currentUnlockNumber + 1.
	Processor yield! !

MockAction subclass: #RaisingExeption
	instanceVariableNames: 'exeptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions'!

!RaisingExeption class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
of: anExeptionClass 
	^self new exeptionClass: anExeptionClass! !

!RaisingExeption methodsFor: 'evaluating' stamp: 'dk 8/17/2007 17:42'!
executeFor: aMessageSend 
	exeptionClass signal! !

!RaisingExeption methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
exeptionClass
	^exeptionClass! !

!RaisingExeption methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
exeptionClass: anExeptionClass
	exeptionClass := anExeptionClass! !

MockAction subclass: #ReturnReceiver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions'!

!ReturnReceiver methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:19'!
executeFor: aMessageSend 
	^aMessageSend receiver! !

MockAction subclass: #ReturnValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Actions'!

!ReturnValue class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
of: anObject 
	^self new value: anObject! !

!ReturnValue methodsFor: 'evaluating' stamp: 'dk 16.8.07 17:19'!
executeFor: aMessageSend 
	^value! !

!ReturnValue methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
value
	^value! !

!ReturnValue methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
value: anObject
	value := anObject! !

!Object methodsFor: '*BehaviorMockup-Constraints-constraints creation' stamp: 'dk 16.8.07 17:18'!
andMatches: anObject 
	^All of: self asConstraint and: anObject asConstraint! !

!Object methodsFor: '*BehaviorMockup-Constraints-converting' stamp: 'dk 16.8.07 17:18'!
asConstraint
	^Equal for: self! !

!Object methodsFor: '*BehaviorMockup-Constraints-constraints creation' stamp: 'dk 16.8.07 17:18'!
notMatches
	^Nothing of: (Array with: self asConstraint)! !

!Object methodsFor: '*BehaviorMockup-Constraints-constraints creation' stamp: 'dk 16.8.07 17:18'!
orMatches: anObject 
	^Any of: self asConstraint and: anObject asConstraint! !

!Object methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dk 16.8.07 17:19'!
should
	^StateValidator for: self! !

!Object methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dk 16.8.07 17:19'!
shouldSatisfy: aStateSpec 
	self should satisfy: aStateSpec! !

!Object methodsFor: '*BehaviorMockup-SSpecDSL-specs' stamp: 'dk 16.8.07 17:19'!
shouldnt
	^self should not! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfClass: aClass 
	^ClassSpec for: aClass! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfEqualityFor: anObject 
	^EqualitySpec pattern: anObject! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfHierarchy: aClass 
	^HierarchySpec for: aClass! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfIdentityFor: anObject 
	^IdentitySpec pattern: anObject! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfResponsibilityFor: aSelector 
	^ResponsibilitySpec for: aSelector! !

!Object methodsFor: '*BehaviorMockup-StateSpecs-displaying' stamp: 'dk 16.8.07 17:18'!
stringForSpecValidation
	^self printString! !

!Object methodsFor: '*BehaviorMockup-Core-class membership' stamp: 'dk 16.8.07 17:17'!
xxxclass
	^self class! !

Object subclass: #ProxyHelper
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Proxy'!

!ProxyHelper class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:16'!
for: aProxy 
	^self new proxy: aProxy! !

!ProxyHelper methodsFor: 'evaluation' stamp: 'dk 16.8.07 17:16'!
evaluateMessage: aMessage 
	^self perform: aMessage selector withArguments: aMessage arguments! !

!ProxyHelper methodsFor: 'proxy inspecting' stamp: 'dk 16.8.07 17:16'!
inspect
	self subclassResponsibility! !

!ProxyHelper methodsFor: 'proxy testing' stamp: 'dk 16.8.07 17:16'!
isBlockClosure
	^false! !

!ProxyHelper methodsFor: 'proxy testing' stamp: 'dk 16.8.07 17:16'!
isBlockContext
	^false! !

!ProxyHelper methodsFor: 'proxy class membership' stamp: 'dk 16.8.07 17:16'!
isKindOf: aClass 
	^self proxyClass includesBehavior: aClass! !

!ProxyHelper methodsFor: 'proxy mockobject constraint' stamp: 'dk 16.8.07 17:16'!
matches: anObject 
	^proxy = anObject! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printOn: aStream 
	"Append to the argument aStream a sequence of characters
        that describes the receiver."

	| title |
	title := self printProxy.
	aStream 
		nextPutAll: ((title at: 1) isVowel ifTrue: ['an '] ifFalse: ['a ']).
	aStream nextPutAll: title! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxy
	^self printProxyClassName , self printProxyName! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxyClassName
	^self proxyClass name! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printProxyName
	self proxyName ifNil: [^''].
	^'(' , self proxyName , ')'! !

!ProxyHelper methodsFor: 'proxy printing' stamp: 'dk 16.8.07 17:16'!
printString
	"Answer a String whose characters are a description of the receiver."

	| aStream |
	aStream := WriteStream on: (String new: 16).
	self printOn: aStream.
	^aStream contents! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy
	^proxy! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxy: aProxy 
	proxy := aProxy! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxyClass
	^proxy xxxclass! !

!ProxyHelper methodsFor: 'accessing' stamp: 'dk 16.8.07 17:16'!
proxyName
	^proxy xxxname! !

Object subclass: #ShouldClause
	instanceVariableNames: 'validator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldClause class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
of: aStateValidator 
	^self new validator: aStateValidator! !

!ShouldClause methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
validator
	^validator! !

!ShouldClause methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
validator: aStateValidator 
	validator := aStateValidator! !

ShouldClause subclass: #ShouldHaveClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldHaveClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
length: anInteger 
	validator haveSize: anInteger! !

!ShouldHaveClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
size: anInteger 
	validator haveSize: anInteger! !

ShouldClause subclass: #ShouldIncludeClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldIncludeClause methodsFor: 'As yet unclassified' stamp: 'dk 16.8.07 17:19'!
index: anInteger 
	validator includeKey: anInteger! !

!ShouldIncludeClause methodsFor: 'As yet unclassified' stamp: 'dk 16.8.07 17:19'!
key: anObject 
	validator includeKey: anObject! !

ShouldClause subclass: #ShouldInstanceClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldInstanceClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
of: aClass 
	validator instanceOf: aClass! !

ShouldClause subclass: #ShouldKindClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldKindClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
of: aClass 
	validator kindOf: aClass! !

ShouldClause subclass: #ShouldLenientClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldLenientClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
satisfy: aBlock 
	validator lenientSatisfy: aBlock! !

ShouldClause subclass: #ShouldRaiseAndLenientClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldRaiseAndLenientClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
satisfy: specDefinitionBlock 
	validator raiseAndLenientSatisfy: specDefinitionBlock! !

ShouldClause subclass: #ShouldRaiseAndStrictlyClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldRaiseAndStrictlyClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
satisfy: specDefinitionBlock 
	validator raiseAndStrictlySatisfy: specDefinitionBlock! !

ShouldClause subclass: #ShouldRaiseClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldRaiseClause methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
and
	^self! !

!ShouldRaiseClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
error
	validator raiseError! !

!ShouldRaiseClause methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
lenient
	^ShouldRaiseAndLenientClause of: validator! !

!ShouldRaiseClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
satisfy: aBehaviorSpec 
	validator raiseAndSatisfy: aBehaviorSpec! !

!ShouldRaiseClause methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
strictly
	^ShouldRaiseAndStrictlyClause of: validator! !

ShouldClause subclass: #ShouldRespondClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldRespondClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
to: aMessageSelector 
	validator respondTo: aMessageSelector! !

ShouldClause subclass: #ShouldStrictlyClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!ShouldStrictlyClause methodsFor: 'clause' stamp: 'dk 16.8.07 17:19'!
satisfy: aBlock 
	validator strictlySatisfy: aBlock! !

Object subclass: #SpecValidationState
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

SpecValidationState subclass: #SpecValidationFailing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

SpecValidationFailing subclass: #BehaviorSpecValidationFailing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

BehaviorSpecValidationFailing subclass: #MessageSendNotHappen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

BehaviorSpecValidationFailing subclass: #TooManyMessageSends
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

BehaviorSpecValidationFailing subclass: #UsageLimitExceeded
	instanceVariableNames: 'usageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!UsageLimitExceeded class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: aMessageSend withUsageLimit: anInteger 
	^(self for: aMessageSend) usageLimit: anInteger! !

!UsageLimitExceeded methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
usageLimit
	^usageLimit! !

!UsageLimitExceeded methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
usageLimit: anInteger 
	usageLimit := anInteger! !

BehaviorSpecValidationFailing subclass: #WrongCondition
	instanceVariableNames: 'expectedCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs'!

!WrongCondition class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
for: aMessageSend withExpectedCondition: aBlock 
	^(self for: aMessageSend) expectedCondition: aBlock! !

!WrongCondition methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
expectedCondition
	^expectedCondition! !

!WrongCondition methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
expectedCondition: aBlock 
	expectedCondition := aBlock! !

BehaviorSpecValidationFailing subclass: #WrongMessageArgument
	instanceVariableNames: 'argumentIndex stateFailing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!WrongMessageArgument class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: aMessageSend index: aNumber stateFailing: aStateValidationFailing 
	^(self for: aMessageSend)
		argumentIndex: aNumber;
		stateFailing: aStateValidationFailing! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
argumentIndex
	^argumentIndex! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
argumentIndex: anObject
	argumentIndex := anObject! !

!WrongMessageArgument methodsFor: 'displaying' stamp: 'dk 16.8.07 17:17'!
description
	^'wrong arg ' , argumentIndex printString , ': ' 
		, stateFailing description! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
stateFailing
	^stateFailing! !

!WrongMessageArgument methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
stateFailing: aStateValidationFailing 
	stateFailing := aStateValidationFailing! !

BehaviorSpecValidationFailing subclass: #WrongMessageReceiver
	instanceVariableNames: 'expectedReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!WrongMessageReceiver class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: aMessageSend withExpectedReceiver: anObject 
	^(self for: aMessageSend) expectedReceiver: anObject! !

!WrongMessageReceiver methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
expectedReceiver
	^expectedReceiver! !

!WrongMessageReceiver methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
expectedReceiver: anObject 
	expectedReceiver := anObject! !

BehaviorSpecValidationFailing subclass: #WrongMessageSelector
	instanceVariableNames: 'expectedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!WrongMessageSelector class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: aMessageSend withExpectedSelector: aSelector 
	^(self for: aMessageSend) expectedSelector: aSelector! !

!WrongMessageSelector methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
expectedSelector
	^expectedSelector! !

!WrongMessageSelector methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
expectedSelector: aSelector 
	expectedSelector := aSelector! !

BehaviorSpecValidationFailing subclass: #WrongProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs'!

!SpecValidationFailing methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:17'!
debugSpecOver: aSpecFailed
	UnhandledError signalForException: aSpecFailed! !

!SpecValidationFailing methodsFor: 'displaying' stamp: 'dk 16.8.07 17:17'!
description
	^self class name! !

!SpecValidationFailing methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isFailing
	^true! !

!SpecValidationFailing methodsFor: 'accessing' stamp: 'dk 8/17/2007 17:53'!
raise
	^ SpecFailed raiseWith: self! !

SpecValidationFailing subclass: #StateValidationFailing
	instanceVariableNames: 'spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!StateValidationFailing class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
spec: aStateSpec for: anObject 
	^(self for: anObject) spec: aStateSpec! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:31'!
debugSpecOver: aSpecFailed
	spec debugValidationFailingOver: aSpecFailed! !

!StateValidationFailing methodsFor: 'displaying' stamp: 'dk 16.8.07 17:17'!
description
	^subject stringForSpecValidation , ' ' , spec description! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
spec
	^spec! !

!StateValidationFailing methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
spec: aStateSpec 
	spec := aStateSpec! !

!SpecValidationState class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: anObject 
	^self new subject: anObject! !

!SpecValidationState methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isFailing
	self subclassResponsibility! !

!SpecValidationState methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isSuccess
	^self isFailing not! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
raise
	self subclassResponsibility! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
subject
	^subject! !

!SpecValidationState methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
subject: anObject 
	subject := anObject! !

SpecValidationState subclass: #SpecValidationSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

SpecValidationSuccess subclass: #BehaviorSpecValidationSuccess
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!BehaviorSpecValidationSuccess class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
for: aMessageState withActions: aMockActionSequence 
	^(self for: aMessageState) actions: aMockActionSequence! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
actions
	^actions! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
actions: aMockActionSequence 
	actions := aMockActionSequence! !

!BehaviorSpecValidationSuccess methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
raise
	^actions executeFor: subject! !

!SpecValidationSuccess methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isFailing
	^false! !

SpecValidationSuccess subclass: #StateValidationSuccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!StateValidationSuccess methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
raise! !

Object subclass: #Specification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

Specification subclass: #ComplexSpecification
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

ComplexSpecification subclass: #BehaviorSpec
	instanceVariableNames: 'world activeSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!BehaviorSpec class methodsFor: 'instance creation' stamp: 'dik 9/3/2007 17:53'!
definedBy: specDefinitionBlock 
	| world spec |
	world := BMWorld new.	
	specDefinitionBlock argumentNames 
		do: [:eachArgName | world createObjectNamed: eachArgName].
	spec := self of: world.
	spec define: [specDefinitionBlock valueWithArguments: world objects].
	^spec! !

!BehaviorSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
of: aBMWorld 
	^self new world: aBMWorld! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
activeSpec
	^activeSpec! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
activeSpec: aComplexSpecification 
	activeSpec := aComplexSpecification! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
arbitrarilyUsedSpecs
	^contents select: [:eachSpec | eachSpec isArbitraryUsage]! !

!BehaviorSpec methodsFor: 'definition' stamp: 'dk 16.8.07 17:17'!
define: aBlock 
	world buildSpecification: self while: aBlock! !

!BehaviorSpec methodsFor: 'definition' stamp: 'dk 16.8.07 17:17'!
define: aBehaviorSpecClass by: aBlock 
	| innerSpec |
	innerSpec := aBehaviorSpecClass of: world.
	innerSpec define: aBlock.
	self add: innerSpec! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
existsActiveSpec
	^activeSpec notNil 
		and: [activeSpec isValid not and: [activeSpec isArbitraryUsage not]]! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isArbitraryUsage
	^false! !

!BehaviorSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isValid
	^contents allSatisfy: [:eachSpec | eachSpec isValid]! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
reset
	super reset.
	self resetActiveSpec! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
resetActiveSpec
	activeSpec := nil! !

!BehaviorSpec methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
selectNotValidSpecs
	^self selectNotValidSpecsFrom: self stronglyUsedSpecs! !

!BehaviorSpec methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
selectNotValidSpecsFrom: innerSpecs 
	self subclassResponsibility! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
stronglyUsedSpecs
	^contents reject: [:eachSpec | eachSpec isArbitraryUsage]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'rkrk 9/26/2007 17:27'!
validate: aMessageSend 
	| validation validation2 |
	validation := self validateByStronglyUsedSpecs: aMessageSend.
	validation isSuccess ifTrue: [^validation].
	"validation class = TooManyMessageSends ifFalse: [^validation]."
	validation2 := self validateByArbitrarilyUsedSpecs: aMessageSend.
	validation2 isSuccess ifTrue: [^validation2].
	validation class = TooManyMessageSends ifFalse: [^validation].
	^validation2! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dk 8/17/2007 17:53'!
validateBehavior: aBlock 
	self reset.
	world validateSpecification: self while: aBlock.
	self isValid ifFalse: [SpecFailed raiseWith: MessageSendNotHappen new]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dk 8/17/2007 17:53'!
validateBehavior: aBlock thatShouldRaise: anExeptionClass 
	self reset.
	[world validateSpecification: self while: aBlock] should 
		raise: anExeptionClass.
	self isValid ifFalse: [SpecFailed raiseWith: MessageSendNotHappen new]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validateByArbitrarilyUsedSpecs: aMessageSend 
	| validation |
	self arbitrarilyUsedSpecs do: 
			[:eachSpec | 
			validation := eachSpec validate: aMessageSend.
			validation isSuccess ifTrue: [^validation]].
	^validation ifNil: [^TooManyMessageSends for: aMessageSend]! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validateByStronglyUsedSpecs: aMessageSend 
	| notValidSpecs validateState |
	self existsActiveSpec ifTrue: [^activeSpec validate: aMessageSend].
	notValidSpecs := self selectNotValidSpecs.
	notValidSpecs isEmpty ifTrue: [^TooManyMessageSends for: aMessageSend].
	notValidSpecs do: 
			[:eachSpec | 
			validateState := eachSpec validate: aMessageSend.
			validateState isSuccess 
				ifTrue: 
					[activeSpec := eachSpec.
					^validateState]].
	^notValidSpecs first validate: aMessageSend! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dik 9/3/2007 17:58'!
validateWorldBehavior: aManyArgsBlock 
	self validateBehavior: (aManyArgsBlock behaviorWrapperOf: world)! !

!BehaviorSpec methodsFor: 'validation' stamp: 'dik 9/3/2007 18:00'!
validateWorldBehavior: aManyArgsBlock thatShouldRaise: anExeptionClass 
	self validateBehavior: (aManyArgsBlock behaviorWrapperOf: world)
		thatShouldRaise: anExeptionClass! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
world
	^world! !

!BehaviorSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
world: aBMWorld 
	world := aBMWorld! !

BehaviorSpec subclass: #LenientBehaviorSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!LenientBehaviorSpec methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
selectNotValidSpecsFrom: innerSpecs 
	^innerSpecs reject: [:eachSpec | eachSpec isValid]! !

BehaviorSpec subclass: #StrictBehaviorSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!StrictBehaviorSpec methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
selectNotValidSpecsFrom: innerSpecs 
	^Array 
		with: (innerSpecs detect: [:eachSpec | eachSpec isValid not] ifNone: [^#()])! !

ComplexSpecification subclass: #ComplexMessageUsageSpec
	instanceVariableNames: 'isValid isArbitrary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!ComplexMessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
beArbitrary
	isArbitrary := true! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
hasArbitraryUsageSpec
	^contents anySatisfy: [:eachUsageSpec | eachUsageSpec isArbitrary]! !

!ComplexMessageUsageSpec methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:17'!
initialize
	super initialize.
	isArbitrary := false.
	self reset! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isArbitrary
	isArbitrary ifFalse: [^self hasArbitraryUsageSpec].
	^isArbitrary! !

!ComplexMessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isValid
	contents isEmpty ifTrue: [^isValid | isArbitrary].
	^contents allSatisfy: [:eachUsageSpec | eachUsageSpec isValid]! !

!ComplexMessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
reset
	super reset.
	isValid := false! !

!ComplexMessageUsageSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validate: aMessageSend 
	| validation |
	contents isEmpty 
		ifTrue: 
			[isValid := true.
			^BehaviorSpecValidationSuccess for: aMessageSend].
	contents do: 
			[:eachUsageSpec | 
			validation := eachUsageSpec validate: aMessageSend.
			validation isFailing ifTrue: [^validation]].
	contents do: [:eachUsageSpec | eachUsageSpec incrementUsageCount].
	^BehaviorSpecValidationSuccess for: aMessageSend! !

!ComplexSpecification class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
new
	^super new initialize! !

!ComplexSpecification methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
add: aSpecification 
	contents add: aSpecification! !

!ComplexSpecification methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
contents
	^contents! !

!ComplexSpecification methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:17'!
initialize
	contents := OrderedCollection new! !

!ComplexSpecification methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isArbitraryUsage
	self subclassResponsibility! !

!ComplexSpecification methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isEmpty
	^contents isEmpty! !

!ComplexSpecification methodsFor: 'private' stamp: 'dk 16.8.07 17:17'!
reset
	contents do: [:eachSpec | eachSpec reset]! !

ComplexSpecification subclass: #MessageSendSpec
	instanceVariableNames: 'actions usageSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!MessageSendSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
withMessageSemanticsLike: aMessageSend 
	^self new add: (MessageSemanticsSpec from: aMessageSend)! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
actions
	^actions! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
actions: aMockActionSequence 
	actions := aMockActionSequence! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
addAction: aMockAction 
	actions add: aMockAction! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
addUsageSpec: aMessageUsageSpec 
	usageSpec add: aMessageUsageSpec! !

!MessageSendSpec methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:17'!
initialize
	super initialize.
	actions := MockActionSequence new.
	usageSpec := ComplexMessageUsageSpec new! !

!MessageSendSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isArbitraryUsage
	^usageSpec isArbitrary! !

!MessageSendSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isValid
	^usageSpec isValid! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
reset
	usageSpec reset.
	actions reset! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
usageSpec
	^usageSpec! !

!MessageSendSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
usageSpec: aComplexMessageUsageSpec 
	usageSpec := aComplexMessageUsageSpec! !

!MessageSendSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validate: aMessageSend 
	| validationState |
	contents do: 
			[:eachSpec | 
			validationState := eachSpec validate: aMessageSend.
			validationState isFailing ifTrue: [^validationState]].
	validationState := usageSpec validate: aMessageSend.
	validationState isFailing ifTrue: [^validationState].
	^BehaviorSpecValidationSuccess for: aMessageSend withActions: actions! !

Specification subclass: #Constraint
	instanceVariableNames: 'denial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

Constraint subclass: #ComplexConstraint
	instanceVariableNames: 'patterns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

ComplexConstraint subclass: #All
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!All methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isFailing ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

ComplexConstraint subclass: #Any
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Any class methodsFor: 'converting' stamp: 'dk 16.8.07 17:18'!
asConstraint
	^self! !

!Any class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial: aBoolean 
	^self! !

!Any class methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
matches: anObject 
	^true! !

!Any class methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	^StateValidationSuccess new! !

!Any methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isSuccess ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

!ComplexConstraint class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
of: arrayOfPatterns 
	^self new patterns: (arrayOfPatterns collect: [:each | each asConstraint])! !

!ComplexConstraint class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
of: pattern1 and: pattern2 
	^self of: (Array with: pattern1 with: pattern2)! !

!ComplexConstraint class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
of: pattern1 and: pattern2 and: pattern3 
	^self of: (Array 
				with: pattern1
				with: pattern2
				with: pattern3)! !

!ComplexConstraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
patterns
	^patterns! !

!ComplexConstraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
patterns: anArray
	patterns := anArray! !

!ComplexConstraint methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject by: aConstraint 
	^aConstraint
		denial: denial;
		validate: anObject! !

ComplexConstraint subclass: #Nothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Nothing class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial
	^true! !

!Nothing methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	| state |
	patterns do: 
			[:eachPattern | 
			state := self validate: anObject by: eachPattern.
			state isFailing ifTrue: [^state]].
	^self validate: anObject by: patterns first! !

!Constraint class methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial
	^false! !

!Constraint class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
new
	^super new initialize! !

!Constraint methodsFor: 'converting' stamp: 'dk 16.8.07 17:18'!
asConstraint
	^self! !

!Constraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial
	^denial! !

!Constraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial: aBoolean
	denial := aBoolean! !

!Constraint methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:18'!
initialize
	denial := self class denial! !

Constraint subclass: #SimpleConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

SimpleConstraint subclass: #ComparisonConstraint
	instanceVariableNames: 'pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!ComparisonConstraint class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
for: anObject 
	^self new pattern: anObject! !

!ComparisonConstraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
pattern
	^pattern! !

!ComparisonConstraint methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
pattern: anObject 
	pattern := anObject! !

ComparisonConstraint subclass: #Equal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Equal methodsFor: 'private' stamp: 'dk 16.8.07 17:18'!
stateSpecFor: anObject 
	^anObject specOfEqualityFor: pattern! !

ComparisonConstraint subclass: #Identical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Identical methodsFor: 'private' stamp: 'dk 16.8.07 17:18'!
stateSpecFor: anObject 
	^anObject specOfIdentityFor: pattern! !

SimpleConstraint subclass: #Kind
	instanceVariableNames: 'requiredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Kind class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
of: aClass 
	^self new requiredClass: aClass! !

!Kind methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredClass
	^requiredClass! !

!Kind methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredClass: aClass 
	requiredClass := aClass! !

!Kind methodsFor: 'private' stamp: 'dk 16.8.07 17:18'!
stateSpecFor: anObject 
	^anObject specOfHierarchy: requiredClass! !

SimpleConstraint subclass: #Satisfy
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Constraints'!

!Satisfy class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
for: aBlockContext 
	^self new condition: aBlockContext! !

!Satisfy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition
	^condition! !

!Satisfy methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition: aBlockContext
	condition := aBlockContext! !

!Satisfy methodsFor: 'private' stamp: 'dk 16.8.07 17:18'!
stateSpecFor: anObject 
	^condition asStateSpec! !

!SimpleConstraint methodsFor: 'private' stamp: 'dk 16.8.07 17:18'!
stateSpecFor: anObject 
	self subclassResponsibility! !

!SimpleConstraint methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	^(self stateSpecFor: anObject)
		denial: denial;
		validate: anObject! !

Specification subclass: #MessageContextSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

MessageContextSpec subclass: #AsynchronousCallSpec
	instanceVariableNames: 'initialProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs'!

!AsynchronousCallSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
forCurrentProcess
	^self new initialProcess: Processor activeProcess! !

!AsynchronousCallSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
initialProcess
	^initialProcess! !

!AsynchronousCallSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
initialProcess: aProcess 
	initialProcess := aProcess! !

!AsynchronousCallSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: aMessageSend 
	^initialProcess == Processor activeProcess 
		ifTrue: [WrongProcess for: aMessageSend]
		ifFalse: [BehaviorSpecValidationSuccess for: aMessageSend]! !

MessageContextSpec subclass: #ConditionSpec
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-ContextSpecs'!

!ConditionSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
from: aBlock 
	^self new condition: aBlock! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition
	^condition! !

!ConditionSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition: aBlockContext
	condition := aBlockContext! !

!ConditionSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: aMessageSend 
	^condition value 
		ifTrue: [BehaviorSpecValidationSuccess for: aMessageSend]
		ifFalse: [WrongCondition for: aMessageSend withExpectedCondition: condition]! !

!MessageContextSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:17'!
isUsageSpec
	^false! !

MessageContextSpec subclass: #MessageSemanticsSpec
	instanceVariableNames: 'receiver selector argumentConstraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

MessageSemanticsSpec subclass: #IgnoreMessageSemanticsSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-MyAddition'!

!IgnoreMessageSemanticsSpec class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 03:17'!
receiver: aReceiver

	^ self new receiver: aReceiver! !

!IgnoreMessageSemanticsSpec methodsFor: 'as yet unclassified' stamp: 'rkrk 9/26/2007 03:20'!
validate: aMessageSend 
	| result |
	result := super validate: aMessageSend.
	^ (result isFailing and: [result isKindOf: WrongMessageSelector])
		ifTrue: [BehaviorSpecValidationSuccess for: aMessageSend]
		ifFalse: [result]! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
from: aMessageSend 
	^self 
		receiver: aMessageSend receiver
		selector: aMessageSend selector
		argumentConstraints: (aMessageSend arguments 
				collect: [:each | each asConstraint])! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
receiver: anObject selector: aSymbol 
	^self 
		receiver: anObject
		selector: aSymbol
		argumentConstraints: Array new! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
receiver: anObject selector: aSymbol argumentConstraint: aConstraint 
	^(self new)
		receiver: anObject;
		selector: aSymbol;
		argumentConstraints: (Array with: aConstraint)! !

!MessageSemanticsSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
receiver: anObject selector: aSymbol argumentConstraints: anArray 
	^(self new)
		receiver: anObject;
		selector: aSymbol;
		argumentConstraints: anArray! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
argumentConstraints
	^argumentConstraints! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
argumentConstraints: anArray 
	argumentConstraints := anArray! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
receiver
	^receiver! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
receiver: anObject 
	receiver := anObject! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
selector
	^selector! !

!MessageSemanticsSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
selector: aSymbol 
	selector := aSymbol! !

!MessageSemanticsSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validate: aMessageSend 
	| state |
	receiver == aMessageSend receiver 
		ifFalse: 
			[^WrongMessageReceiver for: aMessageSend
				withExpectedReceiver: receiver].
	selector = aMessageSend selector 
		ifFalse: 
			[^WrongMessageSelector for: aMessageSend
				withExpectedSelector: selector].
	argumentConstraints with: aMessageSend arguments
		do: 
			[:myArg :hisArg | 
			state := myArg validate: hisArg.
			state isFailing 
				ifTrue: 
					[^WrongMessageArgument 
						for: aMessageSend
						index: (argumentConstraints indexOf: myArg)
						stateFailing: state]].
	^BehaviorSpecValidationSuccess for: aMessageSend! !

Specification subclass: #MessageUsageSpec
	instanceVariableNames: 'usageCount validatedUsageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs'!

MessageUsageSpec subclass: #LimitedUsageSpec
	instanceVariableNames: 'usageLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs'!

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
singleUsage
	^self withExactUsageCount: 1! !

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
withExactUsageCount: anInteger 
	^self withUsageCountBetween: anInteger and: anInteger! !

!LimitedUsageSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
withUsageCountBetween: min and: max 
	^(self withValidatedUsageLimit: min) usageLimit: max! !

!LimitedUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
usageLimit
	^usageLimit! !

!LimitedUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
usageLimit: anInteger 
	usageLimit := anInteger! !

!LimitedUsageSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: aMessageSend 
	usageCount < usageLimit ifTrue: [^BehaviorSpecValidationSuccess for: aMessageSend].
	^UsageLimitExceeded for: aMessageSend withUsageLimit: validatedUsageLimit! !

!MessageUsageSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
new
	^super new initialize! !

!MessageUsageSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
withValidatedUsageLimit: anInteger 
	^self new validatedUsageLimit: anInteger! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
incrementUsageCount
	usageCount := usageCount + 1! !

!MessageUsageSpec methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:18'!
initialize
	self reset! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
isArbitrary
	^usageCount > 0! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
isUsageSpec
	^true! !

!MessageUsageSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
isValid
	^usageCount >= validatedUsageLimit! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
reset
	usageCount := 0! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
usageCount
	^usageCount! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
usageCount: anInteger 
	usageCount := anInteger! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
validatedUsageLimit
	^validatedUsageLimit! !

!MessageUsageSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
validatedUsageLimit: anInteger 
	validatedUsageLimit := anInteger! !

MessageUsageSpec subclass: #UnlimitedUsageSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-UsageSpecs'!

!UnlimitedUsageSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: aMessageSend 
	^BehaviorSpecValidationSuccess for: aMessageSend! !

!Specification methodsFor: 'validation' stamp: 'dk 16.8.07 17:17'!
validate: aMessageSend 
	self subclassResponsibility! !

Specification subclass: #StateSpec
	instanceVariableNames: 'denial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

StateSpec subclass: #ArbitraryStateSpec
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!ArbitraryStateSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
from: aBlockContext 
	^self new condition: aBlockContext! !

!ArbitraryStateSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^condition value: anObject! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition
	^condition! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
condition: aBlockContext 
	condition := aBlockContext! !

!ArbitraryStateSpec methodsFor: 'accessing' stamp: 'dk 8/20/2007 10:46'!
debugValidationFailingOver: aSpecFailed
	"
	[SSpecDSLAcceptanceTests new customTestForArbitraryBlock] fork
	"
	| mainProcess |
	mainProcess := Processor activeProcess.
	[
	mainProcess 
		completeTo: aSpecFailed signalContext sender sender sender; 
		restartTop;	
		stepToHome: condition asContext;
		debug] forkAt: mainProcess priority.
	mainProcess suspend! !

!ArbitraryStateSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'satisfy: ' , condition stringForSpecValidation! !

StateSpec subclass: #ContainmentSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

ContainmentSpec subclass: #ElementContainmentSpec
	instanceVariableNames: 'requiredElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!ElementContainmentSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredElement: anObject 
	^self new requiredElement: anObject! !

!ElementContainmentSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aCollection 
	^aCollection includes: requiredElement! !

!ElementContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredElement
	^requiredElement! !

!ElementContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredElement: anObject
	requiredElement := anObject! !

!ElementContainmentSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'include ' , requiredElement printString! !

ContainmentSpec subclass: #IndexContainmentSpec
	instanceVariableNames: 'requiredIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!IndexContainmentSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredIndex: anObject 
	^self new requiredIndex: anObject! !

!IndexContainmentSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aCollection 
	^requiredIndex between: 1 and: aCollection size! !

!IndexContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredIndex
	^requiredIndex! !

!IndexContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredIndex: anInteger
	requiredIndex := anInteger! !

!IndexContainmentSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'include index ' , requiredIndex printString! !

ContainmentSpec subclass: #KeyContainmentSpec
	instanceVariableNames: 'requiredKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!KeyContainmentSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredKey: anObject 
	^self new requiredKey: anObject! !

!KeyContainmentSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aCollection 
	^aCollection includesKey: requiredKey! !

!KeyContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredKey
	^requiredKey! !

!KeyContainmentSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredKey: anObject 
	requiredKey := anObject! !

!KeyContainmentSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'include key ' , requiredKey printString! !

StateSpec subclass: #ElementsCountSpec
	instanceVariableNames: 'requiredValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!ElementsCountSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredValue: anInteger 
	^self new requiredValue: anInteger! !

!ElementsCountSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aCollection 
	^aCollection size = requiredValue! !

!ElementsCountSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredValue
	^requiredValue! !

!ElementsCountSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredValue: anInteger 
	requiredValue := anInteger! !

!ElementsCountSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'have ' , requiredValue printString , ' elements'! !

StateSpec subclass: #FloatingComparisonSpec
	instanceVariableNames: 'requiredValue delta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!FloatingComparisonSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredValue: value delta: delta 
	^(self new)
		requiredValue: value;
		delta: delta! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
delta
	^delta! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
delta: accurancy 
	delta := accurancy! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredValue
	^requiredValue! !

!FloatingComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredValue: anNumber 
	requiredValue := anNumber! !

!FloatingComparisonSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'be within ' , delta printString , ' of ' , requiredValue printString! !

FloatingComparisonSpec subclass: #NumberFloatingComparisonSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!NumberFloatingComparisonSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aNumber 
	^(aNumber - requiredValue) abs < delta! !

FloatingComparisonSpec subclass: #PointFloatingComparisonSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!PointFloatingComparisonSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aPoint 
	^(requiredValue dist: aPoint) < delta! !

StateSpec subclass: #ObjectComparisonSpec
	instanceVariableNames: 'pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

ObjectComparisonSpec subclass: #EqualitySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!EqualitySpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^pattern = anObject! !

!EqualitySpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	^'equal'! !

ObjectComparisonSpec subclass: #IdentitySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!IdentitySpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^pattern == anObject! !

!IdentitySpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	^'be'! !

!ObjectComparisonSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
pattern: anObject 
	^self new pattern: anObject! !

!ObjectComparisonSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	self subclassResponsibility! !

!ObjectComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
pattern
	^pattern! !

!ObjectComparisonSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
pattern: anObject 
	pattern := anObject! !

!ObjectComparisonSpec methodsFor: 'displaying' stamp: 'dk 8/17/2007 17:30'!
shouldClausePhrase
	^self clauseKeyword , ' ' , pattern printString! !

StateSpec subclass: #ObjectRelationshipSpec
	instanceVariableNames: 'requiredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

ObjectRelationshipSpec subclass: #ClassSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!ClassSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^anObject class = requiredClass! !

!ClassSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	^'be an instance of'! !

ObjectRelationshipSpec subclass: #HierarchySpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!HierarchySpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^anObject isKindOf: requiredClass! !

!HierarchySpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	^'be a kind of'! !

!ObjectRelationshipSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
for: aClass 
	^self new requiredClass: aClass! !

!ObjectRelationshipSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
clauseKeyword
	self subclassResponsibility! !

!ObjectRelationshipSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredClass
	^requiredClass! !

!ObjectRelationshipSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredClass: aClass 
	requiredClass := aClass! !

!ObjectRelationshipSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^self clauseKeyword , ' ' , requiredClass name! !

StateSpec subclass: #RaisingExeptionSpec
	instanceVariableNames: 'requiredExeption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!RaisingExeptionSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
requiredExeption: anExeption 
	^self new requiredExeption: anExeption! !

!RaisingExeptionSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: aBlockContext 
	^
	[aBlockContext value.
	false] on: requiredExeption
			do: 
				[:ex | 
				ex class = SpecFailed ifTrue: [ex outer].
				ex return: true]! !

!RaisingExeptionSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
requiredExeption: anExeption 
	requiredExeption := anExeption! !

!RaisingExeptionSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'raise ' , requiredExeption name! !

StateSpec subclass: #ResponsibilitySpec
	instanceVariableNames: 'messageSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-StateSpecs'!

!ResponsibilitySpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
for: aSelector 
	^self new messageSelector: aSelector! !

!ResponsibilitySpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	^anObject respondsTo: messageSelector! !

!ResponsibilitySpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
messageSelector
	^messageSelector! !

!ResponsibilitySpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
messageSelector: aSymbol 
	messageSelector := aSymbol! !

!ResponsibilitySpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	^'respond to ' , messageSelector printString! !

!StateSpec class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:18'!
new
	^super new initialize! !

!StateSpec methodsFor: 'converting' stamp: 'dk 16.8.07 17:18'!
asStateSpec
	^self! !

!StateSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
basicMatches: anObject 
	self subclassResponsibility! !

!StateSpec methodsFor: 'accessing' stamp: 'dk 8/17/2007 18:38'!
debugValidationFailingOver: aSpecFailed
	UnhandledError signalForException: aSpecFailed! !

!StateSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial
	^denial! !

!StateSpec methodsFor: 'accessing' stamp: 'dk 16.8.07 17:18'!
denial: aBoolean 
	denial := aBoolean! !

!StateSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
description
	^self shouldPrefixPhrase , ' ', self shouldClausePhrase! !

!StateSpec methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:18'!
initialize
	denial := false! !

!StateSpec methodsFor: 'testing' stamp: 'dk 16.8.07 17:18'!
matches: anObject 
	^(self basicMatches: anObject) ~= denial! !

!StateSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldClausePhrase
	self subclassResponsibility! !

!StateSpec methodsFor: 'displaying' stamp: 'dk 16.8.07 17:18'!
shouldPrefixPhrase
	^'should' , (denial ifTrue: [' not'] ifFalse: [''])! !

!StateSpec methodsFor: 'validation' stamp: 'dk 16.8.07 17:18'!
validate: anObject 
	(self matches: anObject) ifTrue: [^StateValidationSuccess new].
	^StateValidationFailing spec: self for: anObject! !

Object subclass: #SpecificationHandler
	instanceVariableNames: 'spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

SpecificationHandler subclass: #BehaviorSpecHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

BehaviorSpecHandler subclass: #BehaviorSpecBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!BehaviorSpecBuilder methodsFor: 'evaluation' stamp: 'rkrk 9/26/2007 13:36'!
evaluateMessageSend: aMessageSend 
	| messageSendSpec |
	messageSendSpec := aMessageSend selector = #ignoreMessages
		ifTrue: [MessageSendSpec new add: 
			(IgnoreMessageSemanticsSpec receiver: aMessageSend receiver)]
		ifFalse: [MessageSendSpec withMessageSemanticsLike: aMessageSend.].
	"messageSendSpec := MessageSendSpec withMessageSemanticsLike: aMessageSend."
	spec add: messageSendSpec.
	^MessageSendSpecBuilder on: messageSendSpec! !

!BehaviorSpecHandler methodsFor: 'evaluation' stamp: 'dk 16.8.07 17:17'!
evaluateMessageSend: aMessageSend
	self subclassResponsibility! !

BehaviorSpecHandler subclass: #MessageSendValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!MessageSendValidator methodsFor: 'evaluation' stamp: 'dk 16.8.07 17:17'!
evaluateMessageSend: aMessageSend 
	^(spec validate: aMessageSend) raise! !

SpecificationHandler subclass: #MessageSendSpecBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!MessageSendSpecBuilder methodsFor: 'context specs definition' stamp: 'dk 16.8.07 17:18'!
shouldBeAsynchronous
	spec add: AsynchronousCallSpec forCurrentProcess! !

!MessageSendSpecBuilder methodsFor: 'context specs definition' stamp: 'dk 16.8.07 17:18'!
shouldSatisfy: aBlockContext 
	spec add: (ConditionSpec from: aBlockContext)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useArbitrarily
	spec usageSpec beArbitrary! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useAtLeast: anInteger 
	spec addUsageSpec: (UnlimitedUsageSpec withValidatedUsageLimit: anInteger)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useAtLeast: min atMost: max 
	spec addUsageSpec: (LimitedUsageSpec withUsageCountBetween: min and: max)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useAtMost: anInteger 
	self useAtLeast: 1 atMost: anInteger! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useExactly: anInteger 
	spec addUsageSpec: (LimitedUsageSpec withExactUsageCount: anInteger)! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useOnce
	self useExactly: 1! !

!MessageSendSpecBuilder methodsFor: 'usage spec definition' stamp: 'dk 16.8.07 17:18'!
useTwice
	self useExactly: 2! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dk 16.8.07 17:19'!
will: anObject 
	spec addAction: anObject asMockAction! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dk 16.8.07 17:19'!
willRaise: anExeptionClass 
	self will: (RaisingExeption of: anExeptionClass)! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dk 16.8.07 17:19'!
willReturn: anObject 
	self will: (ReturnValue of: anObject)! !

!MessageSendSpecBuilder methodsFor: 'actions definition' stamp: 'dk 16.8.07 17:19'!
willReturnYourself
	self will: ReturnReceiver new! !

!SpecificationHandler class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:17'!
on: aSpec 
	^self new spec: aSpec! !

!SpecificationHandler methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
spec
	^spec! !

!SpecificationHandler methodsFor: 'accessing' stamp: 'dk 16.8.07 17:17'!
spec: aSpec 
	spec := aSpec! !

Object subclass: #Validator
	instanceVariableNames: 'subject neededNegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

Validator subclass: #BehaviorValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!BehaviorValidator methodsFor: 'should clause' stamp: 'dk 16.8.07 17:19'!
lenient
	^ShouldLenientClause of: self! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
lenientSatisfy: specDefinitionBlock 
	self satisfySpec: LenientBehaviorSpec definedBy: specDefinitionBlock! !

!BehaviorValidator methodsFor: 'should clause' stamp: 'dk 16.8.07 17:19'!
raise
	^ShouldRaiseClause of: self! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raise: anExeptionClass 
	| spec |
	spec := RaisingExeptionSpec requiredExeption: anExeptionClass.
	spec denial: neededNegate.
	(spec validate: subject) raise! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raise: anExeptionClass andLenientSatisfy: specDefinitionBlock 
	self 
		satisfySpec: LenientBehaviorSpec
		definedBy: specDefinitionBlock
		whenBehaviorShouldRaise: anExeptionClass! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raise: anExeptionClass andSatisfy: aBehaviorSpec 
	aBehaviorSpec validateBehavior: subject thatShouldRaise: anExeptionClass! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raise: anExeptionClass andStrictlySatisfy: specDefinitionBlock 
	self 
		satisfySpec: StrictBehaviorSpec
		definedBy: specDefinitionBlock
		whenBehaviorShouldRaise: anExeptionClass! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raiseAndLenientSatisfy: specDefinitionBlock 
	self 
		satisfySpec: LenientBehaviorSpec
		definedBy: specDefinitionBlock
		whenBehaviorShouldRaise: Error! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raiseAndSatisfy: aBehaviorSpec 
	self raise: Error andSatisfy: aBehaviorSpec! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raiseAndStrictlySatisfy: specDefinitionBlock 
	self 
		satisfySpec: StrictBehaviorSpec
		definedBy: specDefinitionBlock
		whenBehaviorShouldRaise: Error! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
raiseError
	self raise: Error! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
satisfy: aBehaviorSpec 
	neededNegate ifTrue: [self error: 'BehaviorSpec can''t be negated'].
	aBehaviorSpec validateBehavior: subject! !

!BehaviorValidator methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
satisfySpec: aBehaviorSpecClass definedBy: specDefinitionBlock 
	(aBehaviorSpecClass definedBy: specDefinitionBlock) 
		validateWorldBehavior: subject! !

!BehaviorValidator methodsFor: 'private' stamp: 'dk 16.8.07 17:19'!
satisfySpec: aBehaviorSpecClass definedBy: specDefinitionBlock whenBehaviorShouldRaise: anExeptionClass 
	(aBehaviorSpecClass definedBy: specDefinitionBlock) 
		validateWorldBehavior: subject
		thatShouldRaise: anExeptionClass! !

!BehaviorValidator methodsFor: 'should clause' stamp: 'dk 16.8.07 17:19'!
strictly
	^ShouldStrictlyClause of: self! !

!BehaviorValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
strictlySatisfy: specDefinitionBlock 
	self satisfySpec: StrictBehaviorSpec definedBy: specDefinitionBlock! !

Validator subclass: #StateValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-SSpecDSL'!

!StateValidator methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
a
	^self! !

!StateValidator methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
an
	^self! !

!StateValidator methodsFor: 'helper words' stamp: 'dk 16.8.07 17:19'!
be
	^self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
be: anObject 
	self satisfySpecFrom: [subject specOfIdentityFor: anObject]! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
equal: anObject 
	self satisfySpecFrom: [subject specOfEqualityFor: anObject]! !

!StateValidator methodsFor: 'should clauses' stamp: 'dk 16.8.07 17:19'!
have
	^ShouldHaveClause of: self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
haveSize: anInteger 
	self satisfySpecFrom: [subject specOfElementsCount: anInteger]! !

!StateValidator methodsFor: 'should clauses' stamp: 'dk 16.8.07 17:19'!
include
	^ShouldIncludeClause of: self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
include: anObject 
	self satisfySpecFrom: [subject specOfElementContainment: anObject]! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
includeKey: anObject 
	self satisfySpecFrom: [subject specOfKeyContainment: anObject]! !

!StateValidator methodsFor: 'should clauses' stamp: 'dk 16.8.07 17:19'!
instance
	^ShouldInstanceClause of: self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
instanceOf: aClass 
	self satisfySpecFrom: [subject specOfClass: aClass]! !

!StateValidator methodsFor: 'should clauses' stamp: 'dk 16.8.07 17:19'!
kind
	^ShouldKindClause of: self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
kindOf: aClass 
	self satisfySpecFrom: [subject specOfHierarchy: aClass]! !

!StateValidator methodsFor: 'should clauses' stamp: 'dk 16.8.07 17:19'!
respond
	^ShouldRespondClause of: self! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
respondTo: aSelector 
	self satisfySpecFrom: [subject specOfResponsibilityFor: aSelector]! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
satisfy: aStateSpecOrBlockContext 
	(aStateSpecOrBlockContext asStateSpec validate: subject) raise! !

!StateValidator methodsFor: 'private specs' stamp: 'dk 16.8.07 17:19'!
satisfySpecFrom: aBlock 
	| spec |
	spec := aBlock value.
	spec denial: neededNegate.
	self satisfy: spec! !

!StateValidator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
within: delta of: value 
	self 
		satisfySpecFrom: [subject specOfFloatingComparisonWith: value delta: delta]! !

!Validator class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
for: anObject 
	^self new subject: anObject! !

!Validator class methodsFor: 'instance creation' stamp: 'dk 16.8.07 17:19'!
new
	^super new initialize! !

!Validator methodsFor: 'initialize-release' stamp: 'dk 16.8.07 17:19'!
initialize
	neededNegate := false! !

!Validator methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
neededNegate
	^neededNegate! !

!Validator methodsFor: 'specs' stamp: 'dk 16.8.07 17:19'!
not
	neededNegate := neededNegate not! !

!Validator methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
subject
	^subject! !

!Validator methodsFor: 'accessing' stamp: 'dk 16.8.07 17:19'!
subject: anObject 
	subject := anObject! !

!Number methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfFloatingComparisonWith: value delta: delta 
	^NumberFloatingComparisonSpec requiredValue: value delta: delta! !

!Dictionary methodsFor: '*BehaviorMockup-StateSpecs-specs' stamp: 'dk 16.8.07 17:18'!
specOfKeyContainment: anObject 
	^KeyContainmentSpec requiredKey: anObject! !

!BlockNode methodsFor: '*BehaviorMockup-Core-accessing' stamp: 'dik 9/3/2007 17:26'!
arguments
	^arguments! !

Error subclass: #SpecFailed
	instanceVariableNames: 'reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BehaviorMockup-Core'!

!SpecFailed class methodsFor: 'instance creation' stamp: 'dk 8/17/2007 17:53'!
raiseWith: aValidationFailing 
	(self withReason: aValidationFailing) signal! !

!SpecFailed class methodsFor: 'instance creation' stamp: 'dk 8/17/2007 17:53'!
withReason: aValidationFailing 
	^self new reason: aValidationFailing! !

!SpecFailed methodsFor: 'private - actions' stamp: 'dk 8/17/2007 18:12'!
defaultAction
	^reason debugSpecOver: self! !

!SpecFailed methodsFor: 'displaying' stamp: 'dk 8/17/2007 16:24'!
description
	^ self class name , ': ' , reason description! !

!SpecFailed methodsFor: 'accessing' stamp: 'dk 8/17/2007 16:24'!
reason
	^ reason! !

!SpecFailed methodsFor: 'accessing' stamp: 'dk 8/17/2007 16:24'!
reason: anObject
	reason := anObject! !

!SpecFailed methodsFor: 'private - accessing' stamp: 'dk 8/17/2007 18:46'!
signalContext
	^signalContext! !
